/**
 * 公共常量池，使用Const("YOUR_CONST_KEY")获取常量
 * @param key 常量名称
 * @returns {*} 常量值
 * @constructor
 */
var Const = function(key){
    var constants = {
        //面包屑导航最大显示数量
        NAVI_COUNT: 6,
        //数字0
        NUM_ZERO: 0,
        //mongodb保存已完成数据数量
        NUM_MONGODB_TASKS: 200000,
        //每次从数据库抓取的数据条数
        NUM_MONGODB_LIMITS: 1000,
        //每次清理的最大条数
        NUM_CLEAR_NUM: 100000,
        //查询恢复任务状态间隔时间，单位ms
        NUM_RECOVER_QUERY_TIMES: 300000,
        //对象列表中，恢复状态列的id后缀
        RESTORE_STATUS_SUFFIX: "_restore_stat",
        //已完成列表中，如果超过一定数据，处于性能考虑则不再提供排序
        COMPLETED_TASK_NOT_SORT_NUM: 30000,
        //分享对象的最长时间30天,单位m，
        MAX_EXPIRE_TIME_OF_SHARE: 30 * 24 * 60
    }
    return constants[key];
}

module.exports = Const;


