
'use strict';

const crypto = require('crypto');

const aesutil = {};
const clearEncoding = 'utf8';
const cipherEncoding = 'base64';
const encryptCipher = 'aes-256-ctr';

aesutil.encryptSync = (data, key, iv) => {
    iv = iv || '';

    var cipherChunks = [];
    var cipher = crypto.createCipheriv(encryptCipher, key, iv);
    cipher.setAutoPadding(true);
    cipherChunks.push(cipher.update(data, clearEncoding, cipherEncoding));
    cipherChunks.push(cipher.final(cipherEncoding));
    return cipherChunks.join('');
};

aesutil.decryptSync = (data, key, iv) =>{
    if (!data) {
        return '';
    }
    iv = iv || '';
    var cipherChunks = [];
    var decipher = crypto.createDecipheriv(encryptCipher, key, iv);
    decipher.setAutoPadding(true);
    cipherChunks.push(decipher.update(data, cipherEncoding, clearEncoding));
    cipherChunks.push(decipher.final(clearEncoding));
    return cipherChunks.join('');
};

module.exports = aesutil;

