var AWS = require('hws-sdk');
var base64 = require('../base64');
var proxyagent = require('proxy-agent');
var https = require('https');
var http = require('http');
function indexAction(){
    this.maxRetries=2;
    this.timeOut = 50000;
}

/**
 *api proxy 需要的常量
 */
const SERVER_READY_STATUS = 4;
const SERVER_RESPONSE_CODE_SUCCESS = 200;
const CLOUD_TYPE_HW = 2;
const CLOUD_TYPE_PARNTER = 1;
global.cloudType = CLOUD_TYPE_HW;

/**
 *23小时更新一次临时ak/sk/ststoken
 */
setInterval(function () {
    if (global.cloudType === CLOUD_TYPE_PARNTER) {
        let resp_retry = 0;
        while (resp_retry < 3) {
            let post_data = {
                ak: global.accessKeyId,
                sk: global.secretAccessKey,
                endpoint: "obs.eu-west-0.myhuaweicloud.com"
            };
            post_data = JSON.stringify(post_data);
            try {
                let xhr = new XMLHttpRequest();
                xhr.withCredentials = false;
                let url = global.apiProxyAddress + "/obsproxy/tokens";
                xhr.open("POST", url, false);
                xhr.onreadystatechange = function () {
                    if (xhr.readyState === SERVER_READY_STATUS) {
                        if (xhr.status === SERVER_RESPONSE_CODE_SUCCESS) {
                            let res = JSON.parse(xhr.responseText);
                            if (res != null) {
                                if (res["response_code"] !== CLOUD_TYPE_HW) {
                                    if(res["access"] != null){
										global.tempAccessKeyId = res["access"];
									}
                                    if(res["secret"] != null){
									   global.tempSecretAccessKey = res["secret"];
									}
                                    if(res["securitytoken"] != null){
									 global.tempSessionToken = res["securitytoken"];	
									}
                                    resp_retry = 3;
                                }
                            }
                        } else {
                            resp_retry += 1;
                        }
                    }
                };
                xhr.send(post_data);
            } catch (error) {
                resp_retry += 1;
                logger.error("get temp ak/sk failed,the reason is:" + error);
            }
        }
    }
}, 82800001);
/*
初始化S3配置
 */
indexAction.prototype.initS3 = function (option) {
    if (AWS.config.sessionToken) {
        delete AWS.config.sessionToken;
    }
    if (global.tempAccessKeyId) {
        delete global.tempAccessKeyId;
    }
    if (global.tempSecretAccessKey) {
        delete global.tempSecretAccessKey;
    }
    if (global.tempSessionToken) {
        delete global.tempSessionToken;
    }
    global.cloudType = CLOUD_TYPE_HW;
    AWS.config.accessKeyId = option.accessKey;
    AWS.config.secretAccessKey = option.secretKey;
    //新增两个全局变量
    global.accessKeyId = option.accessKey[0];
    global.secretAccessKey = option.secretKey;
    //新逻辑
    let s3 = this.getS3(option);
    return s3;
};
indexAction.prototype.getS3 = function (option) {

    var tag = false;
    for (var item in global.partnerClouds) {
        if (option.endpoint[0].indexOf(item) > 0) {
            tag = true;
        }
    }
    let index = this;
    if (tag === true) {
        try {
            let post_data = {
                ak: option.accessKey[0],
                sk: option.secretKey,
                endpoint: option.endpoint[0]
            };
            post_data = JSON.stringify(post_data);
            let retry_time = 0;
            while (retry_time < 3) {
                let xhr = new XMLHttpRequest();
                xhr.withCredentials = false;
                let url = global.apiProxyAddress + "/obsproxy/tokens";
                xhr.open("POST", url, false);
                xhr.onreadystatechange = function () {
                    if (xhr.readyState === SERVER_READY_STATUS) {
                        if (xhr.status === SERVER_RESPONSE_CODE_SUCCESS) {
                            let res = JSON.parse(xhr.responseText);
                            if (res != null) {
                                if (res["response_code"] !== CLOUD_TYPE_HW) {
                                   if(res["access"] != null){
										AWS.config.accessKeyId[0] = res["access"];
										global.tempAccessKeyId = res["access"];
									}
                                    if(res["secret"] != null){
									   AWS.config.secretAccessKey = res["secret"];	
									   global.tempSecretAccessKey = res["secret"];
									}
                                    if(res["securitytoken"] != null){
									 AWS.config.sessionToken = res["securitytoken"];
									 global.tempSessionToken = res["securitytoken"];	
									}
                                    //新增三个全局变量
                                    option.endpoint[0] = res["endpoint"];
                                    global.cloudType = CLOUD_TYPE_PARNTER;
                                    retry_time = 3;
                                }
                            }
                        } else {
                            retry_time += 1;
                        }
                    }
                };
                xhr.send(post_data);
            }
        } catch (error) {
            logger.error("get temp ak/sk failed,the reason is:" + error);
        }
    }
    return index.commonOperation(option);
};
indexAction.prototype.commonOperation = function (option) {
    let endpoint = option.endpoint[0];
    if (option.isHttps && option.isHttps === 'N') {
        AWS.config.endpoint = "http://" + option.endpoint;
    } else {
        AWS.config.endpoint = "https://" + option.endpoint;
    }
    AWS.config['region'] = '';
    AWS.config['signatureVersion'] = 's3';
    AWS.config['s3ForcePathStyle'] = false;
    var data = endpoint.split(':');
    if(data&&data.length>0){
        var re =  /^([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])$/;
        if(re.test(data[0])){
            AWS.config['s3ForcePathStyle'] = true;
        }
    }

    //加载region信息，V4鉴权必须
    if (option.defaultRegion)
    {
        AWS.config.region = option.defaultRegion;
    }
    //加载鉴权版本
    if (option.signatureVersion)
    {
        AWS.config.signatureVersion = option.signatureVersion;
    }
    s3 = new AWS.S3();
    this.updateS3(s3,option);
    return s3;
}

/*
 修改S3配置
 */
indexAction.prototype.updateS3= function(s3,option){
    var self = this;
    var proxyConfig = false;
    var isSSL = false;
    var point = false;
    if(option.isMD5check){
        global.isMD5check = option.isMD5check
    }
    if(option.proxy){
        point = 'http://';
        if(option.proxy.isAuthentication){
            point = point+encodeURIComponent(option.proxy.proxyUserName)+':'+encodeURIComponent(option.proxy.proxyPwd)+'@';
        }
        if(option.proxy.isProxy){
            if(option.proxy.proxyPort){
                point = point+option.proxy.proxyIP+':'+option.proxy.proxyPort;
            }else{
                point = point+option.proxy.proxyIP+':8080';
            }
            proxyagent.cache.reset();
            proxyConfig = proxyagent(point);
        }
    }
    if(proxyConfig){
        global.agentOption = point;
    }else{
        global.agentOption = false;
    }
    if(option.isSSL == "Y"){
        isSSL = true;
    }
    require("../access/iam/IAMConnector").loadAgent(proxyConfig);

    if(s3){
        var agent = null;
        if (option.isHttps && option.isHttps === 'N') {
            agent = new http.Agent({
                keepAlive: true
            });
        } else {
            agent = new https.Agent({
                keepAlive: true
            });
        }

        s3.config.update({
            //请求失败后最多重试次数
            maxRetries: self.maxRetries,
            httpOptions: {
                //HTTP请求超时时间，50s
                timeout: self.timeOut,
                //默认支持HTTPS，接受自签名证书
                rejectUnauthorized: isSSL,
                agent: proxyConfig || agent
            }
        });
    }
    return s3;
};

/*
 获取系统错误提示信息配置
 */
indexAction.prototype.initErrorConfig = function (errorConfig,languageJson) {
    errorConfig.InvalidObjectState = languageJson.ERR_CODE_InvalidObjectState;
    errorConfig.InternalError = languageJson.InternalError;
    errorConfig.AccessDenied = languageJson.AccessDenied;
    errorConfig.AmbiguousGrantByEmailAddress = languageJson.AmbiguousGrantByEmailAddress;
    errorConfig.AccountProblem = languageJson.AccountProblem;
    errorConfig.BadDigest = languageJson.BadDigest;
    errorConfig.InvalidAccessKeyId = languageJson.InvalidAccessKeyId;
    errorConfig.InvalidAddressingHeader = languageJson.InvalidAddressingHeader;
    errorConfig.InvalidArgument = languageJson.InvalidArgument;
    errorConfig.InvalidBucketName = languageJson.InvalidBucketName;
    errorConfig.InvalidDigest = languageJson.InvalidDigest;
    errorConfig.InvalidLocationConstraint = languageJson.InvalidLocationConstraint;
    errorConfig.InvalidPart =languageJson.InvalidPart;
    errorConfig.InvalidPartOrder = languageJson.InvalidPartOrder;
    errorConfig.InvalidPayer = languageJson.InvalidPayer;
    errorConfig.InvalidPolicyDocument = languageJson.InvalidPolicyDocument;
    errorConfig.InvalidRange = languageJson.InvalidRange;
    errorConfig.InvalidRedirectLocation = languageJson.InvalidRedirectLocation;
    errorConfig.InvalidRequest = languageJson.InvalidRequest;
    errorConfig.InvalidSecurity = languageJson.InvalidSecurity;
    errorConfig.InvalidStorageClass = languageJson.InvalidStorageClass;
    errorConfig.InvalidURI = languageJson.InvalidURI;
    errorConfig.KeyTooLong = languageJson.KeyTooLong;
    errorConfig.MalformedACLError = languageJson.MalformedACLError;
    errorConfig.MalformedPOSTRequest = languageJson.MalformedPOSTRequest;
    errorConfig.MalformedXML = languageJson.MalformedXML;
    errorConfig.MaxMessageLengthExceeded = languageJson.MaxMessageLengthExceeded;
    errorConfig.MaxPostPreDataLengthExceededError = languageJson.MaxPostPreDataLengthExceededError;
    errorConfig.MetadataTooLarge = languageJson.MetadataTooLarge;
    errorConfig.MethodNotAllowed = languageJson.MethodNotAllowed;
    errorConfig.MissingContentLength = languageJson.MissingContentLength;
    errorConfig.MissingRequestBodyError = languageJson.MissingRequestBodyError;
    errorConfig.MissingSecurityHeader = languageJson.MissingSecurityHeader;
    errorConfig.NoSuchBucket = languageJson.NoSuchBucket;
    errorConfig.NoSuchKey = languageJson.NoSuchKey;
    errorConfig.NoSuchUpload = languageJson.NoSuchUpload;
    errorConfig.NoSuchVersion = languageJson.NoSuchVersion;
    errorConfig.NotImplemented = languageJson.NotImplemented;
    errorConfig.NotSignedUp = languageJson.NotSignedUp;
    errorConfig.NotSuchBucketPolicy = languageJson.NotSuchBucketPolicy;
    errorConfig.OperationAborted =languageJson.OperationAborted;
    errorConfig.PermanentRedirect =languageJson.PermanentRedirect;
    errorConfig.PreconditionFailed = languageJson.PreconditionFailed;
    errorConfig.Redirect = languageJson.Redirect;
    errorConfig.RequestIsNotMultiPartContent = languageJson.RequestIsNotMultiPartContent;
    errorConfig.RequestTimeout = languageJson.RequestTimeout;
    errorConfig.RequestTimeTooSkewed = languageJson.RequestTimeTooSkewed;
    errorConfig.RequestTorrentOfBucketError = languageJson.RequestTorrentOfBucketError;
    errorConfig.SignatureDoesNotMatch = languageJson.SignatureDoesNotMatch;
    errorConfig.SlowDown = languageJson.SlowDown;
    errorConfig.TemporaryRedirect = languageJson.TemporaryRedirect;
    errorConfig.TooManyBuckets =  languageJson.TooManyBuckets;
    errorConfig.UnexpectedContent =  languageJson.UnexpectedContent;
    errorConfig.UnresolvableGrantByEmailAddress =  languageJson.UnresolvableGrantByEmailAddress;
    errorConfig.UserKeyMustBeSpecified =  languageJson.UserKeyMustBeSpecified;
    errorConfig.NetworkingError =  languageJson.NetworkingError;
    errorConfig.NetworkingError1 =  languageJson.NetworkingError1;
    errorConfig.InvalidTargetBucketForLogging = languageJson.InvalidTargetBucketForLogging;
    errorConfig.InvalidTargetBucketForLogging1 = languageJson.InvalidTargetBucketForLogging1;
    errorConfig.UnknownEndpoint = languageJson.UnknownEndpoint;
    errorConfig.BucketNotEmpty = languageJson.BucketNotEmpty;
    errorConfig.MalformedPolicy = languageJson.MalformedPolicy;
    errorConfig.BucketAlreadyExists = languageJson.BucketAlreadyExists;
    errorConfig.BucketAlreadyOwnedByYou = languageJson.BucketAlreadyOwnedByYou;
    errorConfig.CredentialsNotSupported = languageJson.CredentialsNotSupported;
    errorConfig.EntityTooSmall = languageJson.EntityTooSmall;
    errorConfig.EntityTooLarge = languageJson.EntityTooLarge;
    errorConfig.IncompleteBody = languageJson.IncompleteBody;
    errorConfig.IncorrectNumberOfFilesInPostRequest = languageJson.IncorrectNumberOfFilesInPostRequest;
    errorConfig.InlineDataTooLarge = languageJson.InlineDataTooLarge;
    errorConfig.MissingRequiredParameter = languageJson.MissingRequiredParameter;
    errorConfig.FileCoverFaild = languageJson.FileCoverFaild;
    errorConfig.InArrearOrInsufficientBalance = languageJson.InArrearOrInsufficientBalance;
    errorConfig.TooManyWrongSignature = languageJson.ERR_CODE_TooManyWrongSignature;
    errorConfig.deleteFail = languageJson.deleteFail;
    errorConfig.undefinedError = languageJson.undefinedError;
    errorConfig.ENOENT4058 = languageJson.ENOENT4058;
    errorConfig.RegionNameNotMatch = languageJson.RegionNameNotMatch;
    errorConfig.KeyTooLongError = languageJson.KeyTooLongError;
    errorConfig.NoSuchFile = languageJson.NoSuchFile;
    errorConfig.XMLParserError=languageJson.XMLParserError;
    errorConfig.EBADF=languageJson.EBADF;
    errorConfig.ENOSPC=languageJson.ENOSPC;
    errorConfig.EBUSY=languageJson.EBUSY;
    errorConfig["Serveice Unavailable"]=languageJson["Serveice Unavailable"];
    errorConfig["500"]=languageJson["500"];
    errorConfig["501"]=languageJson["501"];
    errorConfig["503"]=languageJson["503"];
    errorConfig["add_account_user_valid"]=languageJson["add_account_user_valid"];
    errorConfig.DeregisterUserId=languageJson.DeregisterUserId;
    errorConfig.EPERM=languageJson.EPERM;
    errorConfig.EISDIR=languageJson.EISDIR;
    errorConfig.someObjectDownErr=languageJson.someObjectDownErr;
    errorConfig.someObjectDelErr=languageJson.someObjectDelErr;
    errorConfig.ProxyError=languageJson.ProxyError;
    errorConfig["302"]=languageJson["302"];
    errorConfig["407"]=languageJson["407"];
    errorConfig["304"]=languageJson["304"];
    errorConfig["305"]=languageJson["305"];
    errorConfig["400"]=languageJson["400"];
    errorConfig["401"]=languageJson["401"];
    errorConfig["404"]=languageJson["404"];
    errorConfig["415"]=languageJson["415"];
    errorConfig["502"]=languageJson["502"];
    errorConfig["CDN.0000"]=languageJson["CDN.0000"];
    errorConfig["CDN.0001"]=languageJson["CDN.0001"];
    errorConfig["CDN.0002"]=languageJson["CDN.0002"];
    errorConfig["CDN.0003"]=languageJson["CDN.0003"];
    errorConfig["CDN.0004"]=languageJson["CDN.0004"];
    errorConfig["CDN.0005"]=languageJson["CDN.0005"];
    errorConfig["CDN.0101"]=languageJson["CDN.0101"];
    errorConfig["CDN.0102"]=languageJson["CDN.0102"];
    errorConfig["CDN.0103"]=languageJson["CDN.0103"];
    errorConfig["CDN.0104"]=languageJson["CDN.0104"];
    errorConfig["CDN.0105"]=languageJson["CDN.0105"];
    errorConfig["CDN.0106"]=languageJson["CDN.0106"];
    errorConfig["CDN.0107"]=languageJson["CDN.0107"];
    errorConfig["CDN.0108"]=languageJson["CDN.0108"];
    errorConfig["CDN.0109"]=languageJson["CDN.0109"];
    errorConfig["CDN.0110"]=languageJson["CDN.0110"];
    errorConfig["CDN.0114"]=languageJson["CDN.0114"];
    errorConfig["CDN.0115"]=languageJson["CDN.0115"];
    errorConfig["CDN.0116"]=languageJson["CDN.0116"];
    errorConfig["CDN.0117"]=languageJson["CDN.0117"];
    errorConfig["CDN.0120"]=languageJson["CDN.0120"];
    errorConfig["CDN.0121"]=languageJson["CDN.0121"];
    errorConfig["CDN.0126"]=languageJson["CDN.0126"];
    errorConfig["CDN.0127"]=languageJson["CDN.0127"];
    errorConfig["CDN.0128"]=languageJson["CDN.0128"];
    errorConfig["CDN.0129"]=languageJson["CDN.0129"];
    errorConfig["CDN.0130"]=languageJson["CDN.0130"];
    errorConfig["CDN.0131"]=languageJson["CDN.0131"];
    errorConfig["CDN.0133"]=languageJson["CDN.0133"];
    errorConfig["CDN.0134"]=languageJson["CDN.0134"];
    errorConfig["CDN.0135"]=languageJson["CDN.0135"];
    errorConfig["CDN.0136"]=languageJson["CDN.0136"];
    errorConfig["CDN.0137"]=languageJson["CDN.0137"];
    errorConfig["CDN.0138"]=languageJson["CDN.0138"];
    errorConfig["CDN.0139"]=languageJson["CDN.0139"];
    errorConfig["CDN.0141"]=languageJson["CDN.0141"];
    errorConfig["CDN.0201"]=languageJson["CDN.0201"];
    errorConfig["CDN.0202"]=languageJson["CDN.0202"];
    errorConfig["CDN.0203"]=languageJson["CDN.0203"];
    errorConfig["CDN.0406"]=languageJson["CDN.0406"];
    errorConfig["CDN.0407"]=languageJson["CDN.0407"];
    errorConfig["CDN.0408"]=languageJson["CDN.0408"];
    errorConfig["CDN.0409"]=languageJson["CDN.0409"];
    errorConfig["CDN.0410"]=languageJson["CDN.0410"];
    errorConfig["CDN.0411"]=languageJson["CDN.0411"];
    errorConfig["CDN.0412"]=languageJson["CDN.0412"];
    errorConfig["CDN.0413"]=languageJson["CDN.0413"];
    errorConfig["CDN.0414"]=languageJson["CDN.0414"];
    errorConfig.AllAccessDisabled = languageJson.AllAccessDisabled;
    errorConfig.InvalidTargetBucketForLoggingRegion = languageJson.InvalidTargetBucketForLoggingRegion;
    errorConfig.AuthorizationHeaderMalformed = languageJson.AuthorizationHeaderMalformed;
    errorConfig.IllegalLocationConstraintException = languageJson.IllegalLocationConstraintException;
    errorConfig.ENOENT = languageJson.ENOENT;
    errorConfig.ServiceUnavailable = languageJson.ServiceUnavailable;
    errorConfig.isUpdateHasRunning = languageJson.isUpdateHasRunning;
    errorConfig.inputAccountNameIsRepet = languageJson.inputAccountNameIsRepet;
    errorConfig.searchPrefixTooLong = languageJson.ERR_CODE_searchPrefixTooLong;
    errorConfig.ObjectHasAlreadyRestored = languageJson.ObjectHasAlreadyRestored;
    errorConfig.RestoreAlreadyInProgress = languageJson.ERR_CODE_RestoreAlreadyInProgress;
    errorConfig.Forbidden = languageJson.ERR_CODE_Forbidden;
    errorConfig.NotFound = languageJson.ERR_CODE_NoSuchBucket;
    errorConfig.FsNotSupport = languageJson.ERR_CODE_FsNotSupport;
    return errorConfig;
};

/*
 获取桶区域信息
 */
indexAction.prototype.getBucketRegion = function (pkg,callback) {
    if (!window.require) {
        if (callback) {
            callback({});
        }
        return;
    }
    var fs = require("fs");
    var path = require('path');
    var userPath = path.dirname(process.execPath);
    var filePath = path.normalize(userPath + "/region");
    try{
        fs.exists(filePath, function (exists) {
            if (exists) {
                fs.readFile(filePath, "utf-8", function (err, data) {
                    if(callback){
                        callback(err, data);
                    }
                });
            }else{
                if(callback){
                    callback('region is not found!');
                }
            }
        });
    }catch(err){
        console.error(err);
    }
};

indexAction.prototype.loadingBasicSetting = function (pkg,callback) {
    global.logger.info("loadingBasicSetting execute start!")
    if (!window.require) {
        if (callback) {
            callback({});
        }
        return;
    }
    var fs = require("fs");
    var path = require('path');
    var userPath = path.dirname(process.execPath);
    var filePath = path.normalize(userPath + "/setting");
    try{
        fs.exists(filePath, function (exists) {
            if (exists) {
                fs.readFile(filePath, "utf-8", function (err, data) {
                    if(callback){
                        callback(err, data);
                    }
                });
            }else{
                if(callback){
                    global.logger.warn("Not found:"+filePath+", execute callback.")
                    callback();
                }
            }
        });
    }catch(err){
        global.logger.error(err);
        callback(err);
    }
};

indexAction.prototype.loadSetting = function(cb) {
    readSysConfig(function (obj) {
        if (cb) {
            cb(obj);
        }
    });
};

indexAction.prototype.loadExtBucket = function(cb,path) {
    readExtBucket(function (obj) {
        if (cb) {
            cb(obj);
        }
    },path);
};

indexAction.prototype.loadFavouritePath = function(cb,path) {
    readFavouritePath(function (obj) {
        if (cb) {
            cb(obj);
        }
    },path);
};

indexAction.prototype.compareTwoTime =function(times){
    var date1=new Date(times);
    var date2 = new Date();
    date2 = new Date(date2.getTime()-rubbishDays*24*60*60*1000);
    return date1<date2;
}

//格式化文件大小
indexAction.prototype.getFileSize = function(size,type,language) {
    if(size){
        if (size < 1024) {
            size = this.formatNumber(size,language,true) + " byte";
        } else if (size < 1024 * 1024) {
            size = this.formatNumber(Math.floor(size / 1024 * 1000) /1000.000,language) + " KB";
        } else if (size < 1024 * 1024 * 901) {
            size = this.formatNumber(Math.floor(size / (1024 * 1024) * 1000) /1000.000,language) + " MB";
        } else {
            size = this.formatNumber(Math.floor(size / (1024 * 1024 * 1024) * 1000) / 1000.000 ,language) + " GB";
        }
    }else{
        size = 0 +" byte";
    }
    return size;
};



indexAction.prototype.gmtDate2LocaleDate = function (dateStr,lang,notShowTime) {//根据当前语言显示时间格式
    var creationDate=dateStr;
    var date=new Date(dateStr);

    var year=date.getFullYear();
    var m=date.getMonth()+1;
    var mm=m<10?"0"+m:m;
    var d=date.getDate();
    var dd=d<10?"0"+d:d;
    var h=date.getHours();
    var hh=h<10?"0"+h:h;
    var min=date.getMinutes();
    var minm=min<10?"0"+min:min;
    var s=date.getSeconds();
    var ss=s<10?"0"+s:s;
    if(lang == 'zh'){
        createTime=year+"/"+m+"/"+d+" ";//y/M/d hh:mm
    }else if(lang == 'Portuguese'){
        createTime=dd+"/"+mm+"/"+year+" ";//dd/MM/y hh:mm
    }else if(lang == 'Spanish'){
        createTime=d+"/"+m+"/"+year+" ";//d/M/y h:mm
    }else if(lang == 'German'){
        createTime=d+"."+m+"."+year+" ";//d/M/y h:mm
    }else{//英语
        if(UCDVersion==='TLF'){
            createTime=mm+"/"+dd+"/"+year+" ";//M/d/y hh:mm
        }else{
            createTime=m+"/"+d+"/"+year+" ";//M/d/y hh:mm
        }
    }
    if(UCDVersion==='DT' || UCDVersion==='OCB' || UCDVersion==='CTC'||UCDVersion==='YLM'){
        createTime=year+"-"+mm+"-"+dd+" ";//y-MM-dd hh:mm
    }else if(UCDVersion==='TLF'){
        if(lang == 'Portuguese' || lang == 'Spanish'){
            createTime=dd+"/"+mm+"/"+year+" ";//dd/MM/y hh:mm
        }
    }
    if((UCDVersion==='HEC' || UCDVersion==='HK') && lang == 'en'){
        var monthName = ['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'];
        createTime= monthName[m-1]+" "+dd+","+year+" ";//MMM dd,yyyy hh:mm
    }
    if(notShowTime){
        return createTime;
    }else{
        createTime=createTime+hh+":"+minm+":"+ss+" ";
    }
    var d=new Date(dateStr);
    var dGMT=-(d.getTimezoneOffset());
    var hourGMT=0;
    if((dGMT/60)<0){
        if(dGMT/60>10){
            hourGMT=-(-Math.ceil(dGMT/60)+1);
        }else{
            hourGMT=-(-Math.ceil(dGMT/60));
        }

    }else{
        hourGMT=Math.floor(dGMT/60);
    }
    hourGMT=hourGMT<0?""+hourGMT:"+"+hourGMT;

    var hG1=hourGMT.substr(0,1);
    var hG2=hourGMT.substr(1,hourGMT.length);
    var hG3=hG2<10?"0"+hG2:hG2;
    var hG=hG1+hG3;
    var minGMT=dGMT%60;
    if(dGMT%60<0){
        minGMT=-(dGMT%60);
    }
    var mG=minGMT<10?"0"+minGMT:minGMT;
    createTime=" "+createTime+"GMT"+hG+":"+mG;
    return createTime;
}

//格式化数字显示
indexAction.prototype.formatNumber = function (num,language,isInt){
    if(!num){
        return 0;
    }
    num = parseFloat((num + "").replace(/[^\d\.-]/g,"")).toFixed(3)+"";
    var l = num.split(".")[0].split("").reverse(),r = num.split(".")[1];//通过小数点分割
    t = "";
    for(i = 0;i< l.length;i++){
        if(language == 'German' || language == "Portuguese" || language == "Spanish"){//德语、葡语、西语
            t += l[i] + ((i + 1) % 3 == 0 && (i + 1)!= l.length ? "." : "");
        }else{
            t += l[i] + ((i + 1) % 3 == 0 && (i + 1)!= l.length ? "," : "");
        }
    }
    if(language == 'German' || language == "Portuguese" || language == "Spanish"){//德语、葡语、西语
        if(r!='000' || !isInt){
            return t.split("").reverse().join("")+","+r;
        }else{
            return t.split("").reverse().join("");
        }
    }else{
        if(r!='000' || !isInt){
            return t.split("").reverse().join("")+"."+r;
        }else{
            return t.split("").reverse().join("");
        }
    }
}

/*
 处理文件或者文件夹展示效果
 type:  0->文件  1-> 文件夹
 */
indexAction.prototype.handlePath = function (key, pathStr, type) {
    if (type)
        pathStr = pathStr.substring(0, pathStr.length - 1);
    return pathStr.substring(pathStr.lastIndexOf("/") + 1, pathStr.length);
};

/*
 新增或者更新账户时输入域校验
 */
indexAction.prototype.saveOrModifyAccountCheck = function (obj, languageJson,userId, cb) {
    if(cb){
        var reg = /\\/;
        if (reg.test(obj.name) || reg.test(obj.secretKey) || reg.test(obj.accessKey) || reg.test(obj.endpoint)) {
            cb(languageJson.add_account_user_valid);
            return false;
        }

        if (!obj.name || obj.name.trim().length === 0) {
            cb(languageJson.inputAccountName);
            return false;
        }
        if (obj.name.length > 50) {
            cb(languageJson.inputAccountNameIsLong);
            return false;
        }
        var reg1 = /^[\u4E00-\u9FA5A-Za-z0-9_,.-]+$/;
        if(!reg1.test(obj.name)){
            cb(languageJson.common_term_accountName_tip);
            return false;
        }
        if(global.accountObj && global.accountObj.Accounts && global.accountObj.Accounts.Account){
            for(var i=0;i<global.accountObj.Accounts.Account.length;i++){
                var item = global.accountObj.Accounts.Account[i];
                if(item && item.ID!=userId && item.Name.toString() == obj.name.trim()){
                    cb(languageJson.inputAccountNameIsRepet);
                    return false;
                }
            }
        }
        if (obj.type === "2") {
            if (!obj.endpoint || obj.endpoint.trim().length === 0) {
                cb(languageJson.IPNotNull);
                return false;
            }
            var regPort = /:([0-9]|[1-9]\d|[1-9]\d{2}|[1-9]\d{3}|[1-5]\d{4}|6[0-4]\d{3}|65[0-4]\d{2}|655[0-2]\d|6553[0-5])$/;
            if (!regPort.test(obj.endpoint)) {
                cb(languageJson.PortIsNotNull);
                return false;
            }
            var regIsNum = /^[0-9]*$/;
            var isNum = regIsNum.test(obj.endpoint.split(':')[0].split('.').join(''));
            if(isNum){
                var regIP = /^(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5]):/;
                if (!regIP.test(obj.endpoint)) {
                    cb(languageJson.obs_term_proxyAddress_valid1);
                    return false;
                }
            }else{
                var regAddress = /^(?=^.{3,255}$)[a-zA-Z0-9][-a-zA-Z0-9]{0,62}(\.[a-zA-Z0-9][-a-zA-Z0-9]{0,62})+:/;
                if (!regAddress.test(obj.endpoint)) {
                    cb(languageJson.obs_term_proxyAddress_valid1);
                    return false;
                }
            }
        }
        if (!obj.accessKey || obj.accessKey.trim().length === 0) {
            cb(languageJson.inputAccessKey);
            return false;
        }
        if (obj.accessKey && obj.accessKey.trim().length > 256) {
            cb(languageJson.inputAccessKeyIsLong);
            return false;
        }
        if (!obj.secretKey || obj.secretKey.trim().length === 0) {
            cb(languageJson.inputSecretKey);
            return false;
        }
        if (obj.secretKey && obj.secretKey.trim().length > 256) {
            cb(languageJson.inputSecretKeyIsLong);
            return false;
        }
        cb();
    }
};

/*
 创建或者修改用户信息
 userId:用户ID 存在表示修改用户  不存在表示新增用户
 data:用户信息数据
 */
indexAction.prototype.createOrModifyUser = function (accountService,userId, data, callback) {
    global.logger.info('createOrModifyUser:',accountService,userId);
    if (userId && userId.length > 0) {
        accountService.updateAccountInfo(userId, data, function (err) {
            if (callback)
                callback(err);
        });
    }
    else {
        accountService.createAccountInfo(data, function (err) {
            if (callback)
                callback(err);
        });
    }
};

/*
 删除用户信息
 userId:用户ID
 */
indexAction.prototype.deleteAccountInfo = function (accountService,userId,callback,path) {
    accountService.deleteAccountInfo(userId,function (err) {
        if (callback)
            callback();
    },path);
};


/*
 持久化外部桶配置文件
 */
indexAction.prototype.writeExBucket = function (data,userPath) {
    global.logger.info('writeExBucket data:',data);
    var b = new Base64();
    var base64Str = b.encode(JSON.stringify(data));
    var fs = require("fs");
    if(!userPath){
        userPath = global.appDataPath;
    }
    fs.writeFile(userPath + "extBucket", base64Str,function(){});
};

/*
 持久化收藏路径配置文件
 */
indexAction.prototype.writeFavouritePath = function (data,userPath) {
    global.logger.info('writeFavouritePath data:',data);
    var b = new Base64();
    var base64Str = b.encode(JSON.stringify(data));
    var fs = require("fs");
    if(!userPath){
        userPath = global.appDataPath;
    }
    fs.writeFile(userPath + "favouritePath", base64Str,function(){});
};

/*
 持久化CDN配置文件
 */
indexAction.prototype.saveCDN = function (data,userPath) {
    global.logger.info('saveCDN data:',data);
    var b = new Base64();
    var base64Str = b.encode(JSON.stringify(data));
    var fs = require("fs");
    if(!userPath){
        userPath = global.appDataPath;
    }
    fs.writeFile(userPath + "CDNConfig", base64Str,function(){});
};

/*
 读取CDN配置文件
 */
indexAction.prototype.readCDN = function () {
    var fs = require("fs");
    if(fs.existsSync(global.appDataPath + "CDNConfig")){
        var CDNConfig = fs.readFileSync(global.appDataPath + "CDNConfig", "utf-8");
        var b = new Base64();
        var base64Str = b.decode(CDNConfig);
        CDNConfig = JSON.parse(base64Str);
        return CDNConfig;
    }
};
/*
 持久化系统配置文件
 */
indexAction.prototype.writeSysConfig = function (data,userPath) {
    data.version = 'v002';
    if(data.proxy && data.proxy.proxyPwd){
        global.Tools.encode('proxyPwd',data.proxy.proxyPwd,function(err,text){
            data.proxy.proxyPwd = text;
            var b = new Base64();
            var base64Str = b.encode(JSON.stringify(data));
            var fs = require("fs");
            if(!userPath){
                userPath = global.appDataPath;
            }
            fs.writeFile(userPath + "setting", base64Str,function(){});
        })
    }else{
        global.Tools.destroyKey('proxyPwd', function () {
            var b = new Base64();
            var base64Str = b.encode(JSON.stringify(data));
            var fs = require("fs");
            if(!userPath){
                userPath = global.appDataPath;
            }
            fs.writeFile(userPath + "setting", base64Str,function(){});
        });
    }
};


/*
比较两个时间大小
 */
indexAction.prototype.compareTwoTime = function (times,rubbishDays){
    var date1=new Date(times);
    var date2 = new Date();
    date2 = new Date(date2.getTime()-rubbishDays*24*60*60*1000);
    return date1<date2;
};

/*
 根据文件名显示相应突变
 */
indexAction.prototype.getFileType = function (fileName){
    var objsHtml = '';
    if (fileName.match(/\.zip$/) || fileName.match(/\.rar$/)
        || fileName.match(/\.gz$/) || fileName.match(/\.tar$/)|| fileName.match(/\.7z$/)) {
        objsHtml = '<i class="mui-icon-object-rar"></i>';
    }
    else if (fileName.match(/\.pdf$/)) {
        objsHtml = '<i class="mui-icon-object-pdf"></i>';
    }
    else if (fileName.match(/\.xml$/)) {
        objsHtml = '<i class="mui-icon-object-xml"></i>';
    }
    else if (fileName.match(/\.doc$/) || fileName.match(/\.docx$/)) {
        objsHtml = '<i class="mui-icon-object-word"></i>';
    }
    else if (fileName.match(/\.xls$/) || fileName.match(/\.xlsx$/)) {
        objsHtml = '<i class="mui-icon-object-excel"></i>'
    }
    else if (fileName.match(/\.ppt$/) || fileName.match(/\.pptx$/)) {
        objsHtml = '<i class="mui-icon-object-ppt"></i>'
    }
    else if (fileName.match(/\.html$/)||fileName.match(/\.htm$/)) {
        objsHtml = '<i class="mui-icon-object-html"></i>';
    }
    else if (fileName.match(/\.mp3$/) || fileName.match(/\.wma$/)) {
        objsHtml = '<i class="mui-icon-object-music"></i>';
    }
    else if (fileName.match(/\.csv$/)) {
        objsHtml = '<i class="mui-icon-object-csv"></i>';
    }
    else if (fileName.match(/\.png$/) || fileName.match(/\.gif$/)
        || fileName.match(/\.bmp$/) || fileName.match(/\.jpeg$/)
        || fileName.match(/\.jpg$/)) {
        objsHtml = '<i class="mui-icon-object-img"></i>';
    }
    else if (fileName.match(/\.db$/)) {
        objsHtml = '<i class="mui-icon-object-db"></i>';
    }
    else if (fileName.match(/\.dll$/)) {
        objsHtml = '<i class="mui-icon-object-dll"></i>';
    }
    else if (fileName.match(/\.exe$/)) {
        objsHtml = '<i class="mui-icon-object-exe"></i>';
    }
    else if (fileName.match(/\.iso$/)) {
        objsHtml = '<i class="mui-icon-object-iso"></i>';
    }
    else if (fileName.match(/\.inf$/)) {
        objsHtml = '<i class="mui-icon-object-inf"></i>';
    }
    else if (fileName.match(/\.ini$/)) {
        objsHtml = '<i class="mui-icon-object-ini"></i>';
    }
    else if (fileName.match(/\.js$/)) {
        objsHtml = '<i class="mui-icon-object-js"></i>';
    }
    else if (fileName.match(/\.vedio$/)) {
        objsHtml = '<i class="mui-icon-object-vedio"></i>';
    }
    else if (fileName.match(/\.txt$/)) {
        objsHtml = '<i class="mui-icon-object-txt"></i>';
    }
    else {
        objsHtml = '<i class="mui-icon-object-help"></i>';
    }
    return objsHtml;
};

/*
 *转换字符串为JSON显示
 */
indexAction.prototype.formateJson = function(str){
    if(typeof str == "string"){
        var tag = "";//字符，“，”，“{”，“【”,"】"，“}”
        var result = "";
        var tNumber = 0;
        var nextLine = "\n";
        var index = str.indexOf("\"${null}\"")  > -1 ?str.indexOf("\"${null}\"") : -1;
        for(var i in str){
            if(index > -1){
                if(index<i && i<index+9){
                    result += str[i];
                    continue;
                }
            }
            switch(str[i]){
                case '{' :
                    if(i==0){
                        result += "{";
                    }else{
                        if(tag === ""){
                            result += nextLine+getT(tNumber) + "{";
                        }else if(tag===","){
                            result += nextLine+getT(tNumber) + "{";
                        }else if(tag === "["){
                            tNumber++;
                            result += nextLine+getT(tNumber) + "{";
                        }else if(tag === "{"){
                            tNumber++;
                            result += nextLine+getT(tNumber) + "{";
                        }else if(tag === "}"){
                            result += nextLine+getT(tNumber) + "{";
                        }else if(tag === "]"){
                            result += nextLine+getT(tNumber) + "{";
                        }
                    }
                    tag = '{';
                    break;
                case ',' :
                    result += ",";
                    tag = ",";
                    break;
                case '[' :
                    if(tag===""){
                        result += "[";
                    }else  if(tag===","){
                        result += "[";
                    }else  if(tag==="["){
                        tNumber++;
                        result += nextLine+getT(tNumber) +"[";
                    }else  if(tag==="{"){
                        tNumber++;
                        result +=nextLine+ getT(tNumber) +"[";
                    }else  if(tag==="}"){
                        result +=nextLine+ getT(tNumber) +"[";
                    }else  if(tag==="]"){
                        result +=nextLine+ getT(tNumber) +"[";
                    }
                    tag = "[";
                    break;
                case ']' :
                    tNumber --;
                    result += nextLine+getT(tNumber)+"]";
                    tag = "]"
                    break;
                case '}' :
                    tNumber --;
                    result += nextLine+getT(tNumber)+"}";
                    tag = "}";
                    break;
                default :
                    if(tag === ""){
                        result += str[i];
                    }else if(tag === ","){
                        result += nextLine+getT(tNumber)+str[i];
                    }else if(tag === "["){
                        tNumber++;
                        result += nextLine+getT(tNumber)+str[i];
                    }else if(tag==="{"){
                        tNumber ++;
                        result += nextLine+getT(tNumber)+str[i];
                    }else if(tag === "}"){
                        result += nextLine+getT(tNumber)+str[i];
                    }else if(tag === "]"){
                        result += nextLine+getT(tNumber)+str[i];
                    }
                    tag ="";
                    break;
            }
        }
        return result;
    }else{
        return str;
    }
}


function getT(number){
    var t ="";
    for(var i=0;i<number;i++){
        //读取桶策略后，显示出来有问题，加4个空格调整格式
        t += "    ";
    }
    return t;
}

/*
 读取系统配置文件
 */
function readSysConfig(callback,userPath) {
    var fs = require("fs");
    var path = require('path');
    if(!userPath){
        userPath = global.appDataPath;
    }
    var filePath = path.normalize(userPath + "/setting");
    fs.lstat(filePath, function (err,data){
        if(err){
            if (callback) {
                callback();
            }
        }else if(data.size>0){
            fs.readFile(filePath, "utf-8", function (err, data) {
                if(data&&data.length>0){
                    var b = new Base64();
                    var dataStr = b.decode(data);
                    var configObj = JSON.parse(dataStr);
                    try{
                        if(configObj.version == 'v002' && configObj.proxy && configObj.proxy.proxyPwd){
                            global.Tools.decode('proxyPwd',configObj.proxy.proxyPwd,function(err,text){
                                if(!err){
                                    configObj.proxy.proxyPwd = text;
                                    if (callback) {
                                        callback(configObj);
                                    }
                                }else{
                                    global.logger.error('decode proxyPwd error:',err);
                                    delete configObj.proxy;
                                    if (callback) {
                                        callback(configObj);
                                    }
                                }
                            })
                        }else if(configObj.version == 'v001' && configObj.proxy && configObj.proxy.proxyPwd){
                            global.Tools.decipher(configObj.proxy.proxyPwd,function(text){
                                configObj.proxy.proxyPwd = text;
                                if (callback) {
                                    callback(configObj);
                                }
                            })
                        }else{
                            if (callback) {
                                callback(configObj);
                            }
                        }
                    }catch(err){
                        global.logger.error('decode proxyPwd error:',err);
                        delete configObj.proxy;
                        if (callback) {
                            callback(configObj);
                        }
                    }
                }
            });
        }else{
            if (callback) {
                callback();
            }
        }
    });
}

/*
 读取外部桶配置文件
 */
function readExtBucket(callback,userPath) {
    var fs = require("fs");
    var path = require('path');
    if(!userPath){
        userPath = global.appDataPath;
    }
    var filePath = path.normalize(userPath + "/extBucket");
    fs.lstat(filePath, function (err,data){
        if(err){
            if (callback) {
                callback();
            }
        }else if(data.size>0){
            fs.readFile(filePath, "utf-8", function (err, data) {
                if(data&&data.length>0){
                    var b = new Base64();
                    var dataStr = b.decode(data);
                    var configObj = JSON.parse(dataStr);
                    if (callback) {
                        callback(configObj);
                    }
                }
            });
        }else{
            if (callback) {
                callback();
            }
        }
    });
}

/*
 读取路径收藏夹配置文件
 */
function readFavouritePath(callback,userPath) {
    var fs = require("fs");
    var path = require('path');
    if(!userPath){
        userPath = global.appDataPath;
    }
    var filePath = path.normalize(userPath + "/favouritePath");
    fs.lstat(filePath, function (err,data){
        if(err){
            if (callback) {
                callback();
            }
        }else if(data.size>0){
            fs.readFile(filePath, "utf-8", function (err, data) {
                if(data&&data.length>0){
                    var b = new Base64();
                    var dataStr = b.decode(data);
                    var configObj = JSON.parse(dataStr);
                    if (callback) {
                        callback(configObj);
                    }
                }
            });
        }else{
            if (callback) {
                callback();
            }
        }
    });
}

function Base64() {
    var _keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
    this.encode = function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;
        input = _utf8_encode(input);
        while (i < input.length) {
            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);
            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;
            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }
            output = output +
            _keyStr.charAt(enc1) + _keyStr.charAt(enc2) +
            _keyStr.charAt(enc3) + _keyStr.charAt(enc4);
        }
        return output;
    }

// public method for decoding
    this.decode = function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;
        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
        while (i < input.length) {
            enc1 = _keyStr.indexOf(input.charAt(i++));
            enc2 = _keyStr.indexOf(input.charAt(i++));
            enc3 = _keyStr.indexOf(input.charAt(i++));
            enc4 = _keyStr.indexOf(input.charAt(i++));
            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;
            output = output + String.fromCharCode(chr1);
            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }
        }
        output = _utf8_decode(output);
        return output;
    }
    // private method for UTF-8 encoding
    _utf8_encode = function (inputStr) {
        inputStr = inputStr.replace(/\r\n/g, "\n");
        var utftext = "";
        for (var n = 0; n < inputStr.length; n++) {
            var c = inputStr.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            } else if ((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            } else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
        }
        return utftext;
    }
    // private method for UTF-8 decoding
    _utf8_decode = function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;
        while (i < utftext.length) {
            c = utftext.charCodeAt(i);
            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            } else if ((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i + 1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            } else {
                c2 = utftext.charCodeAt(i + 1);
                c3 = utftext.charCodeAt(i + 2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }
        }
        return string;
    }
}




module.exports = indexAction;