var obsError = require('./js/common/ObsError.js')
var i18n_learnMore = require('./js/i18n_learnMore.js')
var commonUtils = require('./js/common/CommonUtils.js');
var async = require('./node_modules/async');
var TaskControlAction = require('./js/sdk/taskControlAction.js');
var taskControlAction = new TaskControlAction();
//左侧通列表
function listBucketUI(err, data, loading, currentName) {
    var arr = [];
    if(data){
        for (var i in ExtBucket) {
            if (ExtBucket[i].id === currentUserId) {
                for (var index in data.Buckets) {
                    var bucket = data.Buckets[index];
                    // 如果桶列表里存在与外部桶名相同的桶，则去重外部桶
                    if (bucket.Name === ExtBucket[i].bucketArr[0]) {
                        ExtBucket.splice(i,1);
                        break;
                    }
                }
            }
        }
    }
    listBucketBodyUI(err, data);
    $("#downloadFileName").val("");
    pageContext = {};//重置分页对象
    pageContext.nowPage = 1;
    $("#isSearch").val("");
    if(!$("#prefixSearch").val()){//没有前缀搜索时刷新才隐藏图标
        $("#clearPrefixSearchInput").addClass("mui-hide");
        $("#clearBucketSearchInput").addClass("mui-hide");
    }
    $("#path").html('');
    $('#curBucketName').html("");
    $('#lsBuckets').html('');
    $('#objLists tr').each(function (i, item) {
        $(item).remove();
    });
    if (err) {
        $('.btnUserInfo').removeClass('userLogin');
        allButtonChange('1');
        logger.error("Error:", err);
        if (err.code == "BadRequest"){
            err.code = "TooManyWrongSignature"
        }
        if(err.code === "Unauthorized"){
            $(".mui-page-full.shown").removeClass('shown');
            $("#auth").removeClass('mui-hide');
            $("#auth").addClass('shown');
            divDragFunc('authDrag','auth');
        }
        if (errorConfig[err.code]&& err.code != "AccessDenied") {
            $('.mui-model').showErrorMessage({
                message: errorConfig[err.code],
                obsError: obsError(err.code,err.message)
            });
        }
        if (loading) {
            loading.close();
        }
        if(err.code==="AccessDenied"){
            $("#overlay").addClass('mui-hide');
            var arr = [];
            for (var i in ExtBucket) {
                if (ExtBucket[i].id === currentUserId) {
                    arr = ExtBucket[i].bucketArr;
                    if(arr.length != 0){
                        $("#overlay").addClass('mui-hide');
                    }
                    break;
                }
            }

            var extBucketNameList = []
            for (var i in arr) {
                var bucketItem = {
                    bucketName: encoderForHtml(arr[i])
                }
                if (arr[i] === currentName) {
                    bucketItem.current = true
                } else {
                    bucketItem.current = false
                }
                extBucketNameList.push(bucketItem)
            }
            $("#lsBuckets").append(renderSync("lsExtBucketsTemplate", extBucketNameList));
            // 加载收藏路径列表
            // loadFavouritePathList(currentName);
            if(pkg.coldline){
                for (var index in extBucketTableList) {
                    bucketAttributeAction.headBucket(extBucketTableList[index].showKey, function (err, data, bucketName) {
                        if (err) {
                            global.logger.error("query StorageType failed. bucket=" + bucketName, err);
                            $("#" + bucketName.replace(/\./g, "\\.") + "_extBucket_storageType").html("--");
                            return;
                        }
                        $("#" + bucketName.replace(/\./g, "\\.") + "_extBucket_storageType").html(commonUtils.termStorageClass(data.StorageType));
                    })
                }
            }
            $("#lsBuckets").append(renderSync("tableNoDataLeft", {queryNothing: global.langData.noRecords}));
            $("#lsBuckets").append(renderSync("tableQueryNothingLeft", {queryNothing: global.langData.noRecords}));
            $("#leftNoData").hide();
            $("#leftQueryNothing").hide();
        };

    } else {
        isLoaded = true;
        $('.btnUserInfo').addClass('userLogin');
        ownerId = data.Owner.ID;
        ownerName = data.Owner.DisplayName;
        allButtonChange('2');
        var bucket;

        var bucketNameList = []
        for (var index in data.Buckets) {
            bucket = data.Buckets[index];
            var bucketItem = {
                bucketName: encoderForHtml(bucket.Name)
            }
            if (bucket.Name === currentName) {
                bucketItem.current = true
            } else {
                bucketItem.current = false
            }
            bucketNameList.push(bucketItem)
        }
        $("#lsBuckets").html(renderSync("lsBucketsTemplate", bucketNameList));

        var arr = [];
        for (var i in ExtBucket) {
            if (ExtBucket[i].id === currentUserId) {
                arr = ExtBucket[i].bucketArr;
                break;
            }
        }

        var extBucketNameList = []
        for (var i in arr) {
            var bucketItem = {
                bucketName: encoderForHtml(arr[i])
            }
            if (arr[i] === currentName) {
                bucketItem.current = true
            } else {
                bucketItem.current = false
            }
            extBucketNameList.push(bucketItem)
        }
        $("#lsBuckets").append(renderSync("lsExtBucketsTemplate", extBucketNameList));
        $("#lsBuckets").append(renderSync("tableNoDataLeft", {queryNothing: global.langData.noData}));
        $("#lsBuckets").append(renderSync("tableQueryNothingLeft", {queryNothing: global.langData.noRecords}));
        loadFavouritePathList();
        $("#leftQueryNothing").hide();
        $("#leftNoData").hide();
        if (data.Buckets.length === 0 && arr.length === 0) {
            if (loading) {
                loading.close();
            }
            $("#leftNoData").show();
            return false;
        }
        $(".bucketLeftDiv .btnBucketSearch").click();
        $(".btnSearch").click();
        if (currentName) {
            $('#curBucketName').html(encoderForHtml(currentName));
            objectOrBucketRetrun(currentName);//切换到对象列表
        } else if (loading) {
            loading.close();
        } else {
            global.logger.warn("listBucketUI failed, currentName=" + currentName + "; loading=" + loading)
        }
    }
}

function removeDuplicatedItem(arr) {
    for(var i = 0; i < arr.length-1; i++){
        for(var j = i+1; j < arr.length; j++){
            if(arr[i]==arr[j]){
                arr.splice(j,1);
                j--;
            }
        }
    }
    return arr;
}

function loadFavouritePathList(currentName) {
    var pathArr = [];
    for (var i in favouritePath) {
        if (favouritePath[i].id === currentUserId) {
            pathArr = favouritePath[i].pathArr;
            break;
        }
    }
    // 去掉重复的元素
    pathArr = removeDuplicatedItem(pathArr);
    var pathNameList = [];
    var path = getCurrPath();
    var currentPath = path && path != "" ? currentName + "/" + path : currentName;
    for (var i in pathArr) {
        var pathItem = {
            pathName: encoderForHtml(pathArr[i])
        }
        if (pathArr[i] === currentPath) {
            pathItem.current = true
        } else {
            pathItem.current = false
        }
        pathNameList.push(pathItem);
    }
    $("#lsBucketPaths").html("");
    $("#lsBucketPaths").append(renderSync("lsFavouritePathsTemplate", pathNameList));
    $("#lsBucketPaths").append(renderSync("tableNoPathDataLeft", {queryNothing: global.langData.noData}));
    $("#lsBucketPaths").append(renderSync("tableQueryNothingPathLeft", {queryNothing: global.langData.noRecords}));
    $("#leftNoPathData").hide();
    $("#leftQueryNothingPath").hide();
    if(pathNameList.length === 0){
        $("#leftNoPathData").show();
    }
    // 如果搜索出来的则再执行下搜索
    $(".bucketPathLeftDiv .btnBucketSearch").click();
    updateFavouritePathCount();
}

//主区域桶列表
function listBucketBodyUI(err, data, loading, currentName) {
    $('#bucketLists tr').each(function (i, item) {
        $(item).remove();
    });
    $(".pathInput").addClass("mui-hide");
    $("#bread-path-box").removeClass("mui-hide");
    $(".bucket-delete,.mui-icon-aclConfig,.mui-icon-more,.mui-icon-property").addClass('mui-disabled');
    $('#bucketCreateNum').html('');
    $('#bucketRestNum').html('');
    if (err) {
        allButtonChange('1');
        if(err.code === "Unauthorized"){
            $(".mui-page-full.shown").removeClass('shown');
            $("#auth").removeClass('mui-hide');
            $("#auth").addClass('shown');
            divDragFunc('authDrag','auth');
            return false;
        }
        if(err.code === "AccessDenied"){
            isLoaded = true;
            $('.btnUserInfo').addClass('userLogin');
            var arr = [];
            var tbody = $("#bucketLists tbody");
            for (var i in ExtBucket) {
                if (ExtBucket[i].id === currentUserId) {
                    arr = ExtBucket[i].bucketArr;
                    break;
                }
            }
            if(arr.length != 0){
                $("#overlay").addClass('mui-hide');
            }else{
                if(UCDVersion === 'HEC' || UCDVersion === 'HK'){
                    $("#overlay").addClass('mui-hide');
                    $("#bucketLists tbody").html(renderSync("tableNoListPermission", {NoListPermission: global.langData.common_term_accessDenied_msg,tryPath:global.langData.common_term_accessPath_msg}));
                    $(".pathInput").removeClass("mui-hide");
                    $("#bread-path-box").addClass("mui-hide");
                    $("#pathInput").focus();
                }else{
                    $('.mui-model').showErrorMessage({
                        message: errorConfig[err.code],
                        obsError: obsError(err.code,err.message),
                        ok:function(){
                            $("#overlay").addClass('mui-hide');
                        }
                    });
                }
            }
            var extBucketTableList = [];
            for (var i in arr) {
                //处理多个连续空格显示问题
                var showKey = (encoderForHtml(arr[i]).replace(new RegExp(' ', 'gm'), '&nbsp;'));
                extBucketTableList.push({
                    showKey: showKey,
                    bucketName: arr[i],
                    aclConfig: languageJson.aclPermissions,
                    multipart: languageJson.multipart,
                    delete: languageJson.delete,
                    obs_term_unlinkBucket_button: languageJson.obs_term_unlinkBucket_button,
                    coldline : pkg.coldline
                })
            }
            tbody.append(renderSync("lsExtBucketsTableTemplate", extBucketTableList));
            if(pkg.coldline){
                for (var index in extBucketTableList) {
                    bucketAttributeAction.headBucket(extBucketTableList[index].showKey, function (err, data, bucketName) {
                        if (err) {
                            global.logger.error("query StorageType failed. bucket=" + bucketName, err);
                            $("#" + bucketName.replace(/\./g, "\\.") + "_extBucket_storageType").html("--");
                            return;
                        }
                        $("#" + bucketName.replace(/\./g, "\\.") + "_extBucket_storageType").html(commonUtils.termStorageClass(data.StorageType));
                        var curFileInterface = (data && data.FileInterface) ? data.FileInterface : "Disabled";
                        $("#" + bucketName.replace(/\./g, "\\.") + "_extBucket_fsType").html(curFileInterface);
                    })

                }
            }
            $('#bucketCreateNum').html(0);
            $('#extBucketNum').html(extBucketTableList.length);
        }else if (err.code !== "AccessDenied") {
            var _message = errorConfig[err.code] || err.statusCode;
            if(_message){
                $('.mui-model').showErrorMessage({
                    message: errorConfig[err.code],
                    obsError: obsError(err.code,err.message,err.statusCode)
                });
            }
        }
        logger.error("Error:", err);
        if (loading) {
            loading.close();
        }
    } else {
        var bucket;
        var tbody = $("#bucketLists tbody");
        var bucketTableList = [];
        for (var index in data.Buckets) {
            bucket = data.Buckets[index];
            //处理多个连续空格显示问题
            var showKey = (encoderForHtml(bucket.Name).replace(new RegExp(' ', 'gm'), '&nbsp;'));
            var localDate = indexAction.gmtDate2LocaleDate(bucket.CreationDate, language);

            bucketTableList.push({
                showKey: showKey,
                localDate: localDate,
                bucketName: bucket.Name,
                property: languageJson.bucketProperty,
                common_term_changeStorageClass_button: languageJson.common_term_changeStorageClass_button,
                delete: languageJson.delete,
                more: languageJson.more,
                coldline : pkg.coldline,
                objectColdline : pkg.objectColdline
            })
        }
        tbody.html(renderSync("lsBucketsTableTemplate", bucketTableList));
        // 按照桶创建时间排序
        var $trs = $('#bucketLists tbody tr');
        $trs.sort(function(a,b){
            var t1 = $(a).find('span[name="localDate"]').text();
            var t2 = $(b).find('span[name="localDate"]').text();
            t1 = t1.replace(/-/g, "/");
            t2 = t2.replace(/-/g, "/");
            if(language == 'Portuguese' || language == 'Spanish' ){
                t1 = swapDayMonthStr(t1);
                t2 = swapDayMonthStr(t2);
            }
            var x = new Date(Date.parse(t1));
            var y = new Date(Date.parse(t2));
            if(parseInt(x.getTime()) === parseInt(y.getTime())) return 0;
            else if(parseInt(x.getTime()) < parseInt(y.getTime())){
                return 1;
            }else return -1;
        });
        $trs.detach().appendTo('#bucketLists tbody');
        async.eachLimit(bucketTableList, 5, function (item, callback) {
            bucketAttributeAction.getBucketLocation(item.showKey, function (err, data, bucketName) {
                if (err) {
                    global.logger.error("query location failed. bucket=" + bucketName, err);
                    $("#" + bucketName.replace(/\./g, "\\.") + "_bucket_region").html("--");
                } else {
                    $("#" + bucketName.replace(/\./g, "\\.") + "_bucket_region").html(data.LocationConstraint);
                }
                callback();
            })
        }, function (err) {
            if (err) {
                global.logger.error('get location eachSeries error.', err);
            } else {
                global.logger.info('get location eachSeries done.');
            }
        });
        if(pkg.coldline){
            async.eachLimit(bucketTableList, 5, function (item, callback) {
                bucketAttributeAction.headBucket(item.showKey, function (err, data, bucketName) {
                    if (err) {
                        global.logger.error("query StorageType failed. bucket=" + bucketName, err);
                        $("#" + bucketName.replace(/\./g, "\\.") + "_bucket_storageType").html("--");
                    } else {
                        $("#" + bucketName.replace(/\./g, "\\.") + "_bucket_storageType").html(commonUtils.termStorageClass(data.StorageType));
                    }
                    var curFileInterface = (data && data.FileInterface) ? data.FileInterface : "Disabled";
                    $("#" + bucketName.replace(/\./g, "\\.") + "_bucket_fsType").html(curFileInterface);
                    callback();
                })
            }, function (err) {
                if (err) {
                    global.logger.error('head bucket eachSeries error.', err);
                } else {
                    global.logger.info('head bucket eachSeries done.');
                }
            });
        }
        var arr = [];
        for (var i in ExtBucket) {
            if (ExtBucket[i].id === currentUserId) {
                arr = ExtBucket[i].bucketArr;
                break;
            }
        }
        var extBucketTableList = [];
        for (var i in arr) {
            //处理多个连续空格显示问题
            var showKey = (encoderForHtml(arr[i]).replace(new RegExp(' ', 'gm'), '&nbsp;'));
            extBucketTableList.push({
                showKey: showKey,
                bucketName: arr[i],
                aclConfig: languageJson.aclPermissions,
                multipart: languageJson.multipart,
                delete: languageJson.delete,
                obs_term_unlinkBucket_button: languageJson.obs_term_unlinkBucket_button,
                coldline : pkg.coldline
            })
        }
        tbody.append(renderSync("lsExtBucketsTableTemplate", extBucketTableList));
        if(pkg.coldline){
            for (var index in extBucketTableList) {
                bucketAttributeAction.headBucket(extBucketTableList[index].showKey, function (err, data, bucketName) {
                    if (err) {
                        global.logger.error("query StorageType failed. bucket=" + bucketName, err);
                        $("#" + bucketName.replace(/\./g, "\\.") + "_extBucket_storageType").html("--");
                        return;
                    }
                    $("#" + bucketName.replace(/\./g, "\\.") + "_extBucket_storageType").html(commonUtils.termStorageClass(data.StorageType));
                    var curFileInterface = (data && data.FileInterface) ? data.FileInterface : "Disabled";
                    $("#" + bucketName.replace(/\./g, "\\.") + "_extBucket_fsType").html(curFileInterface);
                })
            }
        }
        tbody.append(renderSync("tableNoData", {queryNothing: global.langData.noData}));
        $("#bucketLists tbody").append(renderSync("tableQueryNothing", {queryNothing: global.langData.noRecords}));
        $("#tableBodyNoData").hide();
        $("#tableBodyQueryNothing").hide();
        // 设置桶数量信息
        var bucketCreateNum;
        var extBucketNum;
        if(data.Buckets){
            bucketCreateNum = bucketTableList.length;
        }else{
            bucketCreateNum = '';
            extBucketNum = '';
        }
        if(ExtBucket){
            extBucketNum = extBucketTableList.length;
        }else{
            extBucketNum = '';
        }
        $('#bucketCreateNum').html(bucketCreateNum);
        $('#extBucketNum').html(extBucketNum);
        if (loading) {
            loading.close();
        }
        if (data.Buckets.length === 0 && arr.length === 0) {
            $("#tableBodyNoData").show();
            return false;
        }
    }
}

/**
 * 搜索table区域的bucket
 * @param keyVal
 * @returns {boolean}
 */
function searchBucketTable(keyVal) {
    var mui_hide = $("#bucketArea").attr("class");
    //这里表明是在查桶列表，与查询对象列表区分开
    //查询忽略大小写
    keyVal = keyVal.toLowerCase();
    if (mui_hide != "mui-hide") {
        $("#bucketLists tbody").children().show();
        var bucketLs = $("#bucketLists tbody").children();
        var queryNothing = true;
        for (var i = 0; i < bucketLs.length; i++) {
            var bucketName = $(bucketLs[i]).find("span[name='bucketBodyItem']").attr("data-href");
            if (!bucketName) {
                continue;
            } else if (bucketName.indexOf(keyVal) == -1) {
                $(bucketLs[i]).hide();
            } else {
                queryNothing = false;
            }
        }
        if (queryNothing) {
            $("#tableBodyQueryNothing").show();
            $("#tableBodyNoData").hide();
        } else {
            $("#tableBodyQueryNothing").hide();
            $("#tableBodyNoData").hide();
        }
        return true;
    }
}

$(".bucketLeftDiv .btnBucketSearch").on('click', function (event) {
    var keyval = $('#bucketSearch').val();
    keyval = keyval.toLowerCase();
    $("#lsBuckets").children().show();
    var bucketLs = $("#lsBuckets").children();
    var queryNothing = true;
    for (var i = 0; i < bucketLs.length; i++) {
        var bucketName = $(bucketLs[i]).attr("data-href")
        if (!bucketName) {
            continue;
        } else if (bucketName.indexOf(keyval) == -1) {
            $(bucketLs[i]).hide();
        } else {
            queryNothing = false;
        }
    }
    if (queryNothing) {
        $("#leftQueryNothing").show();
        $("#leftNoData").hide();
    } else {
        $("#leftNoData").hide();
        $("#leftQueryNothing").hide();
    }
});

//筛选桶时输入回车按钮执行查询功能
$("#bucketSearch").on('keyup', function (event) {
    var keyCode = event.keyCode;
    if (keyCode === 13) {
        $(".bucketLeftDiv .btnBucketSearch").click();
    }
});

//筛选收藏路径时输入回车按钮执行查询功能
$("#bucketPathSearch").on('keyup', function (event) {
    var keyCode = event.keyCode;
    if (keyCode === 13) {
        $(".bucketPathLeftDiv .btnBucketSearch").click();
    }
});

//获取当前路径
function getCurrPath() {
    var parentPath = '';
    $('#path a span').each(function (i, a) {
        if (i > 0) {
            parentPath = JSON.parse($(a).text()).name
        }
    });
    return parentPath.replace("obs://", "");
}

function getObjectUrl(bName, href, region, parentPath) {
    var url = false;
    var point = s3.config.endpoint;
    if (point.indexOf('https') === -1) {
        point = point.replace('http', 'https');
    }
    var data = point.split(':');
    if (data.length > 2) {
        point = data[0] + ':' + data[1];
    }
    var regionAddress = domainName;
    var index = regionAddress.indexOf(".");
    if(region && (UCDVersion === 'HEC'|| UCDVersion === 'HK')){
        regionAddress = regionAddress.substring(0,index+1) + region + regionAddress.substring(index);
    }
    var isIP = data[1].replace("//","");
    var re =  /^([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])$/;
    var AWS = require('./node_modules/hws-sdk');
    if (userType == 1) {
        url = point.replace(endpoint, '') + AWS.util.uriEscapePath(bName + "." + regionAddress + '/' + parentPath + href);
    } else {
        if(re.test(isIP)){
            url = point + "/" + AWS.util.uriEscapePath(bName + "/" + parentPath + href);
        }else{
            url = point.replace(isIP, '') + AWS.util.uriEscapePath(bName + "." + regionAddress + '/' + parentPath + href);
        }
    }
    return url;
}

//获取元素绝对位置
function getNodeLocation(id) {
    var x = $("#" + id).offset().left;
    var y = $("#" + id).offset().top;
    var location = {
        popX: x,
        popY: y
    }
    return location;
}

//对象列表和桶列表切换
function objectOrBucketRetrun(currentName) {
    showFavouriteIcon(currentName + "/");
    var path = "obs://" + currentName + "/";
    global.inputPath = path;
    $("#pathInput").val(path);
    $("#pathInputCollect").removeClass("mui-hide");
    var loading = loadingShow();
    if ($("#objectArea").hasClass('mui-hide')) {
        $("#objectArea").removeClass('mui-hide');//桶列表和对象列表切换
        $("#bucketArea").addClass('mui-hide');
        $("#objectBtnDiv").removeClass('mui-hide');
        $("#bucketBtnDiv").addClass('mui-hide');
        $("#prefixSearch").val("");
        $("#all-back-div").addClass('all-back-btn');//修改后退按钮样式
        $("#all-back-div").removeClass('all-back-btn-disabled');
        $(".mui-font-color-gray").removeClass('mui-hide');//显示下方属性栏
        $("#prefixSearch").attr('placeholder', languageJson.prefixSearchInfo);
    }
    bucketAttributeAction.headBucket(currentName, function (err, data) {
        if (err) {
            if (!err.code) {
                err.code = "InternalError"
                global.logger.error("Get into bucket by click...", err);
            }
            if (err.code == "Forbidden") {
                $('.mui-model').showErrorMessage({
                    message: errorConfig["AccessDenied"],
                    obsError: obsError("AccessDenied")
                });
            } else {
                $('.mui-model').showErrorMessage({
                    message: errorConfig[err.code],
                    obsError: obsError(err.code,err.message)
                });
            }

            $("#bread-path-box-bucket").click();
            loading.close();
            return false;
        }
        global.curFileInterface = (data && data.FileInterface) ? data.FileInterface : "Disabled";
        currBucketStorage = (data && data.StorageType) || false;
        if (pkg.objectColdline || currBucketStorage === 'Coldline') {
            $("#restoredInMore").removeClass('mui-hide');
        } else {
            $("#restoredInMore").addClass('mui-hide');
        }
        bucketAndObjectAction.listObject(currentName, 'true', '', function (err, data) {
            loading.close();
            listObjectUI(err, data, currentName);
        });
        var str = {
            name: currentName
        };
        var htmStr = renderSync("head-navi-item", {
            currPath: JSON.stringify(str),
            folderName: currentName
        });
        $(".mui-body .mui-content .path").html(htmStr);
    });
}

/**
 * 实现弹出框拖拽功能
 * @param target
 * @param root
 */
function divDragFunc(target, root) {
    //偏移量，避免拖动到边界时将界面边框挡住了
    var offset = 2;
    //header的高度
    var top = 60;
    // 桶属性窗口的高度过大，需要调整拖拽的最大y值
    var offset2 = target === "bucketProDrag" ? 38 : 0;
    $.drag({
        target: document.getElementById(target),
        root: document.getElementById(root),
        min: {x: offset, y: top},
        max: {
            x: document.body.clientWidth - document.getElementById(root).clientWidth - offset,
            y: document.body.clientHeight - offset - offset2 - document.getElementById(root).scrollHeight
        }
    });
}

/**
 * 打开learnMore 链接
 */
$(".mui-page h5 a,#helpOnline, #multiAZPriceDetai,#linkToUtil").on('click', function () {
    var gui = require('nw.gui');
    var id = $(this).attr('id');
    var href = '';
    if (UCDVersion === 'DT') {//DT版本
        href = i18n_learnMore.getLearnMoreLink("DT_EN", id);
    } else if (UCDVersion === 'TLF') {//TLF版本
        href = i18n_learnMore.getLearnMoreLink("TLF_EN", id);
    } else if (UCDVersion === 'OCB' && language === 'en') {//OCB英文版本
        href = i18n_learnMore.getLearnMoreLink("OCB_EN", id);
    } else if (UCDVersion === 'OCB' && language === 'zh') {//OCB中文版本
        href = i18n_learnMore.getLearnMoreLink("OCB_ZH", id);
    } else if (UCDVersion === 'HEC' && language === 'zh') {//HEC中文版本
        href = i18n_learnMore.getLearnMoreLink("HEC_ZH", id);
    }  else if (UCDVersion === 'HK' && language === 'zh') {//HK中文版本
        href = i18n_learnMore.getLearnMoreLink("HK_ZH", id);
    }  else if (UCDVersion === 'HK' && language === 'en') {//HEC中文版本
        href = i18n_learnMore.getLearnMoreLink("HK_EN", id);
    } else if (UCDVersion === 'CTC' && language === 'zh') {//CTC中文版本
        href = i18n_learnMore.getLearnMoreLink("CTC_ZH", id);
    }  else if (UCDVersion === 'CTC' && language === 'en') {//CTC英文版本
        href = i18n_learnMore.getLearnMoreLink("CTC_EN", id);
    }else if (UCDVersion === 'CMCC' && language === 'zh') {//CMCC中文版本
        href = i18n_learnMore.getLearnMoreLink("CMCC_ZH", id);
    }else if (UCDVersion === 'CMCC' && language === 'en') {//CMCC英文版本
        href = i18n_learnMore.getLearnMoreLink("CMCC_EN", id);
    }else if (UCDVersion === 'HCSO' && language === 'zh') {//HCS中文版本
        href = i18n_learnMore.getLearnMoreLink("HCSO_ZH", id);
    }else if (UCDVersion === 'HCSO' && language === 'en') {//HCS英文版本
        href = i18n_learnMore.getLearnMoreLink("HCSO_EN", id);
    }else if (UCDVersion === 'YLM' && language === 'zh') {//YLM中文版本
        href = i18n_learnMore.getLearnMoreLink("YLM_ZH", id);
    }else if (UCDVersion === 'YLM' && language === 'en') {//YLM英文版本
        href = i18n_learnMore.getLearnMoreLink("YLM_EN", id);
    }else {//HEC英文版本
        href = i18n_learnMore.getLearnMoreLink("HEC_EN", id);
    }
    gui.Shell.openExternal(href);
    return false;
})

/**
 * 控制前缀查询输入域清除按钮显示与隐藏
 */
$("#prefixSearch").on('keyup', function () {
    var value = $(this).val();
    if (value.length > 0) {
        $("#clearPrefixSearchInput").removeClass("mui-hide");
    } else {
        $("#clearPrefixSearchInput").addClass("mui-hide");
        $("#isSearch").val("");
    }
});

/**
 * 清空前缀查询输入域
 */
$("#clearPrefixSearchInput").on('click', function () {
    $("#prefixSearch").val("");
    $("#isSearch").val("");
    $(".btnSearch").click();
    $(this).addClass('mui-hide');
});

/**
 * 控制桶搜索输入域清除按钮显示与隐藏
 */
$("#bucketSearch").on('keyup', function () {
    var value = $(this).val();
    if (value.length > 0) {
        $("#clearBucketSearchInput").removeClass("mui-hide");
    } else {
        $("#clearBucketSearchInput").addClass("mui-hide");
    }
});

/**
 * 控制收藏路径搜索输入域清除按钮显示与隐藏
 */
$("#bucketPathSearch").on('keyup', function () {
    var value = $(this).val();
    if (value.length > 0) {
        $("#clearBucketPathSearchInput").removeClass("mui-hide");
    } else {
        $("#clearBucketPathSearchInput").addClass("mui-hide");
    }
});
/**
 * 清空路径搜索输入域
 */
$("#clearBucketPathSearchInput").on('click', function () {
    $("#bucketPathSearch").val("");
    $(".bucketPathLeftDiv .btnBucketSearch").click();
    $(this).addClass('mui-hide');
});

/**
 * 清空桶搜索输入域
 */
$("#clearBucketSearchInput").on('click', function () {
    $("#bucketSearch").val("");
    $(".bucketLeftDiv .btnBucketSearch").click();
    $(this).addClass('mui-hide');
});

/**
 * 检查每页对象列表配置数量
 * @param configObj
 * @returns {boolean}
 */
function chekcObjPageSize(configObj) {
    var objSize = new Number($("#objPerPageSize").val());
    var objSizeMin = new Number($("#objPerPageSize").attr("min"));
    var objSizeMax = new Number($("#objPerPageSize").attr("max"));
    if (objSize < objSizeMin) {
        $('.mui-model').showMessage({
            type: "warning",
            message: languageJson.objListPerPageMin,
            ok: function () {
                return false;
            },
            title: languageJson.warning
        });
        return false;
    }
    if (objSize > objSizeMax) {
        $('.mui-model').showMessage({
            type: "warning",
            message: languageJson.objListPerPageMax,
            ok: function () {
                return false;
            },
            title: languageJson.warning
        });
        return false;
    }
    global.objPerPageSize = $("#objPerPageSize").val();
    configObj.objPerPageSize = $("#objPerPageSize").val();
    return true;
}



/**
 * disabled 状态的按钮添加tips效果,在生命周期和cors界面上通过mui-disabled样式筛选不生效
 */
$(".mui-disabled").on('mouseover mouseout', function (event) {
    if ($(this).hasClass('mui-disabled')) {
        if (event.type === "mouseover") {
            var data = $(this).attr("data-title");
            $(this).attr("title", data);
        } else {
            $(this).removeAttr("title");
        }
    }
});

/**
 * 生命周期和cors列表中disabled状态的按钮添加tips效果
 */
$(".mui-icon-edit-16,.mui-icon-del-16").on('mouseover mouseout', function (event) {
    if ($(this).hasClass('mui-disabled')) {
        if (event.type === "mouseover") {
            var data = $(this).attr("data-title");
            $(this).attr("title", data);
        } else {
            $(this).removeAttr("title");
        }
    }
});

/**
 * 启用按钮，去掉disabled效果
 * @param $btnObj
 */
function disabledBtn($btnObj) {
    $btnObj.removeClass('mui-disabled');
    $btnObj.removeAttr('title');
    $btnObj.removeAttr('disabled');
}


//域名管理
function CDNChildCtrl() {
    requirejs([], function () {
        var module = angular.module('CDNChildModule', ['tiny']);

        module.controller('CDNChildCtrl', ['$scope','tiValid', function ($scope,tiValid) {
            $scope.CNDType = {
                storageTypeList: [
                    {
                        key: "web",
                        value: global.langData.obs_term_domainName_cdnTypeWeb_option,
                        disable: false
                    }, {
                        key: "download",
                        value: global.langData.obs_term_domainName_cdnTypeDownload_option,
                        disable: false
                    }, {
                        key: "video",
                        value: global.langData.obs_term_domainName_cdnTypeVOD_option,
                        disable: false
                    }
                ]
            }
            $scope.CNDType.selected = {
                // 设置默认选中值，后续$scope.selected.value会根据用户的选择而动态改变
                value: $scope.CNDType.storageTypeList[0].key
            }
            $scope.createCDN = {
                userEenpointValidate:{
                    validator: [{
                        "rule": "required",
                        "errorMsg": global.langData.obs_term_domainName_userDomain_hint
                    }, {
                        rule: "maxSize",
                        param: [256]
                    }, {
                        rule: function (value) {
                            var reg = /^([^\\*]+\\.)?([a-zA-Z0-9]([a-zA-Z0-9-]{0,60}[a-zA-Z0-9])?\.){1,}[a-zA-Z]{2,6}$/;
                            if (reg.test(value)) {
                                return "";
                            } else {
                                return global.langData.obs_term_domainName_userDomain_valid;
                            }
                        }
                    }]
                }
            }
        }]);
        angular.bootstrap($('#CDNChild'), ['CDNChildModule']);
    });
}

function createAccountCtrl() {
    requirejs([], function () {
        var module = angular.module('createAccountModule', ['tiny']);

        module.controller('createAccountCtrl', ['$scope', 'tiValid', function ($scope, tiValid) {
            if(_.isEqual(UCDVersion,"HEC")){
                $("#addNewAccountKnowMore").parent().hide();
            }
            if(_.isEqual(UCDVersion,"CTC")){
                $("#addNewAccountKnowMore").parent().hide();
            }
            $scope.createAccount = {
                placeholder : global.langData.accountNamePlaceHolder,
                accountValidate: {
                    "validator": [{
                        rule: function (value) {
                            return value.length <= 50;
                        },
                        errorMsg: global.langData.inputAccountNameIsLong
                    }, {
                        rule: function (value) {
                            return value.trim().length > 0;
                        },
                        errorMsg: global.langData.common_term_emptyEnter_msg
                    },{
                        rule: function (value) {
                            var reg1 = /^[\u4E00-\u9FA5A-Za-z0-9_,.-]+$/;
                            if(!reg1.test(value.trim())){
                               return false;
                            }
                            return true;
                        },
                        errorMsg: global.langData.common_term_accountName_tip
                    }, {
                        rule: function (value) {
                            var userId = $("#userId").val();
                            if (global.accountObj && global.accountObj.Accounts && global.accountObj.Accounts.Account) {
                                for (var i = 0; i < global.accountObj.Accounts.Account.length; i++) {
                                    var item = global.accountObj.Accounts.Account[i];
                                    if (item && item.ID[0] != userId && item.Name.toString() == value.trim()) {
                                        return false;
                                    }
                                }
                            }
                            return true;
                        },
                        errorMsg: global.langData.inputAccountNameIsRepet
                    }]
                },
                accountAkValidate: {
                    "validator": [{
                        rule: function (value) {
                            return value.trim().length > 0;
                        },
                        errorMsg: global.langData.inputAccessKey
                    },{
                        rule: function (value) {
                            return value.trim().length <= 256;
                        },
                        errorMsg: global.langData.inputAccessKeyIsLong
                    }]
                },
                accountSkValidate: {
                    "validator": [{
                        rule: function (value) {
                            return value.trim().length > 0;
                        },
                        errorMsg: global.langData.inputSecretKey
                    },{
                        rule: function (value) {
                            return value.trim().length <= 256;
                        },
                        errorMsg: global.langData.inputSecretKeyIsLong
                    }]
                },
                accountEndpointValidate: {
                    "validator": [{
                        rule: function (value) {
                            return value.length > 0;
                        },
                        errorMsg: global.langData.IPNotNull
                    }, {
                        rule: function (value) {
                            if(value.indexOf(":") != -1){
                                // 端口校验
                                var regPort = /:([0-9]|[1-9]\d|[1-9]\d{2}|[1-9]\d{3}|[1-5]\d{4}|6[0-4]\d{3}|65[0-4]\d{2}|655[0-2]\d|6553[0-5])$/;
                                if (!regPort.test(value)) {
                                    return false;
                                }
                                return true;
                            }
                            return true;
                        },
                        errorMsg: global.langData.PortIsNotNull
                    }, {
                        rule: function (value) {
                            // 如果只有数字则进行IP校验
                            var regIsNum = /^[0-9]*$/;
                            var isNum = regIsNum.test(value.split(':')[0].split('.').join(''));
                            if(isNum){
                                // IP校验
                                var regIP = /^(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5]):?/;
                                if (!regIP.test(value)) {
                                    return false;
                                }
                            }else{
                                // 域名校验
                                var regAddress = /^(?=^.{3,255}$)[a-zA-Z0-9][-a-zA-Z0-9]{0,62}(\.[a-zA-Z0-9][-a-zA-Z0-9]{0,62})+:?/;
                                if (!regAddress.test(value)) {
                                    return false;
                                }
                            }
                            return true;
                        },
                        errorMsg: global.langData.obs_term_proxyAddress_valid1
                    }]
                },
                cleanInvalidate: function () {
                    tiValid.clearInValid($("#name"));
                    tiValid.clearInValid($("#accessKey"));
                    tiValid.clearInValid($("#secretKey"));
                    tiValid.clearInValid($("#endpoint"));
                }
            };
        }]);

        angular.bootstrap($('#tiny-accountConfig'), ['createAccountModule']);
    });
}

function createBucketCtrl() {
    requirejs([], function () {
        var module = angular.module('createBucketModule', ['tiny']);

        module.controller('createBucketCtrl', ['$scope', 'tiValid', function ($scope, tiValid) {
            if(_.isEqual(UCDVersion,"HEC")){
                $("#extBucketMore").hide();
            }
            if(_.isEqual(UCDVersion,"CTC")){
                $("#extBucketMore").hide();
            }
            $("#createExtBuceketTab").hide();
            $("#createBucketTab").show();
            $scope.coldlineSwitch = pkg.coldline;
            $scope.isCurrentRegionSupportMultiAz = false;
            $scope.isCurrentRegionSupportFsInterface = false;
            $scope.isCurrentStorageTypeIsStandard = true;
            $scope.isSupportMultiAz = pkg.isSupportMultiAz;
            $scope.isSupportFileInterface = pkg.isSupportFileInterface;
            $scope.isSupportBucketPolicy = pkg.isSupportBucketPolicy;
            $scope.isSupportMultiAzRegions = global.langData.obs_term_AZ_regionNotSupport_tip;
            $scope.isSupportFsInterfaceRegions = global.langData.obs_term_filePro_regionNotSupport_tip;
            $scope.enableFsInterfaceNotSupportKms = global.langData.obs_term_KMS_label2;
            $scope.createType = {
                createTypeList: [
                    {
                        key: "bucket",
                        value: global.langData.obs_task_createBucket_radio
                    },
                    {
                        key: "extBucket",
                        value: global.langData.obs_task_createAddExternalBucket_radio
                    }
                ]
            }
            $scope.createType.selected = {
                value: $scope.createType.createTypeList[0].value
            }
            $scope.createType.changeCreate = function () {
                $("#createExtBuceketTab").hide();
                $("#createBucketTab").hide();
                if ($scope.createType.selected.value === $scope.createType.createTypeList[0].value) {
                    $("#createBucketTab").show();
                }
                if ($scope.createType.selected.value === $scope.createType.createTypeList[1].value) {
                    $("#createExtBuceketTab").show();
                }
            }
            $scope.bucket = {
                storageTypeList: [
                    {
                        key: "Standard",
                        value: global.langData.obs_term_standard_lable,
                        desc: global.langData.obs_term_standard_tip,
                        disable: false
                    }, {
                        key: "Nearline",
                        value: commonUtils.termStorageClass("Nearline"),
                        desc: global.langData.obs_term_nearline_tip,
                        disable: false
                    }, {
                        key: "Coldline",
                        value: commonUtils.termStorageClass("Coldline"),
                        desc: global.langData.obs_term_coldline_tip,
                        disable: false
                    }
                ],
                policyTypeList: [
                    {
                        id: "private",
                        value: languageJson.obs_term_bucketPolicy_private_radio,
                        desc: languageJson.obs_term_bucketPolicy_private_info,
                        disable: false
                    }, {
                        id: "publicRead",
                        value: languageJson.obs_term_bucketPolicy_publicRead_radio,
                        desc: languageJson.obs_term_bucketPolicy_publicRead_info,
                        disable: false
                    }, {
                        id: "publicReadWrite",
                        value: languageJson.obs_term_bucketPolicy_publicReadWrite_radio,
                        desc: languageJson.obs_term_bucketPolicy_publicReadWrite_info,
                        disable: false
                    }
                ],
                multiAz: {
                    elementId: "bucket_create_ti_btn_radio_group_multiaz",
                    options: [{
                        id: "3az",
                        value: languageJson.enable,
                        disable :false
                    }, {
                        id: "1az",
                        value: languageJson.disable,
                        disable :false
                    }],
                    selectedId: "3az",
                    az_coldnotsupport_tip: ""
                },
                fsInterface: {
                    elementId: "bucket_create_ti_btn_radio_group_fs_interface",
                    options: [{
                        id: "Enabled",
                        value: languageJson.enable,
                        disable :false
                    }, {
                        id: "Disabled",
                        value: languageJson.disable,
                        disable :false
                    }],
                    selectedId: "Disabled"
                }
            }
            $scope.bucket.selected = {
                // 设置默认选中值，后续$scope.selected.value会根据用户的选择而动态改变
                value: $scope.bucket.storageTypeList[0].key,
                policyValue: $scope.bucket.policyTypeList[0].id
            }
            $scope.bucket.description = $scope.bucket.storageTypeList[0].desc;
            $scope.bucket.policyDescrip = $scope.bucket.policyTypeList[0].desc;
            $scope.bucket.changeType = function (key) {
                for (var index in $scope.bucket.storageTypeList) {
                    if ($scope.bucket.storageTypeList[index].key == $scope.bucket.selected.value) {
                        $scope.bucket.description = $scope.bucket.storageTypeList[index].desc
                    }
                }
                if($scope.isCurrentRegionSupportMultiAz){
                    if(key === "Coldline"){
                        $scope.bucket.multiAz.selectedId = '1az';
                        $scope.bucket.multiAz.options[0].disable = true;
                        $scope.bucket.multiAz.az_coldnotsupport_tip = languageJson.obs_term_AZ_archiveNotSupport_tip;
                    }else {
                        $scope.bucket.multiAz.options[0].disable = false;
                        $scope.bucket.multiAz.az_coldnotsupport_tip = "";
                    }
                }
            }
            $scope.bucket.changeMultiAzMode = function (id) {
                $scope.bucket.multiAz.selectedId = id;
                if(id == "3az"){
                    $("#modelMultiAz").removeClass("mui-hide");
                    $("#modelMultiAz").css('z-index','99');
                }
            }
            $scope.bucket.changeFsInterfaceMode = function (id) {
                $scope.bucket.fsInterface.selectedId = id;
                if(id == "Enabled"){
                    $scope.isCurrentStorageTypeIsStandard = false;
                    // 文件语义开启，只有标准存储，多AZ也应该不能禁用
                    $scope.bucket.multiAz.options[0].disable = false;
                    $scope.bucket.multiAz.az_coldnotsupport_tip = "";
                    $scope.bucket.selected.value = $scope.bucket.storageTypeList[0].key;
                    $("#fsInterfaceNotSupportKmsTip").removeClass("mui-hide");
                }else {
                    $("#fsInterfaceNotSupportKmsTip").addClass("mui-hide");
                    $scope.isCurrentStorageTypeIsStandard = true;
                    if($scope.bucket.selected.value == "Coldline"){
                        $scope.bucket.multiAz.selectedId = '1az';
                        $scope.bucket.multiAz.options[0].disable = true;
                        $scope.bucket.multiAz.az_coldnotsupport_tip = languageJson.obs_term_AZ_archiveNotSupport_tip;
                    }else {
                        $scope.bucket.multiAz.options[0].disable = false;
                        $scope.bucket.multiAz.az_coldnotsupport_tip = "";
                    }
                }
            }
            $scope.bucket.changePolicyType = function (key, desc) {
                var errMsg = languageJson.obs_term_createBucket_publicRead_msg;
                var errMsg2 = languageJson.obs_term_createBucket_publicReadWrite_msg;
                $scope.bucket.selected.policyValue = key;
                $scope.bucket.policyDescrip = desc;
                if(key != "private"){
                    if(key === $scope.bucket.policyTypeList[2].id){
                        errMsg = errMsg2;
                    }
                    $('.mui-model').showMessage({
                        type: 'choose_warning',
                        message: errMsg,
                        noClose: true,
                        ok: function () {
                            $scope.bucket.selected.policyValue = $scope.bucket.policyTypeList[0].id;
                            $scope.bucket.policyDescrip = $scope.bucket.policyTypeList[0].desc;
                            $scope.$apply();// 这里不能缺少
                            return false;
                        },
                        cancel: function () {
                            return false;
                        },
                        title: languageJson.warning
                    });
                    return false;
                }
            }
            $scope.resetCreateBucket = function () {
                // 点击取消还原默认值
                $scope.createType.selected = {
                    value: $scope.createType.createTypeList[0].value
                };
                $scope.createType.changeCreate();
                $scope.bucket.selected = {
                    value: $scope.bucket.storageTypeList[0].key,
                    policyValue: $scope.bucket.policyTypeList[0].id
                };
                $scope.bucket.fsInterface.selectedId = 'Disabled';
                $scope.isCurrentStorageTypeIsStandard = true;
                $scope.bucket.description = $scope.bucket.storageTypeList[0].desc;
                $scope.bucket.policyDescrip = $scope.bucket.policyTypeList[0].desc;
            }
            $scope.createBucket = {
                BucketNameValidate: {
                    "validator": [{//必填提示
                        rule: "required",
                        errorMsg: global.langData.obs_term_createBucket_name_hint
                    }, {
                        rule: function (value) {//仅支持小写字母、数字、"-"、"."
                            var val = $.trim(value);
                            return /^[a-z0-9-.]+$/.test(val);
                        },
                        errorMsg: global.langData.obs_term_createBucket_ruler1_valid
                    }, {//3-63字符
                        "rule": "rangeSize",
                        "param": [3, 63],
                        errorMsg: global.langData.obs_term_createBucket_ruler0_valid
                    }, {
                        rule: function (value) {//禁止以"-"或"."开头及结尾
                            var val = $.trim(value);
                            var start = val.substring(0, 1);
                            var end = val.substring(val.length - 1);
                            return (start !== "-" && start !== "." && end !== "-" && end !== ".");
                        },
                        errorMsg: global.langData.obs_term_createBucket_ruler3_valid
                    },{
                        rule: function (value) {//禁止两个"."相邻
                            var val = $.trim(value);
                            return val.indexOf("..") === -1;
                        },
                        errorMsg: global.langData.obs_term_createBucket_ruler4_valid
                    },{
                        rule: function (value) {//禁止"."和"-"相邻
                            var val = $.trim(value);
                            return (val.indexOf("-.") === -1 && val.indexOf(".-") === -1);
                        },
                        errorMsg: global.langData.obs_term_createBucket_ruler5_valid
                    },{
                        rule: function (value) {//禁止使用IP地址
                            var val = $.trim(value);
                            var regIp = /^(25[0-5]|2[0-4]\d|[01]?\d\d?)\.(25[0-5]|2[0-4]\d|[01]?\d\d?)\.(25[0-5]|2[0-4]\d|[01]?\d\d?)\.(25[0-5]|2[0-4]\d|[01]?\d\d?)$/i;
                            return !regIp.test(val)
                        },
                        errorMsg: global.langData.obs_term_createBucket_ruler2_valid
                    }]
                }
            };
        }]);
        angular.bootstrap($('#createBucketPage'), ['createBucketModule']);
        angular.bootstrap($('#lifecycleChild'), ['createBucketModule']);
        angular.bootstrap($('#model'), ['createBucketModule']);
    });
}
//桶存储类别
function changeStorageCtrl() {
    requirejs([], function () {
        var module = angular.module('changeStorageModule', ['tiny']);

        module.controller('changeStorageCtrl', ['$scope', function ($scope) {
            $scope.coldlineSwitch = pkg.coldline;
            $scope.bucket = {
                storageTypeList: [
                    {
                        key: "Standard",
                        value: global.langData.obs_term_standard_lable,
                        desc: global.langData.obs_term_standard_tip,
                        disable: false
                    }, {
                        key: "Nearline",
                        value: commonUtils.termStorageClass("Nearline"),
                        desc: global.langData.obs_term_nearline_tip,
                        disable: false
                    }, {
                        key: "Coldline",
                        value: commonUtils.termStorageClass("Coldline"),
                        desc: global.langData.obs_term_coldline_tip,
                        disable: false
                    }
                ]
            }
            $scope.bucket.selected = {
                // 设置默认选中值，后续$scope.selected.value会根据用户的选择而动态改变
                value: $scope.bucket.storageTypeList[0].value
            }
            $scope.bucket.description = $scope.bucket.storageTypeList[0].desc;
            if (_.isEqual(UCDVersion, "HEC") || _.isEqual(UCDVersion, "HK")){
                $scope.bucket.obejctNotRestoreTip = global.langData.obs_term_changeStorageClass_archiveObejctNotRestore_tip;
            } else {
                $scope.bucket.obejctNotRestoreTip = global.langData.obs_term_changeStorageClass_coldObejctNotRestore_tip;
            }
            $scope.bucket.azBucketCanNotChange2ArchiveTip = "";
            $scope.bucket.changeType = function () {
                var selectBucketStorageClass = $('#bucketLists .selected-tr-active').find('td').eq(1).text();
                if(selectBucketStorageClass === commonUtils.termStorageClass("Coldline") && $scope.bucket.selected.value !== 'Coldline'){
                    $('#obejctNotRestoreTip').removeClass('mui-hide');
                }else{
                    $('#obejctNotRestoreTip').addClass('mui-hide');
                }
                if($scope.bucket.selected.value !== 'Coldline'){
                    $('#azBucketCanNotChange2ArchiveTip').addClass('mui-hide');
                }else {
                    $('#azBucketCanNotChange2ArchiveTip').removeClass('mui-hide');
                }
                for (var index in $scope.bucket.storageTypeList) {
                    if ($scope.bucket.storageTypeList[index].key == $scope.bucket.selected.value) {
                        $scope.bucket.description = $scope.bucket.storageTypeList[index].desc
                    }
                }
            }
        }]);
        angular.bootstrap($('#changeStorageType'), ['changeStorageModule']);
    });
}
//对象存储类别
function changeObjectStorageCtrl() {
    requirejs([], function () {
        var module = angular.module('changeObjectStorageModule', ['tiny']);

        module.controller('changeObjectStorageCtrl', ['$scope', function ($scope) {
            $scope.coldlineSwitch = pkg.objectColdline;
            $scope.object = {
                storageTypeList: [
                    {
                        key: "Standard",
                        value: global.langData.obs_term_standard_lable,
                        desc: global.langData.obs_term_standard_tip,
                        disable: false
                    }, {
                        key: "Nearline",
                        value: commonUtils.termStorageClass("Nearline"),
                        desc: global.langData.obs_term_nearline_tip,
                        disable: false
                    }, {
                        key: "Coldline",
                        value: commonUtils.termStorageClass("Coldline"),
                        desc: global.langData.obs_term_coldline_tip,
                        disable: false
                    }
                ]
            }
            $scope.file = {
                Status:[
                    {
                        key: global.langData.enable,
                        value: global.langData.enable,
                        desc: global.langData.obs_term_uploadSync_enable_tip,
                        disable: false
                    }, {
                        key: global.langData.disable,
                        value: global.langData.disable,
                        desc: global.langData.obs_term_uploadSync_disable_tip,
                        disable: false
                    }
                ]
            }
            $scope.file.selected = {
                // 设置默认选中值，后续$scope.selected.value会根据用户的选择而动态改变
                value: $scope.file.Status[1].value
            }
            $scope.file.description = $scope.file.Status[1].desc;
            $scope.object.selected = {
                // 设置默认选中值，后续$scope.selected.value会根据用户的选择而动态改变
                value: $scope.object.storageTypeList[0].value
            }
            $scope.object.description = $scope.object.storageTypeList[0].desc;
            $scope.file.changeType = function () {
                for (var index in $scope.file.Status) {
                    if ($scope.file.Status[index].key == $scope.file.selected.value) {
                        $scope.file.description = $scope.file.Status[index].desc
                    }
                }
            }
            $scope.object.changeType = function () {
                for (var index in $scope.object.storageTypeList) {
                    if ($scope.object.storageTypeList[index].key == $scope.object.selected.value) {
                        $scope.object.description = $scope.object.storageTypeList[index].desc
                    }
                }
            }
        }]);
        angular.bootstrap($('#uploadFileDialog'), ['changeObjectStorageModule']);
        angular.bootstrap($('#uploadFolderDialog'), ['changeObjectStorageModule']);
        angular.bootstrap($('#changeStorageClass'), ['changeObjectStorageModule']);
    });
}
//日志管理校验
function LoggingCtrl() {
    requirejs([], function () {
        var module = angular.module('LoggingModule', ['tiny']);
        module.controller('LoggingCtrl', ['$scope', 'tiValid', function ($scope, tiValid) {
            $scope.bucketLogging = {
                enable:global.langData.startUse,
                disable:global.langData.stopUse
            }
            $scope.Logging = {
                LoggingValidate: {
                    "validator": [{
                        rule: function (value) {//特殊字符校验
                            var val = $.trim(value);
                            return !/[\\"<>:|\?\*]/gi.test(val);
                        },
                        errorMsg: global.langData.obs_term_bucketLogging_rule2_valid
                    }, {
                        rule: function (value) {//斜线校验
                            var val = $.trim(value);
                            var start = val.substring(0, 1);
                            if (start === "/") {
                                return false;
                            }
                            // 判断是否包含两个及以上连续斜线
                            if (val.indexOf("//") !== -1) {
                                return false;
                            }
                            return true;
                        },
                        errorMsg: global.langData.obs_term_bucketLogging_rule3_valid
                    }, {
                        rule: function (value) {//点校验
                            var val = $.trim(value);
                            var folders = val.split("/");
                            var folder = "";
                            for (var i = 0; i < folders.length; i++) {
                                folder = folders[i];
                                var start = folder.substring(0, 1);
                                var end = folder.substring(folder.length - 1, folder.length);
                                if (start === "." || end === ".") {
                                    return false;
                                }
                            }
                            return true;
                        },
                        errorMsg: global.langData.obs_term_bucketLogging_rule4_valid
                    }, {
                        rule: function (value) {//长度校验
                            var val = $.trim(value);
                            var length = AWS.util.string.byteLength(val);
                            if (length > 254) { //254
                                return false;
                            }
                            return true;
                        },
                        errorMsg: global.langData.obs_term_bucketLogging_rule5_valid
                    }]
                }
            };
        }]);
        angular.bootstrap($('#bucketLogging'), ['LoggingModule']);
    });
}
//路径输入提示
function PathCtrl() {
    requirejs([], function () {
        var module = angular.module('PathModule', ['tiny']);

        module.controller('PathCtrl', ['$scope', 'tiValid', function ($scope, tiValid) {
            $scope.PathInput = {
                PathValidate: {
                    "validator": [{//必填提示
                        rule: "required",
                        errorMsg: global.langData.obs_browser_path_hint
                    }],
                    "position": "right"
                },
                cleanInvalidate: function () {
                    tiValid.clearInValid($("#pathInput"));
                }
            };
            $scope.supportCollectPath = pkg.isSupportCollectPath;
        }]);
        angular.bootstrap($('#breadPath'), ['PathModule']);
    });
}

//日历选择
function DateCtrl() {
        requirejs([], function () {
            var module = angular.module("DateCtrlModule", ["tiny"]);

            module.controller('DateCtrl', function ($scope) {
                $scope.dateOptions = {
                    format : "yyyy.MM.dd",
                    value : {
                        begin : new Date(2011, 5, 6),
                        end: null
                    },
                    elementId: 'date_range_test',
                    minValue : null,
                    maxValue : new Date(2019, 8, 27),
                    disable : false
                };

                $scope.changeValue = function() {
                    $scope.dateOptions.value = {
                        begin : new Date(2012, 7, 8),
                        end: new Date(2012, 7, 8)
                    };
                };

                $scope.getValue = function() {
                    $scope.currentValue = "cuurent value.begin is: " + $scope.dateOptions.value.begin;
                    $scope.currentValue1 = "cuurent value.end is: " + $scope.dateOptions.value.end;
                }
            });

            angular.bootstrap($("#exportData"), ["DateCtrlModule"]);
        })
}
/**
 * 菜单控制
 */
function ctxMenuCtrl() {
    requirejs([], function () {
        var module = angular.module('ctxMenuModule', ['ngAnimate', 'tiny']);

        module.controller('ctxMenuCtrl', function ($scope, tiModal) {
            //點擊刪除按鈕時，触发次方法
            $scope.openDelConfirm = function () {
                //获取通列表选中的tr元素里面的桶信息
                var isDisabled = false;//是否禁用OK键
                var name = $("#bucketLists .selected-tr-active [name='bucketBodyItem']").text();
                var region = $("#bucketLists .selected-tr-active [name='region']").text();
                var storageClass = $("#bucketLists .selected-tr-active [name='storageClass']").text();
                //构造modal内置table的header
                var head = [
                    [global.langData.bucketNameInTable, "50%"],
                ];
                //构造modal内置table的body，为了使html模板能通用，这里必须定义为二维数组
                var body = [
                    [
                        [name, "50%"]
                    ]
                ];
                //如果是温冷存储开启，则添加温冷类型信息
                if(pkg.coldline) {
                    head.push([global.langData.obs_term_storageClass_lable, "25%"]);
                    head.push([global.langData.obs_term_region_column, "25%"]);
                    //bucket不能批量删除，所以只有一组数据
                    body[0].push([storageClass, "25%"]);
                    body[0].push([region, "25%"]);
                } else {
                    head.push([global.langData.obs_term_region_column, "50%"]);
                    body[0].push([region, "50%"]);
                }
                var loading = loadingShow();
                //打开modal窗口，参考tinyui2：http://tinyui.huawei.com/tinyui2/index.html#/api/modal
                s3.listObjectVersions({Bucket: name},function(err,data){
                    loading.close();
                    var tip1 = global.langData.obs_term_deleteBucket_tips;
                    if(data&&(data.DeleteMarkers.length>0||data.Versions.length>0||data.CommonPrefixes.length>0)){
                        isDisabled = true;
                        tip1 = global.langData.obs_deleteBucket_tips;
                    }
                    var modalInstance = tiModal.open({
                        templateUrl: 'html_template/deleteBucket.html',
                        controller: 'modalInstanceCtrl',
                        modalClass: "obs-ti-modal-class",
                        closeOnEsc: false,
                        draggable: false,
                        //参数传递
                        resolve: {
                            items: {
                                message: global.langData.isSureDeleteBucket,
                                title: global.langData.deleteBucket,
                                head: head,
                                body: body,
                                ButtonDisbaled:isDisabled,
                                tip:global.langData.obs_term_deleteWarn_msg,
                                tip1:tip1,
                                OK: function () {
                                    var bName = $("#curBucketName").html();
                                    deleteBucketOK(bName);
                                }
                            }
                        }
                    });
                })
            };
            $scope.openBucketUnlink = function () {
                var isDisabled = false;//是否禁用OK键
                //获取通列表选中的tr元素里面的桶信息
                var name = $("#bucketLists .selected-tr-active [name='bucketBodyItem']").text();
                var region = $("#bucketLists .selected-tr-active [name='region']").text();
                var storageClass = $("#bucketLists .selected-tr-active [name='storageClass']").text();
                //构造modal内置table的header
                var head = [
                    [global.langData.bucketNameInTable, "50%"],
                ];
                //构造modal内置table的body，为了使html模板能通用，这里必须定义为二维数组
                var body = [
                    [
                        [name, "50%"]
                    ]
                ];
                //如果是温冷存储开启，则添加温冷类型信息
                if(pkg.coldline) {
                    head.push([global.langData.obs_term_storageClass_lable, "25%"]);
                    head.push([global.langData.obs_term_region_column, "25%"]);
                    //bucket不能批量删除，所以只有一组数据
                    body[0].push([storageClass, "25%"]);
                    body[0].push([region, "25%"]);
                } else {
                    head.push([global.langData.obs_term_region_column, "50%"]);
                    body[0].push([region, "50%"]);
                }
                //打开modal窗口，参考tinyui2：http://tinyui.huawei.com/tinyui2/index.html#/api/modal
                var modalInstance = tiModal.open({
                    templateUrl: 'html_template/deleteDetail.html',
                    controller: 'modalInstanceCtrl',
                    modalClass: "obs-ti-modal-class",
                    closeOnEsc: false,
                    draggable: false,
                    //参数传递
                    resolve: {
                        items: {
                            message: global.langData.obs_term_unlinkBucket_msg,
                            title: global.langData.obs_term_unlinkBucket_Wintitle,
                            head: head,
                            body: body,
                            ButtonDisbaled:isDisabled,
                            tip1:global.langData.obs_term_unlinkBucket_warn_msg,
                            tip:global.langData.obs_term_unlinkBucket_warn_msg,
                            OK: function () {
                                var bName = $("#curBucketName").html();
                                deleteBucketOK(bName);
                            }
                        }
                    }
                });
            };
        });
        /**
         * 删除桶弹出框控制器
         */
        module.controller('modalInstanceCtrl', function ($scope, tiModalInstance, items) {
            $scope.OK = global.langData.ok;
            $scope.Cancel = global.langData.cancel;
            $scope.warnMessage = items.message;
            $scope.title = items.title;
            $scope.tableItems = items.body;
            $scope.tableHeads = items.head;
            $scope.tip1 = items.tip1;
            $scope.tip = items.tip;
            $scope.isDisable = items.ButtonDisbaled;
            $scope.ok = function () {
                   tiModalInstance.close();
                   items.OK();
               };

            $scope.cancel = function () {
                tiModalInstance.dismiss('cancel');
            };
        });

        angular.bootstrap($("#bucketCtxMenuId"), ["ctxMenuModule"]);
    })
}

function checkObjectRestore(key, cb) {
    var bucket = $("#curBucketName").html();
    bucketAndObjectAction.headObject(bucket, key, function (err, data) {
        if (data && data.Restore && data.Restore.indexOf('ongoing-request="true"') > -1) {
            $("#recoverBtn").addClass('mui-disabled');
            $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreUnavailable_tip);
            updateRestoreStatCache(key,languageJson.obs_term_restoring_lable);
        } else {
            disabledBtn($("#recoverBtn"));
        }
        var objectStorage = getChoseObjType();
        if (objectStorage === 'Coldline' || objectStorage === "GLACIER"){
            if (data && data.Restore && data.Restore.indexOf('ongoing-request="false"') > -1) {
                disabledBtn($("#downloadbtn"));
                $(".downloadCtx").removeClass('mui-disabled-task');
                $(".downloadCtx").parent().removeAttr('title');
                updateRestoreStatCache(key,languageJson.obs_term_restored_lable);
            }else{
                $("#downloadbtn").addClass('mui-disabled');
                $(".downloadCtx").addClass('mui-disabled-task');
                $(".downloadCtx").parent().attr('title', languageJson.ERR_CODE_InvalidObjectState);
                $("#downloadbtn").attr('data-title', languageJson.obs_task_downloadUnavailable_tip);
            }
        }else{
            disabledBtn($("#downloadbtn"));
            $("#recoverBtn").addClass('mui-disabled');
        }
    });
}

function checkAddTitle($id, data) {
    $("#tempWidthDiv").html(data);
    if (!($("#tempWidthDiv").width() < $id.width())) {
        $id.attr('title', data);
    } else {
        $id.attr('title', "");
    }
}