/**
 * Created on 5/18/2017.
 */
var TaskEnum = require("./js/common/TaskEnum.js");
var CopyMoveComponent = require("./js/component/CopyMoveComponent.js");

global.glbClipboard = {

    action: "",
    empty: true,

    //剪贴板中的内容，如果多选，则有多项包括bucket,key,size,objName,location,isFolder.
    contents: [],


    /**
     * 添加多个选中的对象
     * @param bucket  多个选中对象的桶名
     * @param location 多个选中对象的location
     * @param action   操作名称，是move还是copy
     * @param data     选中对象的数组 {key,size,name,.isFolder}
     */
    addAll: function (bucket, location, action,sourceFsStatus, data) {
        this.clean();
        if (!data) {
            data = [];
        }
        for (let item of data) {
            this.add(bucket, item.key, item.size, item.name, item.isFolder, location, action,sourceFsStatus, false);
        }
    },

    add: function (bucket, key, size, objName, isFolder, location, action, sourceFsStatus, isClean = true) {
        if (isClean) {
            this.clean();
        }
        this.action = action;
        this.empty = false;
        this.bucket = bucket;
        this.location = location;
        this.contents.push({
            bucket: bucket,
            objName: objName,
            isFolder: isFolder,
            key: key,
            size: size,
            location: location,
            modifyTime: new Date(),
            sourceFsStatus: sourceFsStatus
        })
    },
    clean: function () {
        this.action = "";
        this.empty = true;
        this.location = "";
        this.bucket = "";
        this.contents = [];
        $("#pastebtn").text(languageJson.obs_term_pasteObject_button);
        $("#pastebtn").addClass("mui-disabled");
    }


}

function doAction(action) {
    "use strict";
    var objKey = getChoseObjKey();
    var objSize = getChoseObSize();
    var bucket = $("#curBucketName").html();
    var objName = getChoseObjName();
    var isFolder = activeIsFolder();
    var curPath = getCurrPath();
    var sourceFsStatus = global.curFileInterface;
    global.glbClipboard.add(bucket, objKey, objSize, objName, isFolder, curPath, action,sourceFsStatus);
    var number = "(" + global.glbClipboard.contents.length + ")";
    if(action === TaskEnum.TASK_TYPE.copy.value){
        var copyShow = languageJson.obs_term_copyObject_button + number;
        $("#copybtn").text(copyShow);
        $("#movebtn").text(languageJson.obs_term_moveObject_button);
    }
    if(action === TaskEnum.TASK_TYPE.move.value){
        var moveShow = languageJson.obs_term_moveObject_button  + number;
        $("#movebtn").text(moveShow);
        $("#copybtn").text(languageJson.obs_term_copyObject_button);
    }
}

$(".copyCtx").click(function () {
    "use strict";
    doAction(TaskEnum.TASK_TYPE.copy.value);
})

$(".moveCtx").click(function () {
    "use strict";
    doAction(TaskEnum.TASK_TYPE.move.value);
})

$(".pasteCtx").click(function () {
    "use strict";
    function paste() {
        var showAnimate = true;
        setTimeout(function(){
            if(showAnimate) {
                showCreateTasksAnimation();
            }
        }, 1500)
        var targetBucket = $("#curBucketName").html();
        var targetPath = getCurrPath();
        var copyMoveComponent = new CopyMoveComponent(taskControlAction, taskManager, targetBucket, targetPath);
        taskManager.setAbortAll(false);
        taskManager.setPauseAll(false);
        copyMoveComponent.doPaste(function (err) {
            if(err) {
                showAnimate = false;
                $(".mui-model").showMessage({
                    type: "warning",
                    message: obsError(err.code).description,
                    ok: function () {
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        return;
                    },
                    title: global.langData.warning
                });
            }
            if (global.glbClipboard.action === TaskEnum.TASK_TYPE.move.value) {
                global.glbClipboard.clean();
            }
        });
    }
    var bucket = $("#curBucketName").html();
    var prefix = getCurrPath();
    if(global.glbClipboard.contents.length === 1 && !global.glbClipboard.contents[0].isFolder){
        var loading =loadingShow();
        var objName = global.glbClipboard.contents[0].objName;
        bucketAndObjectAction.headObject(bucket,prefix+objName,function (err,data) {
            loading.close();
            if(err){
                if(err.code === "NoSuchKey"){
                    if(global.glbClipboard.action === TaskEnum.TASK_TYPE.move.value) {
                        $(".mui-model").showMessage({
                            type: "warning",
                            message: global.langData.obs_term_moveObject_msg,
                            ok: function () {
                                if ($("#mui-overlay").size() > 0) {
                                    mui.overlay('off');
                                }
                                paste();
                            },
                            cancel: function () {
                                if ($("#mui-overlay").size() > 0) {
                                    mui.overlay('off');
                                }
                                return false;
                            },
                            title: global.langData.warning
                        });
                        showOverlay();
                    } else {
                        paste();
                    }
                }else{
                    if(errorConfig[err.code]){
                        $('.mui-model').showErrorMessage({
                            message: errorConfig[err.code],
                            obsError: obsError(err.code,err.message),
                            ok: function () {
                                return false;
                            }
                        });
                    }
                }
            }else{
                $("#objLists tr.selected-tr-active").removeClass('selected-tr-active');
                $(".isCopy").removeClass("mui-hide");
                var message = languageJson.obs_term_pasteObject_msg.format(CommonUtils.substr32(objName))
                $("#copyNmae").html(message);
                $("#newName").val(objName);
                $(".mui-page-full.shown").removeClass('shown');
                $("#ObjectRename").addClass('shown');
                $("#ObjectRename").css('z-index',"1000");
                $("#ObjectRename").removeClass('mui-hide');
                $("#newName").focus();
                if(global.glbClipboard.action === TaskEnum.TASK_TYPE.move.value){
                    $("#moveTips").removeClass("mui-hide");
                }else{
                    $("#moveTips").addClass("mui-hide");
                }
                divDragFunc('ObjectRenameDrag', 'ObjectRename');
                showOverlay();
                return false;
            }
        })
    }else{
        if(global.glbClipboard.action === TaskEnum.TASK_TYPE.move.value) {
            $(".mui-model").showMessage({
                type: "warning",
                message: global.langData.obs_term_moveObject_msg,
                ok: function () {
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                    paste();
                },
                cancel: function () {
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                    return false;
                },
                title: global.langData.warning
            });
            showOverlay();
        } else {
            $(".mui-model").showMessage({
                type: "warning",
                message: global.langData.obs_term_pasteMultiObject_msg,
                ok: function () {
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                    paste();
                },
                cancel: function () {
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                    return false;
                },
                title: global.langData.warning
            });
            showOverlay();
        }
    }
})
