/**
 * Created on 2017/3/23.
 */
function objButtonCtrl() {
    requirejs([], function () {
        var module = angular.module('objButtonModule', ['tiny']);
        /**
         * 上传对象按钮显示tips
         */
        module.controller('objButtonCtrl', function ($scope, tiModal, tiValid) {
            $scope.uploadButton = {
                content: global.langData.uploadOverwriteTip,
                position: "top-left",
                value: global.langData.upload,
                hideEffect: {
                    duration: 100
                },
                showEffect: {
                    duration: 100
                }
            };
            //点击删除object时触发的动作，包括顶部按钮和右侧删除图标
            $scope.openObjDelConfirm = function () {
                if ($("#btnDeleteObjects").hasClass('mui-disabled')) {
                    return false;
                }
                var bucketName = $('#curBucketName').html();
                var parentPath = getCurrPath();
                //删除对象从选择列表中获取
                var filename = [];
                var lis = $("#objLists tr.selected-tr-active>td:last-child");
                /**
                 *
                 * 如果是文件，则获取到dom对应的text是这样{"name":"94K_23","size":"94.00 KB","dataSize":96256,"modifyTime":" 12/30/2016 17:39:46 GMT+08:00"}
                 * 如果是文件夹，则是：{"name":"test10/测试数据/10000小对象1k-100k/"}
                 */
                var nameSize = {};
                async.forEachSeries(lis, function (li, callback) {
                    var obj = JSON.parse($(li).text());
                    if (obj.size) {
                        //有size属性则说明是文件
                        nameSize[parentPath + obj.name] = obj.dataSize;
                        filename.push(parentPath + obj.name);
                    } else {
                        filename.push(obj.name);
                    }
                    callback();
                }, function (err) {
                    if (err) {
                        logger.error('err: ' + err);
                    }
                });
                //校验所选文件夹或文件下是否有未完成的任务
                deletedCheck(filename, bucketName, function (result) {
                    if (result) {
                        //存在未完成的任务，禁止删除
                        $('.mui-model').showMessage({
                            type: "warning",
                            message: global.langData.selectDeleteObject1,
                            ok: function () {
                                return false;
                            },
                            title: global.langData.warning
                        });
                        return false;
                    } else {
                        //没有任务执行，开始处理删除逻辑
                        if (!filename) {
                            $('.mui-model').showMessage({
                                type: "warning",
                                message: global.langData.selectDeleteObject,
                                ok: function () {
                                    return false;
                                },
                                title: global.langData.warning
                            });
                            return false;
                        }
                        showOverlay();
                        var delBody = [];
                        var typeArr = [];
                        //获取选中对象的信息
                        $("#objLists .selected-tr-active").each(function (index, obj) {
                            var showKey = $(obj).find("[name='showKey']").text();
                            var fileType = $(obj).find("[name='fileType']").text();
                            var date = $(obj).find("[name='date']").text();
                            var type = $(obj).attr('data-type');
                            var storageClass = $(obj).find('td').eq(2).children('span').text();
                            var fileSize = $(obj).find('td').eq(4).children('span').text();
                            var line = [
                                [showKey.trim(), "50%"],
                                [storageClass.trim(), "20%"],
                                [fileSize.trim(), "30%"]
                            ];
                            delBody.push(line);
                            typeArr.push(type);
                        })
                        var msg;
                        var titleName;
                        var tip1 = global.langData.obs_term_delObject_disableVersion_tip;
                        var tip2 = global.langData.obs_term_delObject_enableVersion_tip;
                        if (delBody.length > 1){
                            if(typeArr.indexOf('file')==-1){
                                msg = CommonUtils.format(global.langData.obs_term_objectManage_delMultiFolder_msg, delBody.length);
                                titleName =global.langData.obs_term_delFolder_wintitle;
                                tip1 = global.langData.obs_term_delFolder_disableVersion_tip;
                                tip2 = global.langData.obs_term_delFolder_enableVersion_tip;
                            }else{
                                msg = CommonUtils.format(global.langData.obs_term_objectManage_delMultiObject_msg, delBody.length);
                                titleName = global.langData.obs_task_deleteObject_wintitle;
                            }

                        } else {
                            //判断选中的是文件还是文件夹
                            var thisTrType = $("#objLists .selected-tr-active").attr('data-type');
                            if(thisTrType == "folder"){
                                msg = global.langData.isSureDeleteFolder;
                                titleName =global.langData.obs_term_delFolder_wintitle;
                                tip1 = global.langData.obs_term_delFolder_disableVersion_tip;
                                tip2 = global.langData.obs_term_delFolder_enableVersion_tip;
                            }else {
                                msg = global.langData.isSureDeleteObjcet;
                                titleName = global.langData.obs_task_deleteObject_wintitle;
                            }

                        }

                        //打开modal窗口，参考tinyui2：http://tinyui.huawei.com/tinyui2/index.html#/api/modal
                        var modalInstance = tiModal.open({
                            templateUrl: 'html_template/deleteDetail.html',
                            controller: 'modalInstanceCtrl',
                            modalClass: "obs-ti-modal-class",
                            closeOnEsc: false,
                            draggable: false,
                            resolve: {
                                items: {
                                    message: msg,
                                    title:titleName,
                                    tip1:tip1,
                                    tip2:tip2,
                                    head: [
                                        [global.langData.object, "50%"],
                                        [global.langData.obs_term_storageClass_lable, "20%"],
                                        [global.langData.size, "30%"]
                                    ],
                                    body: delBody,
                                    OK: function () {
                                        deleteObjectOK(bucketName, filename, parentPath, nameSize);
                                    }
                                }
                            }
                        });
                    }
                });
                taskControlAction.checkDBData();
            };
            $scope.cleanInvalidate = function () {
                tiValid.clearInValid($("#floderName"));
            }
        });
        /**
         * 删除桶弹出框控制器
         */
        module.controller('modalInstanceCtrl', function ($scope, tiModalInstance, items) {
            $scope.OK = global.langData.ok;
            $scope.Cancel = global.langData.cancel;
            $scope.warnMessage = items.message;
            $scope.title = items.title;
            $scope.tableItems = items.body;
            $scope.tableHeads = items.head;
            $scope.tip1 = items.tip1;
            $scope.tip2 = items.tip2;
            $scope.ok = function () {
                tiModalInstance.close();
                items.OK();
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
            };
            $scope.cancel = function () {
                tiModalInstance.dismiss('cancel');
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
            };
        });

        angular.bootstrap($('#objectBtnDiv'), ['objButtonModule']);
    });
}
//创建文件夹验证
function createFloderCtrl() {
    requirejs([], function () {
        var module = angular.module('createFloderModule', ['tiny']);

        module.controller('createFloderCtrl', ['$scope', 'tiValid', function ($scope, tiValid) {
            $scope.createFloder = {
                floderNameValidate: {

                    "validator": [{
                        "rule": function notEmptyFn(value) {
                            var val = $.trim(value);
                            return val.length > 0;
                        },
                        "errorMsg": global.langData.InputFolderName
                    }, {
                        "rule": function characterFn(value) {
                            var val = $.trim(value);
                            return !/[\\“”？"<>:|\?\*／＼＂＜＞：｜＊]/gi.test(val);
                        },
                        "errorMsg": global.langData.obs_term_createFolder_ruler2_valid
                    }, {
                        "rule": function followFn(value) {
                            var val = $.trim(value);

                            if (val === "." || val === "..") {
                                return false;
                            }
                            //带有多层文件夹的目录不能以.开头和结尾
                            return !/(\/\.)|(\.\/)/gi.test(val);
                        },
                        "errorMsg": global.langData.obs_term_createFolder_ruler3_valid
                    }, {
                        "rule": function startFn(value) {
                            var val = $.trim(value);
                            var start = val.substring(0, 1);
                            var end = val.substring(val.length - 1, val.length);
                            if (start === "." || end === "." || start === "．" || end === "．" || start === "/" || end === "/") {
                                return false;
                            }
                            return true;
                        },
                        "errorMsg": global.langData.obs_term_createFolder_ruler3_valid
                    }, {
                        "rule": function lengthFn(value) {
                            var path = getCurrPath();
                            var folderNameChar=new Buffer(path+value.trim());
                            var folderNameLength=folderNameChar.length;
                            if(folderNameLength>1023){
                                return false;
                            }
                            return true;
                        },
                        "errorMsg": global.langData.obs_term_createFolder_ruler1_valid
                    },{
                        "rule": function followFn(value) {
                            var val = $.trim(value);
                            return val.indexOf("//") === -1;
                        },
                        "errorMsg": global.langData.obs_term_createFolder_ruler2_valid
                    }]




                    // "validator": [{
                    //     rule: function (value) {
                    //         return value.trim().length > 0;
                    //     },
                    //     errorMsg: global.langData.InputFolderName
                    // }, {
                    //     rule: function (value) {
                    //         var parrent = /[<>?:*\\|\"]/g;
                    //         if (parrent.test(value)) {
                    //             return false;
                    //         }
                    //         return true;
                    //     },
                    //     errorMsg: global.langData.inputVerification
                    // }, {
                    //     rule: function (value) {
                    //         if(value.indexOf('.')===0||value.substring(value.length-1,value.length)==='.'||value.indexOf('/')===0 ||value.substring(value.length-1,value.length)==='/'){
                    //             return false;
                    //         }
                    //         return true;
                    //     },
                    //     errorMsg: global.langData.describe_object_ruleThree
                    // }, {
                    //     rule: function (value) {
                    //         return value.indexOf("//") === -1;
                    //     },
                    //     errorMsg: global.langData.inputVerification3
                    // }, {
                    //     rule: function (value) {
                    //         var path = getCurrPath();
                    //         var folderNameChar=new Buffer(path+value.trim());
                    //         var folderNameLength=folderNameChar.length;
                    //         if(folderNameLength>1023){
                    //             return false;
                    //         }
                    //         return true;
                    //     },
                    //     errorMsg: global.langData.folderNameTooLarge
                    // }]
                }
            };
        }]);

        angular.bootstrap($('#createFolderPage'), ['createFloderModule']);
    });
}

//创建路径验证
function createPathCtrl() {
    requirejs([], function () {
        var module = angular.module('createPathModule', ['tiny']);

        module.controller('createPathCtrl', ['$scope', 'tiValid', function ($scope, tiValid) {

            $scope.createPath = {
                pathNameValidate: {
                    "validator": [{
                        rule: function (value) {
                            return value.trim().length > 0;
                        },
                        errorMsg: global.langData.obs_browser_path_hint
                    }, {
                        rule: function (value) {
                            var bucketName = value.split("/")[0];
                            var regex = new RegExp("^[a-z0-9]{1}[a-z0-9-.]{1,61}[a-z0-9]{1}$");
                            var regIp = /^(25[0-5]|2[0-4]\d|[01]?\d\d?)\.(25[0-5]|2[0-4]\d|[01]?\d\d?)\.(25[0-5]|2[0-4]\d|[01]?\d\d?)\.(25[0-5]|2[0-4]\d|[01]?\d\d?)$/i;
                            var bucketNameCriterion = !regex.test(bucketName);
                            var bucketNameNotIP = regIp.test(bucketName);
                            var bucketNameNotSpecail = bucketName.indexOf("..") > -1 || bucketName.indexOf(".-") > -1 || bucketName.indexOf("-.") > -1;
                            if(bucketNameCriterion || bucketNameNotIP || bucketNameNotSpecail){
                                return false;
                            }
                            var index = value.indexOf("/");
                            var folderPath = value.substr(index+1);
                            if(folderPath){
                                var parrent = /[<>?:*\\|\"]/g;
                                var veri = parrent.test(folderPath);
                                var nrule = folderPath.indexOf('.')===0||folderPath.substring(folderPath.length-1,folderPath.length)==='.'||folderPath.indexOf('/')===0;
                                if(veri || nrule){
                                    return false;
                                }
                            }
                            return true;
                        },
                        errorMsg: global.langData.obs_term_collectPath_valid_00002
                    }, {
                        rule: function (value) {
                            return value.indexOf("//") === -1;
                        },
                        errorMsg: global.langData.inputVerification3
                    }, {
                        rule: function (value) {
                            var pathNameLength = value.length;
                            if(pathNameLength > 1023){
                                return false;
                            }
                            return true;
                        },
                        errorMsg: global.langData.obs_term_collectPath_valid_00003
                    }]
                }
            };
        }]);

        angular.bootstrap($('#createPathPage'), ['createPathModule']);
    });
}

function createPolicyCtrl() {
    requirejs([], function () {
        var module = angular.module('createPolicyModule', ['tiny']);

        module.controller('createPolicyCtrl', ['$scope', 'tiValid', function ($scope, tiValid) {
            var accessConnector = require("./js/access/iam/IAMConnector");

            $scope.objectPolicy = undefined;
            $scope.Permissions = [
                {
                    "key": global.langData.obs_objectPolicy_read_option,
                    "id": "r",
                    "desc":global.langData.obs_objectPolicy_read_tip
                },
                {
                    "key": global.langData.obs_objectPolicy_readAndWrite_option,
                    "id": "rw",
                    "desc":global.langData.obs_objectPolicy_readAndWrite_tip
                }
            ];
            $scope.Permissions.description = $scope.Permissions[0].desc;
            $scope.Sid = undefined;
            $scope.Permissions.changeType = function () {
                for (var index in $scope.Permissions) {
                    if ($scope.Permissions[index].id == $scope.permissionSelected.value) {
                        $scope.Permissions.description = $scope.Permissions[index].desc
                    }
                }
            }
            // 选中的权限
            $scope.permissionSelected = {value: undefined};
            $scope.simplePolicyModel = {
                selectedUserId: [],
                disable: false,
                placeholder: global.langData.obs_objectPolicy_user_hint,
                options: []
            }
            $scope.resetPermission = function () {
                $scope.Permissions.description = $scope.Permissions[0].desc;
                $scope.permissionSelected.value = $scope.Permissions[0].id;
            }
            //提交新建policy
            $("#subPolicy").on("click", function () {
                var selectUserInfo = [];
                $scope.simplePolicyModel.selectedUserId.forEach(function (data) {
                    for (let userInfo of accessConnector.userCache) {
                        if (userInfo.id === data) {
                            selectUserInfo.push(userInfo);
                        }
                    }
                })
                if (selectUserInfo.length === 0) {
                    $('.mui-model').showErrorMessage({
                        type: 'error',
                        message: global.langData.obs_objectPolicy_user_hint,
                        ok: function () {
                            return false;
                        },
                        title: languageJson.errorMessage
                    });
                    return;
                }
                if ($scope.objectPolicy) {
                    var is_not_same = $scope.objectPolicy.addSimplePolicy($scope.Sid, $scope.permissionSelected.value, selectUserInfo);
                    var select_user_str = "";
                    for(var i=0;i<selectUserInfo.length;i++){
                        if(i != selectUserInfo.length-1){
                            select_user_str = select_user_str + selectUserInfo[i].name + ",";
                        }else {
                            select_user_str = select_user_str + selectUserInfo[i].name;
                        }
                    }
                    var message = languageJson.obs_objectPolicy_createRepeat_msg.format(select_user_str);
                    if(!is_not_same){
                        $('.mui-model').showErrorMessage({
                            type: 'error',
                            message: message,
                            ok: function () {
                                return false;
                            },
                            title: languageJson.errorMessage
                        });
                        return;
                    }
                }
                $("#CreatePolicy").add("mui-hide");
                $("#CreatePolicy").removeClass('shown');
                $("#Policy").css("z-index", "1000");
                loadObjectPolicyListPage($scope.objectPolicy);
            });
            //取消新建policy
            $("#cancelPolicy").on("click", function () {
                $("#CreatePolicy").add("mui-hide");
                $("#CreatePolicy").removeClass('shown');
                $("#Policy").css("z-index", "1000");
            });
        }]);
        angular.bootstrap($('#CreatePolicy'), ['createPolicyModule']);
    });
}

function loadObjectPolicyListPage(objectpolicy){
    var user = [];
    $("#allPolicy").get(0).checked = false;
    if(objectpolicy.statements.length>0){
        for(var i=0;i<objectpolicy.statements.length;i++){
            var Sid = objectpolicy.statements[i].Sid;
            var userinfo = objectpolicy.statements[i].getUserInfo();
            var username = [];
            var ids = [];
            var permission,action;
            for(var j = 0 ;j<userinfo.length;j++){
                username.push(userinfo[j].name);
                ids.push(userinfo[j].id);
            }
            if(objectpolicy.statements[i].actionToStr() === "r"){
                action = 'r';
                permission = languageJson.obs_objectPolicy_read_option;
            }else if(objectpolicy.statements[i].actionToStr() === "rw"){
                action = "rw";
                permission = languageJson.obs_objectPolicy_readAndWrite_option;
            }else{
                action = "other";
                permission = languageJson.others;
            }
            user.push(
                {
                    name:username.join(","),
                    id:ids.join("/"),
                    sid:Sid,
                    action:action,
                    permission:permission,
                    edit:global.langData.edit,
                    delete : global.langData.delete
                })
        }
        $("#PolicyTab tbody").html(renderSync("SimplePolicyTemplate", user));
    }
}

function deleteObjectOK(bucketName, filename, parentPath, nameSize) {
    if ($("#mui-overlay").size() > 0) {
        mui.overlay('off');
    }
    if (bucketName && filename) {
        var prefixSearch = $('#prefixSearch').val();
        var arr = filename;
        $("#downloadFileName").val('');
        $("#objLists tr.selected-tr-active>td:first-child").find('span').removeClass('show-span-active');
        $("#downloadbtn,#btnDeleteObjects,#recoverBtn").addClass('mui-disabled');
        $("#downloadbtn,#movebtn,#copybtn").attr('data-title', languageJson.selectFileOrFolder);
        if (UCDVersion === "HEC" || UCDVersion === "HK") {
            $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyArchive_tip);
        }else {
            $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
        }
        $("#objLists tr.selected-tr-active").removeClass('selected-tr-active');
        if (taskManager) {
            taskManager.setPauseAll(false);
            taskManager.abortAll = false;
        }
        showCreateTasksAnimation();//加载新增任务动画效果
        var showMsgTemp = true;
        var showMsgTemp2 = true;
        for (var i in arr) {
            if (arr[i].charAt(arr[i].length - 1) === '/') {
                // 如果是文件语义的文件夹需要递归删除，需要先删除子目录和文件才能删除空文件夹
                if(global.curFileInterface === "Enabled"){
                    var params = {
                        Bucket : bucketName,
                        Prefix : arr[i]
                    };
                    taskControlAction.recursiveDeleteFolder(bucketName, arr[i], '', 0, function (err) {
                        if (err && showMsgTemp2) {
                            showMsgTemp2 = false;
                            $('.mui-model').showErrorMessage({
                                message: languageJson.someObjectDelErr,
                                obsError: obsError("someObjectDelErr")
                            });
                        }
                        
                    });
                }else {
                    taskControlAction.deletePath(bucketName, arr[i], '', 0, function (err) {
                        if (err && showMsgTemp) {
                            showMsgTemp = false;
                            $('.mui-model').showErrorMessage({
                                message: languageJson.someObjectDelErr,
                                obsError: obsError("someObjectDelErr")
                            });
                        }
                    });
                }
            } else if (arr[i]) {
                taskControlAction.deleteObject(bucketName, arr[i], nameSize[arr[i]]);
            }
        }
    } else {
        $('.mui-model').showMessage({
            type: "info",
            message: languageJson.oneOrMoreDeleteObjcet,
            ok: function () {
                return false;
            },
            title: languageJson.hint
        });
    }
}
