/**
 * Created on 2017/2/20.
 */
var mongodb = require('./js/mongodb.js');
var IndexAction = require('./js/sdk/indexAction.js');
var async = require('./node_modules/async');
var Const = require('./js/common/constants.js');
var queryCompleted = false;
//是否显示下载文件错误信息
var isShowDownErrMsg = true;
function taskPanelCtrl() {
    requirejs([], function () {
        var module = angular.module('taskPanelModule', ['ngAnimate', 'tiny']);

        module.controller('taskPanelCtrl', ['$scope', '$timeout', function ($scope, $timeout) {
            $scope.activeTab = 0;
            $scope.completeTab = {
                noData: global.langData.noData,
                noRecords:global.langData.noRecords,
                columns: [
                    {
                        title: '',
                        width: "30px"
                    },
                    {
                        title: global.langData.bucketNameInTable,
                        width: "150px"
                    }, {
                        title: global.langData.name,
                        width: "auto"
                    },
                    {
                        title: global.langData.type,
                        width: "100px"
                    },
                    {
                        title: global.langData.size,
                        width: "100px"
                    },
                    {
                        title: global.langData.statusInTable,
                        width: "138px"
                    },
                    {
                        title: global.langData.obs_term_completed_tab,
                        width: "200px"
                    },
                    {
                        title: global.langData.operating,
                        width: "80px"
                    }

                ]
            };
            // 定义选择的CheckBox
            $scope.completeTab.selected = [] ;
            $scope.completeTab.select_all = false;
            $scope.completeTab.m = []; // 保存每个CheckBox的选中状态
            $scope.completeTab.updateSelection = function($event,id){
                var checkbox = $event.target ;
                var checked = checkbox.checked ;
                if(checked){
                    $scope.completeTab.selected.push(id) ;
                    $scope.completeTab.m[id] = true;
                }else{
                    var idx = $scope.completeTab.selected.indexOf(id) ;
                    $scope.completeTab.selected.splice(idx,1) ;
                    $scope.completeTab.m[id] = false;
                }
                if ($scope.completeTab.doneData.length === $scope.completeTab.selected.length) {
                    $scope.completeTab.select_all = true;
                } else {
                    $scope.completeTab.select_all = false;
                }
            };
            // CheckBox全选
            $scope.completeTab.selectAll = function ($event) {
                var checkbox = $event.target ;
                var checked = checkbox.checked ;
                if(checked) {
                    $scope.completeTab.select_all = true;
                    angular.forEach($scope.completeTab.doneData, function (i) {
                        $scope.completeTab.m[i.id] = true;
                        var index = $scope.completeTab.selected.indexOf(i.id) ;
                        if(index === -1){
                            $scope.completeTab.selected.push(i.id);
                        }
                    });
                }else {
                    $scope.completeTab.select_all = false;
                    angular.forEach($scope.completeTab.doneData, function (i) {
                        $scope.completeTab.m[i.id] = false;
                        $scope.completeTab.selected = [];
                    })
                }
            };
            $scope.completeTab.srcData = {
                state: {
                    filter: false, // 源数据未进行过滤处理
                    sort: false, // 源数据未进行排序处理
                    pagination: true // 后台分页时将其置为true，标识数据从后台返回时已经进行了分页处理
                }
            }
            $scope.completeTab.totalItems = 0;
            $scope.completeTab.currentPage = 1;

            $scope.completeTab.pageSize = {
                size: 10,
                options: [10, 20, 50]
            };
            $scope.completeTab.typeSelectedId = "allType";
            //注意，这里其他类型放在后面
            $scope.completeTab.typeOptions = [
                {
                    id: "allType",
                    label: CommonUtils.convertTaskType("allType")
                }, {
                    id: "putObj",
                    label: CommonUtils.convertTaskType("putObj")
                }, {
                    id: "getObj",
                    label: CommonUtils.convertTaskType("getObj")
                }, {
                    id: "delete",
                    label: CommonUtils.convertTaskType("delete")
                }
            ];
            $scope.completeTab.changedType = "allType";
            //下拉框选择任务类型后刷新
            $scope.completeTab.changeType = function (option) {
                $scope.completeTab.currentPage = 1;
                //这里只需要更变一下页码就行，真正获取数据并刷新页面是由tableStateUpdate完成的
                if (option.id && option.id != "allType") {
                    $scope.completeTab.changedType = option.id;
                } else {
                    //如果是所有类型，则过滤条件为空
                    $scope.completeTab.changedType = "allType";
                }
                findAndAddData({type: $scope.completeTab.changedType}, $scope.completeTab.pageSize.size, 1);
                $scope.completeTab.currentPage = 1;
                clearCompletedCheckBoxStatus();
            }
            function clearCompletedCheckBoxStatus() {
                $scope.completeTab.selected = [] ;
                $scope.completeTab.select_all = false;
                $scope.completeTab.m = [];
            }
            $scope.completeTab.pageNumChange = function (currentPage, pageSizeNum, totalItems) {
                clearCompletedCheckBoxStatus();
            };
            $scope.completeTab.pageUpdate = function (currentPage, pageSizeNum, totalItems) {
                clearCompletedCheckBoxStatus();
            }
            //点击选项夹时刷新任务界面
            $scope.completeTab.refreshComplete = function () {
                $scope.activeTab = 1;
                queryCompleted = true;
                findAndAddData({type: $scope.completeTab.changedType}, $scope.completeTab.pageSize.size, 1);
                $scope.completeTab.currentPage = 1;
            }
            //删除单个任务后刷新任务界面
            $scope.completeTab.delCompletedTask = function (id) {
                deleteSingleTask(id, false, function () {
                    if($scope.completeTab.pageSize.size >= $scope.completeTab.totalItems - 1) {
                        //避免出现分页器消失后（页面大小大于总数），无法触发tableStateUpdate事件，导致无法回到第一页的情况
                        $scope.completeTab.currentPage = 1;
                    }
                    findAndAddData({type: $scope.completeTab.changedType}, $scope.completeTab.pageSize.size, $scope.completeTab.currentPage);
                });
            }
            //删除所有任务后刷新界面
            $scope.completeTab.delAllCompletedTask = function () {
                deleteAllTasks($scope.completeTab.changedType, function () {
                    findAndAddData({type: $scope.completeTab.changedType}, $scope.completeTab.pageSize.size, 1);
                })
            }
            //删除选中的任务后刷新界面
            $scope.completeTab.delSelectedCompletedTask = function () {
                deleteSelectedCompletedTask($scope.completeTab.selected, function () {
                    findAndAddData({type: $scope.completeTab.changedType}, $scope.completeTab.pageSize.size, 1);
                    $scope.completeTab.selected = [] ;
                    $scope.completeTab.select_all = false;
                });

            }
            //当table数据发生变化后刷新
            $scope.completeTab.tableStateUpdate = function (tableState) {
                var pagination = tableState.pagination;

                findAndAddData({type: $scope.completeTab.changedType}, pagination.itemsPerPage, pagination.currentPage, true);
                // return true 表示在回调中更新了表格数据，控件获得该返回值后，可以做进一步处理
                // 如果在回调中未更新表格数据，则可以不返回值或者是返回false
                return true;
            }
            $scope.completeTab.doneData = [];
            /**
             * 查询数据库，并将结果赋值到table数据源中
             * @param pageSize
             * @param curPage
             */
            function findAndAddData(params, pageSize, curPage, notUpdatePagination) {
                function doQueryTask() {
                    if (params && params.type == 'allType') {
                        params = {};
                    }
                    params.$or = [
                        {stat: "SUCCESS"},
                        {stat: "MD5SUCCESS"},
                        {stat: "skip"}
                    ]
                    params.userId = currentUserId;
                    mongodb.count(params, function (err, data) {
                        if (err) {
                            global.logger.error("count tasks failed...");
                        }
                        if(!notUpdatePagination) {
                            $scope.completeTab.totalItems = data;
                        }
                        var indexAction = new IndexAction();
                        $scope.completeTab.numberOfTasks = indexAction.formatNumber(encoderForHtml(data),language,true);
                        if(data > Const("COMPLETED_TASK_NOT_SORT_NUM")) {
                            var sortParam = {};
                        } else {
                            var sortParam = {
                                endTime: -1
                            }
                        }
                        mongodb.listWithSort(params, pageSize, curPage, sortParam, function (err, data) {
                            $scope.completeTab.doneData = data;
                            for (var index in data) {
                                $scope.completeTab.doneData[index]["size"] = indexAction.getFileSize(data[index].size, 'task', language);
                                $scope.completeTab.doneData[index]["statSymbol"] = data[index].stat;
                                $scope.completeTab.doneData[index]["stat"] = CommonUtils.convertTaskType(data[index].stat);
                                $scope.completeTab.doneData[index]["type"] = CommonUtils.convertTaskType(data[index].type);
                                $scope.completeTab.doneData[index]["endTime"] = data[index].endTime ? indexAction.gmtDate2LocaleDate(data[index].endTime.toString(), language) : "--";
                            }
                            // $scope.$apply();
                        })
                    })
                }

                try {
                    if (queryCompleted) {
                        doQueryTask();
                    }
                } catch (err) {
                    global.logger.error("failed to access DB", err);
                    doQueryTask();
                }
            }

            /******************************** runningTab ********************************/
            $scope.runningTab = {};
            $scope.runningTab.onSelect = function(){
                //表示running tab被激活
                $scope.activeTab = 0;
            }
            $scope.runningTab.taskNum = 0;
            $scope.runningTab.taskTypeNum = 0;
            $scope.runningTab.currentPage = 1;

            $scope.runningTab.pageSize = {
                size: 10,
                options: [10, 20, 50]
            };
            //设置任务类型常亮
            var allTypeOptions = [
                {id: "allType", label: CommonUtils.convertTaskType("allType")},
                {id: "putObj", label: CommonUtils.convertTaskType("putObj")},
                {id: "getObj", label: CommonUtils.convertTaskType("getObj")},
                {id: "delete", label: CommonUtils.convertTaskType("delete")}
            ];
            //初始化任务状态常亮
            var allStatusOptions = [
                {id: "allTask", label: global.langData.all, data: {$ne: "SUCCESS"}},
                {id: "runningTask", label: global.langData.running, data: "RUNNING"},
                {id: "waitTask", label: global.langData.wait, data: "WAIT"},
                {id: "pasueTask", label: global.langData.paused, data: "PAUSE"},
                {id: "failedTask", label: global.langData.failed, data: "FAILED"}
            ];
            if (pkg.coldline) {
                if(pkg.recoverAndDownload) {
                    $scope.completeTab.typeOptions.push({id: "recoverAndDownload", label: CommonUtils.convertTaskType("recoverAndDownload")});
                    allTypeOptions.push({id: "recoverAndDownload", label: CommonUtils.convertTaskType("recoverAndDownload")});
                }
                allTypeOptions.push({id: "recover", label: CommonUtils.convertTaskType("recover")});
                $scope.completeTab.typeOptions.push({id: "recover", label: CommonUtils.convertTaskType("recover")});
                allStatusOptions.push({id: "recoverTask", label: global.langData.obs_term_restoring_lable, data: "RESTORING"});
            }
            if(pkg.objCopy) {
                $scope.completeTab.typeOptions.push({id: "copy",  label: CommonUtils.convertTaskType("copy")});
                $scope.completeTab.typeOptions.push({id: "move", label: CommonUtils.convertTaskType("move")});
                $scope.completeTab.typeOptions.push({id: "rename", label: CommonUtils.convertTaskType("rename")});
                allTypeOptions.push({id: "copy",  label: CommonUtils.convertTaskType("copy")});
                allTypeOptions.push({id: "move", label: CommonUtils.convertTaskType("move")});
                allTypeOptions.push({id: "rename", label: CommonUtils.convertTaskType("rename")});
            }
            //初始化类型下拉框
            $scope.runningTab.typeOptions = allTypeOptions;
            $scope.runningTab.typeSelectedId = "allType";
            //初始化任务状态下拉框
            $scope.runningTab.statusOptions = allStatusOptions;
            $scope.runningTab.statusSelectedId = "allTask";
            //初始化查询语句
            $scope.runningTab.query = {
                $and:[{stat: {"$ne": "SUCCESS"}},{stat: {"$ne": "MD5SUCCESS"}},{stat: {"$ne": "skip"}}]
            };
            $scope.runningTab.pageNumChange = function (currentPage, pageSizeNum, totalItems) {
                clearRunningCheckBoxStatus();
            };
            $scope.runningTab.pageUpdate = function (currentPage, pageSizeNum, totalItems) {
                clearRunningCheckBoxStatus();
            }
            $scope.runningTab.changeType = function (option) {
                //如果选择所有类型，则查询语句删除type条件，否则type条件为所选类型
                if (option.id === "allType") {
                    delete $scope.runningTab.query.type;
                } else {
                    $scope.runningTab.query.type = option.id;
                }
                //当选择恢复类型时，任务状态就只有所有、恢复中、失败
                buildStatusOptionsByRecoverType(option);
                // 清空CheckBox的选中状态
                clearRunningCheckBoxStatus();
            }
            function clearRunningCheckBoxStatus() {
                $scope.runningTab.selected = [] ;
                $scope.runningTab.select_all = false;
                $scope.runningTab.m = [];
            }
            $scope.runningTab.changeStatus = function (option) {
                $scope.runningTab.query.stat = option.data;
                //当选择恢复状态时，恢复任务只有：所有、恢复
                buildTypeOptionsByRestoringStatus(option);
                // 清空CheckBox的选中状态
                clearRunningCheckBoxStatus();
            }

            //task数据
            $scope.runningTab.pendingData = [];
            $scope.runningTab.displayed = [];
            $scope.remainingTime =  global.langData.remainingTime;
            $scope.speed =  global.langData.speed;
            $scope.runningTab.columns = [
                {
                    title: '',
                    width: "30px"
                },
                {
                    title: global.langData.bucketNameInTable,
                    width: "150px"
                },
                {
                    title: global.langData.name,
                    width: "auto"
                },
                {
                    title: global.langData.type,
                    width: "80px"
                },
                {
                    title: global.langData.size,
                    width: "100px"
                },
                {
                    title: global.langData.progress,
                    width: "110px"
                },
                {
                    title: global.langData.statusInTable,
                    width: "105px"
                },
                {
                    title: global.langData.remainingTime,
                    width: "140px"
                },
                {
                    title: global.langData.speed,
                    width: "90px"
                },
                {
                    title: global.langData.operation,
                    width: "120px"
                }
            ];
            // 定义选择的CheckBox
            $scope.runningTab.selected = [] ;
            $scope.runningTab.select_all = false;
            $scope.runningTab.m = []; // 保存每个CheckBox的选中状态
            $scope.runningTab.updateSelection = function($event,id){
                var checkbox = $event.target ;
                var checked = checkbox.checked ;
                if(checked){
                    $scope.runningTab.selected.push(id) ;
                    $scope.runningTab.m[id] = true;
                }else{
                    var idx = $scope.runningTab.selected.indexOf(id) ;
                    $scope.runningTab.selected.splice(idx,1);
                    $scope.runningTab.m[id] = false;
                }
                if ($scope.runningTab.pendingData.length === $scope.runningTab.selected.length) {
                    $scope.runningTab.select_all = true;
                } else {
                    $scope.runningTab.select_all = false;
                }
            };
            // CheckBox全选
            $scope.runningTab.selectAll = function ($event) {
                var checkbox = $event.target ;
                var checked = checkbox.checked ;
                if(checked) {
                    $scope.runningTab.select_all = true;
                    angular.forEach($scope.runningTab.pendingData, function (i) {
                        $scope.runningTab.m[i.id] = true;
                        var index = $scope.runningTab.selected.indexOf(i.id) ;
                        if(index === -1){
                            $scope.runningTab.selected.push(i.id);
                        }
                    });

                }else {
                    $scope.runningTab.select_all = false;
                    angular.forEach($scope.runningTab.pendingData, function (i) {
                        $scope.runningTab.m[i.id] = false;
                        $scope.runningTab.selected = [];
                    })
                }
            };

            $scope.runningTab.restoreSingleTask = function(showTask) {
                restoreSingleTask(showTask.id);
                showTask.progressVal = 99.99;
                showTask.stat = "WAIT";
                showTask.statusInTable = CommonUtils.convertTaskType("WAIT");
                showTask.errmsg = "";
                $scope.$apply();
            };
            $scope.runningTab.startSingleTask = function(taskId) {
                taskControlAction.startTask(taskId);
            };
            $scope.runningTab.pauseSingleTask = function(taskId) {
                taskControlAction.pauseTask(taskId);
            };
            $scope.runningTab.deleteSingleTask = function(taskId) {
                deleteSingleTask(taskId, true, function () {
                    if($scope.runningTab.selected.length == 0){
                        $scope.runningTab.select_all = false;
                    }
                });
            };

            $scope.runningTab.runAll = function() {
                return taskRunAll();
            };
            $scope.runningTab.run = function() {
                angular.forEach($scope.runningTab.selected, function (i) {
                    taskControlAction.startTask(i);    
                });
            };
            $scope.runningTab.pauseAll = function() {
                taskControlAction.pauseAllTasks(function(){
                    reloadTasks(true);
                });
                return false;
            };
            $scope.runningTab.pause = function() {

                angular.forEach($scope.runningTab.selected, function (i) {
                    taskControlAction.pauseTask(i);
                });
            };

            $scope.runningTab.cancelAll = function() {
                return taskCancelAll();
            };

            $scope.runningTab.cancel = function() {
                return taskCancelSelected();
            };

            setInterval(function () {
                if($scope.runningTab.pageSize.size > parseInt($scope.runningTab.taskTypeNum) - 1) {
                    //避免出现分页器消失后（页面大小大于总数），无法触发tableStateUpdate事件，导致无法回到第一页的情况
                    $scope.runningTab.currentPage = 1;
                }
                renderTasks();
            }, 1000);

            function getShowTask(task) {
                var showTask = {
                    id: task.id,
                    bucket: task.bucket,
                    size: indexAction.getFileSize(task.size, 'task', language),
                    key: task.key,
                    type: task.type,
                    stat: task.stat,
                    remainingTime: getRemainingTimeVal(task),
                    speed: getSpeedVal(task),
                    progress: task.progress,
                    //为了给进度条UI提供数据，progress为x%，progressVal为x
                    progressVal: task.progress ? task.progress.slice(0, task.progress.length - 1) : 0,
                    statusInTable: CommonUtils.convertTaskType(task.stat),
                    actionType: CommonUtils.convertTaskType(task.type)
                };
                if (isShowFullProgress(task)) {
                    //delete、recover任务，则显示无百分比进度条，这里做个假的
                    showTask.progressVal = 99.99
                }
                buildOptionCondition(showTask);
                buildFailMessage(task, showTask);
                return showTask;
            }
            $scope.exportData = function () {
                $("#exportData").removeClass('mui-hide');
                $("#exportData").addClass('shown');
                $("#exportData").css('z-index','1001')
                divDragFunc('exportDataDrag','exportData');
            }
            /**
             *
             */
            function renderTasks() {
                if (taskManager && isLoaded) {
                    if ($("#taskPanel").hasClass('mui-active')) {
                        async.parallel([
                            function (cb) {
                                taskManager.listTasks($scope.runningTab.query, parseInt($scope.runningTab.pageSize.size), $scope.runningTab.currentPage, function (err, data) {
                                    $scope.runningTab.pendingData = [];
                                    var runningMap = taskManager.runningMap;
                                    if(data) {
                                        if($scope.runningTab.statusSelectedId === "allTask" || $scope.runningTab.statusSelectedId === "runningTask") {
                                            for (var i = 0; i < data.length; i++) {
                                                if (runningMap[data[i].id]) {
                                                    var showTask = getShowTask(runningMap[data[i].id]);
                                                    $scope.runningTab.pendingData.push(showTask);
                                                }
                                            }
                                        }
                                        var idArr = [];// 保存所有运行任务的id数组
                                        for (var i = 0; i < data.length; i++) {
                                            idArr.push(data[i].id);
                                            if(runningMap[data[i].id]) {
                                                continue;
                                            }
                                            var showTask = getShowTask(data[i]);
                                            $scope.runningTab.pendingData.push(showTask);
                                        }
                                        // 正在运行任务变为已完成任务，更新选中的CheckBox列表
                                        var len = $scope.runningTab.selected.length;
                                        if(len > 0 ){
                                            for(var j = 0;j < len; j++){
                                                var selectedId = $scope.runningTab.selected[j];
                                                if(idArr.indexOf(selectedId) === -1){
                                                    $scope.runningTab.selected.splice(j,1);
                                                }
                                            }
                                        }
                                    }
                                    cb();
                                });
                            },
                            function (cb) {
                                taskManager.countTasks($scope.runningTab.query, function (err, data) {
                                    $scope.runningTab.taskNum = data;
                                    $scope.runningTab.taskTypeNum = indexAction.formatNumber(encoderForHtml(data),global.langData,true);
                                    cb();
                                })
                            }
                        ], function (err, results) {
                            $scope.$evalAsync();
                        });
                    }
                }
            }

            /**
             * 根据所选的任务状态，确定任务类型有哪些选项，目前只针对Restoring状态进行调整
             * @param option
             */
            function buildTypeOptionsByRestoringStatus(option) {
                if (option.id === "recoverTask") {
                    $scope.runningTab.typeOptions = [{
                        id: "allType",
                        label: CommonUtils.convertTaskType("allType"),
                    }, {
                        id: "recover",
                        label: CommonUtils.convertTaskType("recover")
                    }, {
                        id: "recoverAndDownload",
                        label: CommonUtils.convertTaskType("recoverAndDownload")
                    }];
                    if (["putObj", "getObj", "delete"].indexOf($scope.runningTab.typeSelectedId) > -1) {
                        $scope.runningTab.typeSelectedId = "allType";
                        delete $scope.runningTab.query.type;
                    }
                } else if (option.id === "failedTask" || option.id === "allTask") {
                    $scope.runningTab.typeOptions = allTypeOptions;
                } else {
                    $scope.runningTab.typeOptions = [
                        {id: "allType", label: CommonUtils.convertTaskType("allType")},
                        {id: "putObj", label: CommonUtils.convertTaskType("putObj")},
                        {id: "getObj", label: CommonUtils.convertTaskType("getObj")},
                        {id: "delete", label: CommonUtils.convertTaskType("delete")}
                    ];
                    if(pkg.recoverAndDownload){
                        $scope.runningTab.typeOptions.push({id: "recoverAndDownload", label: CommonUtils.convertTaskType("recoverAndDownload")})
                    }
                }
            }

            /**
             *
             * @returns {boolean}
             */
            function taskCancelAll() {
                if (!$(".mui-model.mui-model-mini").hasClass('shown')) {
                    showOverlay();
                    $("#taskPanel").css('z-index','90');
                }
                var message = global.langData.isSureCancelAll;
                if (hasRunning()) {
                    message = global.langData.cancelRunningTasksMsg;
                }
                $('.mui-model').showMessage({
                    type: "warning",
                    message: message,
                    isFocus: true,
                    ok: function () {
                        $("#taskPanel").css('z-index','1000');
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        taskControlAction.abortAllTasks(function () {
                            reloadTasks(true);
                            refreshTaskNum();//刷新所有任务个数
                        });
                    },
                    cancel: function () {
                        $("#taskPanel").css('z-index','1000');
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }

            /**
             *  取消选中的任务
             * @returns {boolean}
             */
            function taskCancelSelected() {
                if (!$(".mui-model.mui-model-mini").hasClass('shown')) {
                    showOverlay();
                    $("#taskPanel").css('z-index','90');
                }
                var message = global.langData.isSureCancel;
                if (hasRunning()) {
                    message = global.langData.cancelRunningTasksMsg;
                }
                $('.mui-model').showMessage({
                    type: "warning",
                    message: message,
                    isFocus: true,
                    ok: function () {
                        $("#taskPanel").css('z-index','1000');
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        angular.forEach($scope.runningTab.selected, function (id) {
                            taskControlAction.abortTask(id, function () {

                            });
                        });
                        $scope.runningTab.selected = [];
                        $scope.runningTab.select_all = false;
                    },
                    cancel: function () {
                        $("#taskPanel").css('z-index','1000');
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }
            /**
             *
             * @returns {boolean}
             */
            function taskRunAll() {
                $("#runAllTask").addClass('mui-disabled-task');
                var queryString = {"$or": [{stat: "PAUSE"}, {stat: "FAILED"}]};
                taskManager.countTasks(queryString, function (err, data) {
                    if (data === 0 && hasRunning()) {
                        $("#taskPanel").css('z-index','90');
                        showOverlay();
                        $('.mui-model').showMessage({
                            type: "tips",
                            message: global.langData.obs_task_runAllTask_tip,
                            ok: function () {
                                $("#runAllTask").removeClass('mui-disabled-task');
                                $("#taskPanel").css('z-index','1000');
                                if ($("#mui-overlay").size() > 0) {
                                    mui.overlay('off');
                                }
                            },
                            title: global.langData.info
                        });
                        return;
                    }
                    async.parallel([
                        function (cb) {
                            taskControlAction.startAllTasks(function () {
                                reloadTasks(true);
                                cb();
                            });
                        },
                        function (cb) {
                            restoreAllFailedTask(function () {
                                cb();
                            });
                        }
                    ], function (err, results) {
                        $("#runAllTask").removeClass('mui-disabled-task');
                    });
                    return false;
                });

            }

            /**
             * 根据所选任务类型，确定任务状态选项，目前只针对recover任务调整
             * @param option
             */
            function buildStatusOptionsByRecoverType(option) {
                if (option.id === "recover") {
                    $scope.runningTab.statusOptions = [
                        {id: "allTask", label: global.langData.all, data: {$ne: "SUCCESS"}},
                        {id: "failedTask", label: global.langData.failed, data: "FAILED"},
                        {id: "recoverTask", label: global.langData.obs_term_restoring_lable, data: "RESTORING"}
                    ];
                    if (["runningTask", "waitTask", "pasueTask"].indexOf($scope.runningTab.statusSelectedId) > -1) {
                        $scope.runningTab.statusSelectedId = "allTask";
                        $scope.runningTab.query.stat = {"$ne": "SUCCESS"}
                    }
                    $("#recover-refresh-div").show();
                } else if (option.id === "allType") {
                    $("#recover-refresh-div").show();
                    $scope.runningTab.statusOptions = allStatusOptions;
                } else if (option.id === "recoverAndDownload") {
                    $scope.runningTab.statusOptions = [
                        {id: "allTask", label: global.langData.all, data: {$ne: "SUCCESS"}},
                        {id: "runningTask", label: global.langData.running, data: "RUNNING"},
                        {id: "waitTask", label: global.langData.wait, data: "WAIT"},
                        {id: "pasueTask", label: global.langData.paused, data: "PAUSE"},
                        {id: "failedTask", label: global.langData.failed, data: "FAILED"},
                        {id: "recoverAndDownload", label: global.langData.obs_term_restoring_lable, data: "RESTORING"}
                    ];
                    if (["runningTask", "waitTask", "pasueTask"].indexOf($scope.runningTab.statusSelectedId) > -1) {
                        $scope.runningTab.statusSelectedId = "allTask";
                        $scope.runningTab.query.stat = {"$ne": "SUCCESS"}
                    }
                }else {
                    $("#recover-refresh-div").hide();
                    $scope.runningTab.statusOptions = [
                        {id: "allTask", label: global.langData.all, data: {$ne: "SUCCESS"}},
                        {id: "runningTask", label: global.langData.running, data: "RUNNING"},
                        {id: "waitTask", label: global.langData.wait, data: "WAIT"},
                        {id: "pasueTask", label: global.langData.paused, data: "PAUSE"},
                        {id: "failedTask", label: global.langData.failed, data: "FAILED"}
                    ];
                }
            }

            /**
             * 构建任务操作区域应该显示那些操作图标
             * @param showTask
             */
            function buildOptionCondition(showTask) {
                showTask.showRestore = false;
                showTask.showStart = false;
                showTask.showPause = false;
                showTask.showDelete = false;
                //恢复的时候单独处理，只有失败了才能重新restore或者delete
                if (showTask.type === 'recover') {
                    if(showTask.stat === 'FAILED') {
                        showTask.showRestore = true;
                        showTask.showDelete = true;
                    }
                    return;
                }
                if (showTask.type === 'recoverAndDownload' && showTask.stat === 'RESTORING') {
                    return;
                }
                //其他情况，则只看运行和等待的状态
                if (showTask.stat === 'RUNNING' || showTask.stat === 'WAIT') {
                    showTask.showPause = true;
                } else {
                    showTask.showStart = true;
                }
                showTask.showDelete = true;
            }

            /**
             * 获取速率
             * @param task
             * @returns {*}
             */
            function getSpeedVal(task) {
                if (task.type === 'delete' || task.type === "copy" || task.type === "move" || task.type === "rename") {
                    return "--";
                }
                if (task.stat === "RUNNING" && task.speed) {
                    return task.speed;
                }
                return "--";
            }

            /**
             * 获取任务剩余时间
             * @param task
             * @returns {*}
             */
            function getRemainingTimeVal(task) {
                if (task.type === 'delete') {
                    return "--";
                }
                if (task.stat === "RUNNING" && task.spTime) {
                    return task.spTime;
                }
                return "--";
            }
            /**
             * 对于没有数据流的任务，删除、恢复，进度条只有在runing、restoring的时候才出现
             * @param task
             * @returns {boolean}
             */
            function isShowFullProgress(task) {
                if (task.type === 'delete' || task.type === 'recover' ) {
                    if (task.stat === 'RUNNING' || task.stat === 'RESTORING') {
                        return true;
                    }
                }
                return false;
            }

            /**
             * 如果任务fail了，则构建错误信息
             * @param showTask
             * @returns {*}
             */
            function buildFailMessage(task, showTask) {
                if (task.errMessage === 'NetworkingError' && task.type != 'recover' && task.stat === "FAILED") {
                    showTask.statusInTable = global.langData.wait;
                }
                var obsErrorObj = obsError(task.errMessage,"");
                if (errorConfig[task.errMessage]) {
                    showTask.errmsg = errorConfig[task.errMessage].lastIndexOf("。") > 0 || errorConfig[task.errMessage].lastIndexOf(".") > 0
                        ? errorConfig[task.errMessage].substring(0, errorConfig[task.errMessage].length - 1)
                        : errorConfig[task.errMessage];
                    showTask.errmsg = obsErrorObj ? obsErrorObj.description : showTask.errmsg;
                } else if (task.errMessage) {
                    showTask.errmsg = obsErrorObj ? obsErrorObj.description : task.errMessage;
                } else {
                    showTask.errmsg = global.langData.undefinedError;
                }
                return obsErrorObj;
            }



        }]);

        angular.bootstrap($('#taskPanel'), ['taskPanelModule']);
    });
}

/**
 * 删除单个任务
 * @param id
 * @param isRun 如果是在running的任务，则需要通过abortTask处理，如果是在complete里面，则直接删除
 * @param callback
 */
function deleteSingleTask(id, isRunTab, callback) {
    if (!$(".mui-model.mui-model-mini").hasClass('shown')) {
        showOverlay();
        $("#taskPanel").css('z-index','90');
    }
    $('.mui-model').showMessage({
        type: "warning",
        message: global.langData.warn_delete_single_record,
        isFocus:true,
        ok: function () {
            $("#taskPanel").css('z-index','1000');
            if ($("#mui-overlay").size() > 0) {
                mui.overlay('off');
            }
            if(isRunTab) {
                taskControlAction.abortTask(id, callback);
            } else {
                mongodb.delById(id, callback);
            }
        },
        cancel: function () {
            $("#taskPanel").css('z-index','1000');
            if ($("#mui-overlay").size() > 0) {
                mui.overlay('off');
            }
            return false;
        },
        title: global.langData.warning
    });
}

/**
 * 删除已完成任务
 * @param selectedIds
 * @param callback
 */
function deleteSelectedCompletedTask(selectedIds, callback) {
    if (!$(".mui-model.mui-model-mini").hasClass('shown')) {
        showOverlay();
        $("#taskPanel").css('z-index','90');
    }
    $('.mui-model').showMessage({
        type: "warning",
        message: global.langData.warn_delete_selected_record,
        isFocus:true,
        ok: function () {
            $("#taskPanel").css('z-index','1000');
            if ($("#mui-overlay").size() > 0) {
                mui.overlay('off');
            }
            angular.forEach(selectedIds, function (id) {
                mongodb.delById(id, callback);
            });

        },
        cancel: function () {
            $("#taskPanel").css('z-index','1000');
            if ($("#mui-overlay").size() > 0) {
                mui.overlay('off');
            }
            return false;
        },
        title: global.langData.warning
    });
}
/**
 * 删除所有任务
 * @param callback
 */
function deleteAllTasks(changedType, callback) {
    if (!$(".mui-model.mui-model-mini").hasClass('shown')) {
        showOverlay();
        $("#taskPanel").css('z-index','90');
    }
    $('.mui-model').showMessage({
        type: "warning",
        message: global.langData.warn_delete_all_record,
        isFocus: true,
        ok: function () {
            $("#taskPanel").css('z-index','1000');
            if ($("#mui-overlay").size() > 0) {
                mui.overlay('off');
            }
            var queryString = {
                userId: currentUserId,
                $or: [
                    {stat: "SUCCESS"},
                    {stat: "MD5SUCCESS"}
                ]
            }
            if(changedType != "allType") {
                queryString.type = changedType;
            }
            mongodb.delByQueryString(queryString, callback);
        },
        cancel: function () {
            $("#taskPanel").css('z-index','1000');
            if ($("#mui-overlay").size() > 0) {
                mui.overlay('off');
            }
            return false;
        },
        title: global.langData.warning
    });
}

/**
 * 定时查询恢复任务的进行状态
 */
function checkRecoverStatus(call) {
    global.logger.info("CheckRecoverStatus on going.");
    //是否继续递归标志
    var isStill = true;
    //页码
    var pageNum = 1;
    async.whilst(
        function () {
            return isStill;
        },
        function (cb) {
            //从数据库中取未完成的恢复任务
            taskManager.listAllRunRecoverTasks("RESTORING", Const("NUM_MONGODB_LIMITS"), pageNum, function (err, data) {
                if (data && data.length > 0) {
                    pageNum++;
                    queryAndUpdateRecoverStatus(data, function (err) {
                        cb(err);
                    })
                } else {
                    isStill = false;
                    cb();
                }
            });
        },
        function (err) {
            //执行完成后刷新recover任务界面
            reloadTasks(true);
            if (err) {
                global.logger.error('CheckRecoverStatus failed:', err);
            } else {
                global.logger.info('CheckRecoverStatus success!');
            }
            if (call) {
                call();
            }
        }
    );
}

/**
 * 遍历data数据，查询任务状态
 * @param data
 * @param cb
 */
function queryAndUpdateRecoverStatus(data, cb) {
    async.eachLimit(data, 20, function (item, callback) {
        bucketAndObjectAction.headObject(item.bucket, item.key, function (err, data) {
            //判断恢复操作是否已完成
            if (err) {
                if(err.code === 'NetworkingError') {
                    global.logger.warn("queryAndUpdateRecoverStatus timeout, do nothing and waiting next query.")
                    callback();
                    return;
                }
                item.stat = "FAILED";
                item.errMessage = err.code;
                global.logger.error('headObject failed:', err);
            } else if (data && data.Restore && data.Restore.indexOf('ongoing-request="false"') > -1) {
                if(item.type === "recoverAndDownload"){
                    if (taskManager) {
                        taskManager.setPauseAll(false);
                        taskManager.abortAll = false;
                    }
                    item.stat = "WAIT";
                    mongodb.updateStat(item, function (err, data) {
                        callback(err);
                    });
                    taskManager.start(item.id)
                }else{
                    item.stat = "SUCCESS";
                }
            } else if (data && !data.Restore) {
                item.stat = "FAILED";
                item.errMessage = 'NoSuchKey';
            }
            callback();
        });
    }, function () {
        //已完成任务id集合
        var ids = [];
        for (var x in data) {
            if (data[x].stat === 'SUCCESS') {
                ids.push(data[x].id);
                updateRestoreStatCache(data[x].key, languageJson.obs_term_restored_lable);
            }
        }

        async.parallel([
            function (cb) {
                //修改数据库中成功任务状态
                taskManager.updatesRecoverTasks(ids, function (err) {
                    cb(err);
                });
            },
            function (cb) {
                //失败的任务依次修改
                async.eachLimit(data, 20, function (item, callback) {
                    if (item.stat === 'FAILED') {
                        item.endTime = new Date();
                        mongodb.updateStat(item, function (err, data) {
                            callback(err);
                        });
                    } else {
                        callback();
                    }
                }, function (err) {
                    cb(err);
                });
            }
        ], function (err) {
            if (err) {
                global.logger.error("update tasks status failed...");
            }
            if (cb) {
                cb(err);
            }
        });
    });
}

function recoverObjectCtrl() {
    requirejs([], function () {
        var module = angular.module('recoverObjectModule', ['tiny']);

        module.controller('recoverObjectCtrl', ['$scope', 'tiValid', function ($scope, tiValid) {
            //根据局点判断是否显示对象恢复的慢速选项
            var getRecoverSpeedList = function () {
                if (_.isEqual(UCDVersion, "HEC")) {
                    return [
                        {
                            key: "Expedited",
                            value: global.langData.obs_task_restoreObjectExpedited_radio,
                            desc: global.langData.obs_task_restoreObjectExpedited_tip,
                            disable: false
                        }, {
                            key: "Standard",
                            value: global.langData.obs_task_restoreObjectStandard_radio,
                            desc: global.langData.obs_task_restoreObjectStandard_tip,
                            disable: false
                        }
                    ]
                }else if (_.isEqual(UCDVersion, "HK")) {
                    return [
                        {
                            key: "Expedited",
                            value: global.langData.obs_task_restoreObjectExpedited_radio,
                            desc: global.langData.obs_task_restoreObjectExpedited_tip,
                            disable: false
                        }, {
                            key: "Standard",
                            value: global.langData.obs_task_restoreObjectStandard_radio,
                            desc: global.langData.obs_task_restoreObjectStandard_tip,
                            disable: false
                        }
                    ]
                }  else if (_.isEqual(UCDVersion, "CTC")) {
                    return [
                        {
                            key: "Expedited",
                            value: global.langData.obs_task_restoreObjectExpedited_radio,
                            desc: global.langData.obs_task_restoreObjectExpedited_tip,
                            disable: false
                        }, {
                            key: "Standard",
                            value: global.langData.obs_task_restoreObjectStandard_radio,
                            desc: global.langData.obs_task_restoreObjectStandard_tip,
                            disable: false
                        }
                    ]
                } else if (_.isEqual(UCDVersion, "CMCC")) {
                    return [
                        {
                            key: "Expedited",
                            value: global.langData.obs_task_restoreObjectExpedited_radio,
                            desc: global.langData.obs_task_restoreObjectExpedited_tip,
                            disable: false
                        }, {
                            key: "Standard",
                            value: global.langData.obs_task_restoreObjectStandard_radio,
                            desc: global.langData.obs_task_restoreObjectStandard_tip,
                            disable: false
                        }
                    ]
                } else{
                    return [
                        {
                            key: "Expedited",
                            value: global.langData.obs_task_restoreObjectExpedited_radio,
                            desc: global.langData.obs_task_restoreObjectExpedited_tip,
                            disable: false
                        }, {
                            key: "Standard",
                            value: global.langData.obs_task_restoreObjectStandard_radio,
                            desc: global.langData.obs_task_restoreObjectStandard_tip,
                            disable: false
                        }, {
                            key: "Bulk",
                            value: global.langData.obs_task_restoreObjectBulk_radio,
                            desc: global.langData.obs_task_restoreObjectBulk_tip,
                            disable: false
                        }
                    ]
                }
            };
            $scope.recover = {
                recoverSpeedList: getRecoverSpeedList()
            };
            $scope.recover.selected = {
                // 设置默认选中值，后续$scope.selected.value会根据用户的选择而动态改变
                value: $scope.recover.recoverSpeedList[1].key
            };
            $scope.recover.description = $scope.recover.recoverSpeedList[1].desc;
            $scope.recover.changeType = function () {
                for (var index in $scope.recover.recoverSpeedList) {
                    if ($scope.recover.recoverSpeedList[index].key == $scope.recover.selected.value) {
                        $scope.recover.description = $scope.recover.recoverSpeedList[index].desc
                    }
                }
            }

            $scope.numberOptions = {
                value: 30,
                focused: false,
                disable: true,
                focus: function () {
                },
                blur: function () {
                },
                change: function () {
                }
            };

            //批量恢复
            function handleMuilObject(days, tier) {
                var bucket = $("#recoverBucketNmae").text();
                var path = getCurrPath();
                var lis = $("#objLists tr.selected-tr-active>td:last-child");
                //批量恢复
                var showMsgTemp = true;
                /**
                 * 与forEach相似，但不是并行执行。而是一个个按顺序执行。
                 */
                async.forEachSeries(lis, function (li, callback) {
                    var obj = JSON.parse($(li).text());
                    var name = obj.name;
                    if (name.charAt(name.length - 1) === '/') {
                        listRestoreObjects(bucket, path, name, '', 0, function (err) {
                            if (err && showMsgTemp) {
                                showMsgTemp = false;
                                $('.mui-model').showErrorMessage({
                                    message: languageJson.someObjectDownErr,
                                    obsError: obsError("someObjectDownErr")
                                });
                            }
                            callback();
                        }, days, tier);
                    } else {
                        var size = obj.dataSize;
                        handleSingleObject(path + name, bucket, days, tier, function (err) {
                            if (err) {
                                taskControlAction.recoverObject(bucket, path + name, size, "FAILED", err.code, days, tier);
                            } else {
                                taskControlAction.recoverObject(bucket, path + name, size, "RESTORING", "", days, tier);
                            }
                            callback();
                        });
                    }
                }, function () {
                    global.logger.info('HandleMuilObject scuuess!');
                });
            }

            /**
             * 批量恢复任务
             * @param bucket 桶名
             * @param parentPath 当前文件夹路径
             * @param marker
             * @param path 本地文件夹路径
             * @param retryNnum 重试次数
             * @param cb 回调方法
             */
            function listRestoreObjects(bucket, parentPath, prefix, marker, retryNnum, cb, days, tier) {
                var self = this;
                if (!self.taskManager.abortAll) {
                    var params = {Bucket: bucket, Marker: marker, Prefix: prefix, MaxKeys: 100};
                    s3.listObjects(params, function (err, data) {
                        if (err) {
                            //最多重试3次
                            if (retryNnum < 4) {
                                retryNnum++;
                                //每次重试间隔时间按重试次数递增
                                setTimeout(function () {
                                    listRestoreObjects(bucket, parentPath, prefix, marker, retryNnum, cb, days, tier);
                                    global.logger.error('this is listRestoreObjects function error = ', retryNnum);
                                }, retryNnum * 60000);
                            } else {
                                if (cb) {
                                    cb(err);
                                }
                            }
                            global.logger.error(err);
                        }
                        else {
                            retryNnum = 0;
                            //处理列举出来的结果集
                            restoreListObjectData(data, days, tier, function () {
                                if (data.IsTruncated) {
                                    listRestoreObjects(bucket, parentPath, prefix, data.NextMarker, retryNnum, cb, days, tier);
                                } else {
                                    cb();
                                }
                            });
                        }
                    });
                } else {
                    cb()
                }
            };

            /**
             * 处理每次调用listObjects返回的结果数据
             * @param data 需要处理的数据
             */
            function restoreListObjectData(data, days, tier, call) {
                //同步处理结果集，每次处理20条记录，避免和UDS交互并发太大
                var bucket = data.Name;
                async.eachLimit(data.Contents, 20, function (item, callback) {
                    var key = item.Key;
                    var size = item.Size;
                    handleSingleObject(key, bucket, days, tier, function (err) {
                        if (key.charAt(key.length - 1) != '/' && item.StorageClass === "GLACIER") {//folders and not clod will not be restored
                            if (err) {
                                taskControlAction.recoverObject(bucket, key, size, "FAILED", err.code, days, tier);
                            } else {
                                taskControlAction.recoverObject(bucket, key, size, "RESTORING", "", days, tier);
                            }
                        }
                        callback();
                    });
                }, function () {
                    if (call) {
                        call();
                    }
                });
            };

            $scope.okButton = {
                click: function () {
                    if (!$scope.validateResult) {
                        return false;
                    }
                    if(!$scope.validateExpiresResult){
                        $('.mui-model').showMessage({
                            type:'warning',
                            message: languageJson.obs_task_restoreValidityPeriodFault_info,
                            ok: function () {
                                return false;
                            },
                            title: languageJson.warning
                        });
                        return false;
                    }
                    taskManager.setPauseAll(false);
                    taskManager.setAbortAll(false);
                    var lis = $("#objLists tr.selected-tr-active>td:last-child");
                    var days = $scope.numberOptions.value;
                    var tier = $scope.recover.selected.value;
                    if (lis.length === 1 && $("#objLists tr.selected-tr-active").attr("data-type") === "file") {
                        var key = $('#recoverObjectName').text();
                        var size = $("#recoverObjectSize").text();
                        var bucket = $("#recoverBucketNmae").text();
                        var path = getCurrPath();
                        handleSingleObject(path + key, bucket, days, tier, function (err) {
                            if (err) {
                                taskControlAction.recoverObject(bucket, path + key, size, "FAILED", err.code, days, tier);
                            } else {
                                taskControlAction.recoverObject(bucket, path + key, size, "RESTORING", "", days, tier);
                            }
                        });
                    } else {
                        handleMuilObject(days, tier);
                    }
                    showCreateTasksAnimation();
                    $scope.cancelButton.click();
                }
            };

            $scope.cancelButton = {
                click: function () {
                    $scope.validateResult = true;
                    $scope.validateExpiresResult = true;
                    $("#recoverObjectPage").removeClass('shown');
                    $('#recoverObjectName').html('');
                    $("#recoverBucketNmae").html('');
                    $("#recoverObjectExpires").html('');
                    $("#recoverObjectSize").html('');
                    $scope.numberOptions.value = 30;
                    $scope.recover.selected = {
                        value: $scope.recover.recoverSpeedList[1].key,
                    };
                    $scope.recover.description = $scope.recover.recoverSpeedList[1].desc;
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                }
            };
            $scope.validateResult = true;
            $scope.validateExpiresResult = true;
            $scope.recoverObject = {
                daysValidate: {
                    "validator": [{
                        rule: function (value) {
                            if (value > 0 && value < 31) {
                                $scope.validateResult = true;
                                return true;
                            } else {
                                $scope.validateResult = false;
                                return false;
                            }
                        },
                        errorMsg: global.langData.obs_task_restoreDaysBeyond_tip
                    }, {
                        rule: function (value) {
                            var oldExpires = $("#recoverObjectExpires").text();
                            if (commonUtils.compareExpiresDays(value, oldExpires)) {
                                $scope.validateExpiresResult = true;
                                return true;
                            } else {
                                $scope.validateExpiresResult = false;
                                return false;
                            }
                        },
                        errorMsg: global.langData.obs_task_restoreValidityPeriodFault_info
                    }]
                },
                cleanInvalidate: function () {
                    tiValid.clearInValid($("#recoverDays"));
                },
            };

        }]);

        angular.bootstrap($('#recoverObjectPage'), ['recoverObjectModule']);
    });
}

function shareObjectCtrl() {
    requirejs([], function () {
        var module = angular.module('shareObjectModule', ['tiny']);

        module.controller('shareObjectCtrl', ['$scope', 'tiValid', function ($scope, tiValid) {
            $scope.numberOptions = {
                value: 5,
                focused: false,
                disable: true,
                focus: function () {
                },
                blur: function () {
                },
                change: function () {
                    creatObjectShareLink();
                }
            };

            $scope.expireTimeUnit = {
                selectedId: 'minute',
                options: [{
                    id: 'minute',
                    label: global.langData.obs_term_share_object_expire_time_minute
                },{
                    id: 'hour',
                    label: global.langData.obs_term_share_object_expire_time_hour
                },{
                    id: 'day',
                    label: global.langData.obs_term_share_object_expire_time_day
                }],
                change: function (option) {
                    creatObjectShareLink();
                }
            };

            var maxExpireTime = Const('MAX_EXPIRE_TIME_OF_SHARE');
            var validationMsg = CommonUtils.format(global.langData.obs_term_shareFolder_msg_warning, maxExpireTime);
            $scope.$watch('expireTimeUnit.selectedId', (newVal, oldVal) => {
                if (newVal) {
                    switch (newVal) {
                        case 'minute':
                            maxExpireTime = Const('MAX_EXPIRE_TIME_OF_SHARE');
                            break;
                        case 'hour':
                            maxExpireTime = Const('MAX_EXPIRE_TIME_OF_SHARE') / 60;
                            break;
                        case 'day':
                            maxExpireTime = Const('MAX_EXPIRE_TIME_OF_SHARE') / 60 / 24;
                            break;
                    }
                    validationMsg = CommonUtils.format(global.langData.obs_term_shareFolder_msg_warning, maxExpireTime);
                    $('#expireTime').attr('placeholder', CommonUtils.format(global.langData.obs_term_shareObject_urlValidityInput_valid, maxExpireTime));
                    $scope.expireTimeDesc = CommonUtils.format(global.langData.obs_term_shareObject_urlValidity_valid2, maxExpireTime);
                }
            });

            $scope.validateResult = true;
            $scope.validateExpiresResult = true;
            $scope.expireTimeDesc = CommonUtils.format(global.langData.obs_term_shareObject_urlValidity_valid2, maxExpireTime);
            $scope.downloadUrl = "";
            var errorMsg = global.langData.common_term_emptyEnter_msg;
            $scope.shareObject = {
                daysValidate: {
                    "validator": [{
                        "rule": "required",
                        "errorMsg": errorMsg
                    },{
                        rule: function (value) {
                            var regu = /^[1-9]\d*$/;
                            if (value > 0 && value > maxExpireTime) {
                                $scope.validateResult = false;
                                return validationMsg;
                            }else if(regu.test(value)){
                                return "";
                            } else {
                                $scope.validateResult = false;
                                return validationMsg;
                            }
                        }
                    }]
                },
                cleanInvalidate: function () {
                    tiValid.clearInValid($("#expireTime"));
                }
            };

        }]);

        angular.bootstrap($('#shareObjectPage'), ['shareObjectModule']);
    });
}

function shareFolderCtrl() {
    requirejs([], function () {
        var module = angular.module('shareFolderModule', ['tiny']);

        module.controller('shareFolderCtrl', ['$scope', 'tiValid', function ($scope, tiValid) {
            $scope.numberOptions = {
                value: 5,
                value2:"",
                focused: false,
                disable: true,
                placeholder: global.langData.obs_term_shareObject_urlValidityInput_valid,
                focus: function () {
                },
                blur: function () {
                },
                change: function () {
                    if(!$("#shareFolder").parent().hasClass("mui-hide")){
                        createShareToken();
                    }
                },
            };

            $scope.expireTimeUnit = {
                selectedId: 'minute',
                options: [{
                    id: 'minute',
                    label: global.langData.obs_term_share_object_expire_time_minute
                },{
                    id: 'hour',
                    label: global.langData.obs_term_share_object_expire_time_hour
                },{
                    id: 'day',
                    label: global.langData.obs_term_share_object_expire_time_day
                }],
                change: function (option) {
                    createShareToken();
                }
            };

            var maxExpireTime = Const('MAX_EXPIRE_TIME_OF_SHARE');
            var validationMsg = CommonUtils.format(global.langData.obs_term_shareFolder_msg_warning, maxExpireTime);
            $scope.$watch('expireTimeUnit.selectedId', (newVal, oldVal) => {
                if (newVal) {
                    switch (newVal) {
                        case 'minute':
                            maxExpireTime = Const('MAX_EXPIRE_TIME_OF_SHARE');
                            break;
                        case 'hour':
                            maxExpireTime = Const('MAX_EXPIRE_TIME_OF_SHARE') / 60;
                            break;
                        case 'day':
                            maxExpireTime = Const('MAX_EXPIRE_TIME_OF_SHARE') / 60 / 24;
                            break;
                    }
                    validationMsg = CommonUtils.format(global.langData.obs_term_shareFolder_msg_warning, maxExpireTime);
                    $('#expireTime1').attr('placeholder', CommonUtils.format(global.langData.obs_term_shareObject_urlValidityInput_valid, maxExpireTime));
                    $scope.expireTimeDesc = CommonUtils.format(global.langData.obs_term_shareObject_urlValidity_valid2, maxExpireTime);
                }
            });

            $scope.validateResult = true;
            $scope.validateExpiresResult = true;
            $scope.expireTimeDesc = CommonUtils.format(global.langData.obs_term_shareObject_urlValidity_valid2, maxExpireTime);
            $scope.downloadUrl = "";
            var errorMsg = global.langData.common_term_emptyEnter_msg;
            $scope.shareFolder = {
                daysValidate: {
                    "validator": [{
                        "rule": "required",
                        "errorMsg": errorMsg
                    },{
                        rule: function (value) {
                            var regu = /^[1-9]\d*$/;
                            if (value > 0 && value > maxExpireTime) {
                                $scope.validateResult = false;
                                return validationMsg;
                            }else if(regu.test(value)){
                                return "";
                            } else {
                                $scope.validateResult = false;
                                return validationMsg;
                            }
                        }
                    }]
                },
                shareCode:{
                    "validator": [{
                        rule: "required",
                        errorMsg: global.langData.obs_term_accesscode_tip
                    },{
                        rule: function (value) {
                            return /^\d{6}\b/.test(value.trim());
                        },
                        errorMsg: global.langData.obs_term_accesscode_tip
                    }]
                },
                cleanInvalidate: function () {
                    tiValid.clearInValid($("#expireTime1"));
                }
            };

        }]);
        angular.bootstrap($('#shareFolderPage'), ['shareFolderModule']);
    });
}

function creatObjectShareLink() {
    var bName = $("#curBucketName").html();
    var region = $("#shareObjectRegion").html();
    var objectName = $("#shareObjectName").text();
    var expireTime = $("#expireTime").val();
    var appElement = document.getElementById("shareObjectPage");
    var $scope = angular.element(appElement).scope();
    var realExpireTime = 0;
    switch ($scope.expireTimeUnit.selectedId) {
        case 'minute':
            expireTime = expireTime;
            break;
        case 'hour':
            expireTime = expireTime * 60;
            break;
        case 'day':
            expireTime = expireTime * 60 * 24;
            break;
    }
    if(expireTime){
        realExpireTime = parseInt(new Date().getTime()/1000 + parseInt(expireTime)*60);
    }else{
        realExpireTime = parseInt(new Date().getTime()/1000 + 300);
    }
    if(expireTime && expireTime <= Const('MAX_EXPIRE_TIME_OF_SHARE') && /^[1-9]\d*$/.test(expireTime)) {
        var url = generateDownloadUrl(bName, objectName, region, realExpireTime);
        $("#shareUrl").val(url);
        $scope.downloadUrl = url;
    } else {
        $("#expireTime").focus();
        return false;
    }
}

function createShareToken() {
    var bName  = $('#curBucketName').html();
    var FolderName = $("#shareFolderName").text();
    var expireTime = $("#expireTime1").val().trim();
    var shareCode = $("#shareCode").val().trim();
    var appElement = document.getElementById("shareFolderPage");
    var $scope = angular.element(appElement).scope();
    switch ($scope.expireTimeUnit.selectedId) {
        case 'minute':
            expireTime = expireTime;
            break;
        case 'hour':
            expireTime = expireTime * 60;
            break;
        case 'day':
            expireTime = expireTime * 60 * 24;
            break;
    }
    if(!(/^[1-9]\d*$/).test(expireTime) || expireTime < 0 || expireTime > Const('MAX_EXPIRE_TIME_OF_SHARE')){
        $("#expireTime1").focus();
        return false;
    }
    if(!(/^\d{6}\b/).test(shareCode)){
       $("#shareCode").focus();
        return false;
    }
    var region = $("#shareFolderRegion").html();
    var uri = ShareFolderUrl(bName,FolderName,region,expireTime);
    var span1 = languageJson.obs_term_share_column + ":\n";
    var span2 = languageJson.obs_term_accesscode_label + ":\n" + shareCode +"\n";
    shareCode = shareText + shareCode;
    var base = new Base64();
    var base64uri = base.encode(uri);
    //params: 注意参数key为WordArray对象
    //return: 密码对象 或者 密码对象Base64字符串

    /*var shareToken = CryptoJS.AES.encrypt(base64uri, shareCode, {
        iv: CryptoJS.enc.Hex.parse("obs-share"),
        mode: CryptoJS.mode.CTR,
        padding:CryptoJS.pad.Pkcs7
    });*/

    var shareToken = CryptoJS.AES.encrypt(new Buffer(uri).toString('base64'), CryptoJS.enc.Utf8.parse(shareCode), {
        iv: CryptoJS.enc.Utf8.parse('obs-share1234567'),
        mode: CryptoJS.mode.CBC,
        padding:CryptoJS.pad.Pkcs7
    });

    var span3 = "*" + languageJson.obs_term_accesscode_labelto + ":";
    expireTime = indexAction.gmtDate2LocaleDate(iso8601(new Date(new Date().getTime() + (expireTime * 60)*1000)));
    var text = span1 + global.shareConsole + "/" + "?token=" + shareToken + "\n\n" + span2 + span3 + expireTime;
    $("#shareFolder").val(text);
}

//分享文件夹
function ShareFolderUrl(bName, FolderName, region, expireTime) {
    var realfolderPath = "";
    var parentPath = getCurrPath();
    var url = getObjectUrl(bName, FolderName, region, parentPath);
    var index = url.indexOf("com/");
    var domain = url.slice(0, url.indexOf("com/") + 3) + ":443";
    if(index === -1){
        var point = s3.config.endpoint;
        domain = point;
        if(point.indexOf('https') === -1){
            domain = point.replace('http', 'https');
        }
    }
    var expiration = iso8601(new Date(new Date().getTime() + (expireTime * 60)*1000));
    var Policy = {
        "expiration": expiration,
        "conditions": [{
            "bucket": bName
        },
            ["starts-with", "$key", FolderName]
        ]
    };
    var b = new Base64();
    Policy = b.encode(JSON.stringify(Policy));
    var getQueryString = function () {
        var qs = {
            "prefix":FolderName,
            'AccessKeyId' : global.accessKeyId,
            'Policy': Policy
        };
        return AWS.util.queryParamsToString(qs);
    }
    var getPathName = function() {
        var str = (getCurrPath() + FolderName).split("/");
        realfolderPath = "";
        for (var i = 0, len = str.length; i < len; i++) {
            if (i === len - 1) {
                realfolderPath += encodeURIComponent(str[i]);
            } else {
                realfolderPath += encodeURIComponent(str[i]) + "/";
            }
        }
        return "/" + bName + "/" + realfolderPath;
    };
    var stringToSign = function () {
        var parts = [];
        parts.push("GET" + "\n"+ "\n");
        parts.push(Policy+ "\n");
        return parts.join('\n');
    };
    var getSignature = function () {
        return AWS.util.crypto.hmac(global.secretAccessKey, stringToSign(), 'base64', 'sha1');
    };
    var getSignUrl = function() {
        var parsedUrl = AWS.util.urlParse(getPathName() + "?" + getQueryString());
        var queryParams = {};
        if (parsedUrl.search) {
            queryParams = AWS.util.queryStringParse(parsedUrl.search.substr(1));
        }
        queryParams['Signature'] = getSignature();
        var shareUrl = domain + "/" + "?" + AWS.util.queryParamsToString(queryParams);
        if(index === -1){
            shareUrl = domain + "/" + bName + "/"  + "?" + AWS.util.queryParamsToString(queryParams);
        }
        return shareUrl;
    };
    return getSignUrl();
}

//过期时间格式转换
function iso8601(date) {
    return date.toISOString().replace(/\.\d{3}Z$/, 'Z');
};
// 生成对象下载url，也就是分享的url
function generateDownloadUrl(bName, href, region, expireTime) {
    var realfolderPath = "";
    var parentPath = getCurrPath();
    var url = getObjectUrl(bName, href, region, parentPath);
    var index = url.indexOf("com/");
    var domain = url.slice(0, url.indexOf("com/") + 3) + ":443";
    if(index === -1){
        var point = s3.config.endpoint;
        domain = point;
        if(point.indexOf('https') === -1){
            domain = point.replace('http', 'https');
        }

    }
    var getQueryString = function () {
        var date = AWS.util.date.getDate();
        var qs = {
            'AccessKeyId' : global.accessKeyId,
            'Expires': expireTime
        };
        return AWS.util.queryParamsToString(qs);
    }
    var getPathName = function() {
        var str = (getCurrPath() + href).split("/");
        realfolderPath = "";
        for (var i = 0, len = str.length; i < len; i++) {
            if (i === len - 1) {
                realfolderPath += encodeURIComponent(str[i]);
            } else {
                realfolderPath += encodeURIComponent(str[i]) + "/";
            }
        }
        return "/" + bName + "/" + realfolderPath;
    };
    var getParamsString = function () {
        var queryString = "";
        queryString += getPathName();
        return queryString;
    };
    var stringToSign = function () {
        var parts = [];
        parts.push("GET" + '\n' + '\n');
        parts.push(expireTime);
        parts.push(getParamsString());
        return parts.join('\n');
    };
    var getSignature = function () {
        return AWS.util.crypto.hmac(global.secretAccessKey, stringToSign(), 'base64', 'sha1');
    };
    var getSignUrl = function() {
        var parsedUrl = AWS.util.urlParse(getPathName() + "?" + getQueryString());
        var queryParams = {};
        if (parsedUrl.search) {
            queryParams = AWS.util.queryStringParse(parsedUrl.search.substr(1));
        }
        queryParams['Signature'] = getSignature();
        var shareUrl = domain + "/" + realfolderPath + "?" + AWS.util.queryParamsToString(queryParams);
        if(index === -1){
            shareUrl = domain + "/" + bName + "/" + realfolderPath + "?" + AWS.util.queryParamsToString(queryParams);
        }
        return shareUrl;
    };
    // 更新当前对象的region，方便下次改变失效时间生成新的url
    $("#shareObjectRegion").html(region);
    return getSignUrl();
}

//恢复并下载
function recoverFloderCtrl() {
    requirejs([], function () {
        var module = angular.module('recoverFloderModule', ['tiny']);

        module.controller('recoverFloderCtrl', ['$scope', 'tiValid', function ($scope, tiValid) {
            //根据局点判断是否显示对象恢复的慢速选项
            var getRecoverSpeedList = function () {
                if (_.isEqual(UCDVersion, "HEC")) {
                    return [
                        {
                            key: "Expedited",
                            value: global.langData.obs_task_restoreObjectExpedited_radio,
                            desc: global.langData.obs_task_restoreObjectExpedited_tip,
                            disable: false
                        }, {
                            key: "Standard",
                            value: global.langData.obs_task_restoreObjectStandard_radio,
                            desc: global.langData.obs_task_restoreObjectStandard_tip,
                            disable: false
                        }
                    ]
                }else if(_.isEqual(UCDVersion, "HK")) {
                    return [
                        {
                            key: "Expedited",
                            value: global.langData.obs_task_restoreObjectExpedited_radio,
                            desc: global.langData.obs_task_restoreObjectExpedited_tip,
                            disable: false
                        }, {
                            key: "Standard",
                            value: global.langData.obs_task_restoreObjectStandard_radio,
                            desc: global.langData.obs_task_restoreObjectStandard_tip,
                            disable: false
                        }
                    ]
                }else if (_.isEqual(UCDVersion, "CTC")) {
                    return [
                        {
                            key: "Expedited",
                            value: global.langData.obs_task_restoreObjectExpedited_radio,
                            desc: global.langData.obs_task_restoreObjectExpedited_tip,
                            disable: false
                        }, {
                            key: "Standard",
                            value: global.langData.obs_task_restoreObjectStandard_radio,
                            desc: global.langData.obs_task_restoreObjectStandard_tip,
                            disable: false
                        }
                    ]
                } else if (_.isEqual(UCDVersion, "CMCC")) {
                    return [
                        {
                            key: "Expedited",
                            value: global.langData.obs_task_restoreObjectExpedited_radio,
                            desc: global.langData.obs_task_restoreObjectExpedited_tip,
                            disable: false
                        }, {
                            key: "Standard",
                            value: global.langData.obs_task_restoreObjectStandard_radio,
                            desc: global.langData.obs_task_restoreObjectStandard_tip,
                            disable: false
                        }
                    ]
                } else{
                    return [
                        {
                            key: "Expedited",
                            value: global.langData.obs_task_restoreObjectExpedited_radio,
                            desc: global.langData.obs_task_restoreObjectExpedited_tip,
                            disable: false
                        }, {
                            key: "Standard",
                            value: global.langData.obs_task_restoreObjectStandard_radio,
                            desc: global.langData.obs_task_restoreObjectStandard_tip,
                            disable: false
                        }, {
                            key: "Bulk",
                            value: global.langData.obs_task_restoreObjectBulk_radio,
                            desc: global.langData.obs_task_restoreObjectBulk_tip,
                            disable: false
                        }
                    ]
                }
            };
            $scope.recoverAndDowload = {
                recoverSpeedList: getRecoverSpeedList()
            };
            $scope.recoverAndDowload.selected = {
                // 设置默认选中值，后续$scope.selected.value会根据用户的选择而动态改变
                value: $scope.recoverAndDowload.recoverSpeedList[1].key
            };
            $scope.recoverAndDowload.description = $scope.recoverAndDowload.recoverSpeedList[1].desc;
            $scope.recoverAndDowload.changeType = function () {
                for (var index in $scope.recoverAndDowload.recoverSpeedList) {
                    if ($scope.recoverAndDowload.recoverSpeedList[index].key == $scope.recoverAndDowload.selected.value) {
                        $scope.recoverAndDowload.description = $scope.recoverAndDowload.recoverSpeedList[index].desc
                    }
                }
            }

            $scope.numberOptions = {
                value: 30,
                focused: false,
                disable: true,
                focus: function () {
                },
                blur: function () {
                },
                change: function () {
                }
            };

            //恢复并下载文件夹
            function handleMuilFloder(days, tier,filePath) {
                var bucket = $('#curBucketName').html();;
                var path = getCurrPath();
                var lis = $("#objLists tr.selected-tr-active>td:last-child");
                //批量恢复
                var showMsgTemp = true;
                /**
                 * 与forEach相似，但不是并行执行。而是一个个按顺序执行。
                 */
                async.forEachSeries(lis, function (li, callback) {
                    var obj = JSON.parse($(li).text());
                    var name = obj.name;
                    listRestoreFloder(bucket, path, name, '', 0, function (err) {
                        if (err && showMsgTemp) {
                            showMsgTemp = false;
                            $('.mui-model').showErrorMessage({
                                message: languageJson.someObjectDownErr,
                                obsError: obsError("someObjectDownErr")
                            });
                        }
                        callback();
                    }, days, tier,filePath);

                }, function () {
                    global.logger.info('HandleMuilFloder scuuess!');
                });
            }

            /**
             * 批量恢复任务
             * @param bucket 桶名
             * @param parentPath 当前文件夹路径
             * @param marker
             * @param path 本地文件夹路径
             * @param retryNnum 重试次数
             * @param cb 回调方法
             */
            function listRestoreFloder(bucket, parentPath, prefix, marker, retryNnum, cb, days, tier,filePath) {
                var self = this;
                if (!self.taskManager.abortAll) {
                    var params = {Bucket: bucket, Marker: marker, Prefix: prefix, MaxKeys: 100};
                    s3.listObjects(params, function (err, data) {
                        if (err) {
                            //最多重试3次
                            if (retryNnum < 4) {
                                retryNnum++;
                                //每次重试间隔时间按重试次数递增
                                setTimeout(function () {
                                    listRestoreFloder(bucket, parentPath, prefix, marker, retryNnum, cb, days, tier,filePath);
                                    global.logger.error('this is listRestoreObjects function error = ', retryNnum);
                                }, retryNnum * 60000);
                            } else {
                                if (cb) {
                                    cb(err);
                                }
                            }
                            global.logger.error(err);
                        }
                        else {
                            retryNnum = 0;
                            //处理列举出来的结果集
                            restoreListObjectData(data, days, tier,filePath, function () {
                                if (data.IsTruncated) {
                                    listRestoreFloder(bucket, parentPath, prefix, data.NextMarker, retryNnum, cb, days, tier,filePath);
                                } else {
                                    cb();
                                }
                            });
                        }
                    });
                } else {
                    cb()
                }
            };

            /**
             * 处理每次调用listObjects返回的结果数据
             * @param data 需要处理的数据
             */
            function restoreListObjectData(data, days, tier,filePath, call) {
                //同步处理结果集，每次处理20条记录，避免和UDS交互并发太大
                var bucket = data.Name;
                async.eachLimit(data.Contents, 20, function (item, callback) {
                    var key = item.Key;
                    var size = item.Size;
                    var etag = item.etag;
                    var filePath1 = filePath + "/" + key;
                    if(taskManager){
                        taskManager.pauseAll = false;
                        taskManager.abortAll = false;
                    }
                    if(item.StorageClass === "GLACIER"){
                        handleSingleObject(key, bucket, days, tier, function (err) {
                            if (key.charAt(key.length - 1) != '/') {//folders will not be restored
                                if (err) {
                                    taskControlAction.recoverAndDownload(bucket, key, size, "FAILED", filePath1 ,err.code, days, tier,etag);
                                } else {
                                    taskControlAction.recoverAndDownload(bucket, key, size, "RESTORING", filePath1 ,"", days, tier,etag);
                                }
                            }
                            callback();
                        });
                    }else{
                        if(key.charAt(key.length - 1) === '/'){
                            taskControlAction.downloadFile(bucket,key,filePath1,0)
                        }else{
                            taskControlAction.downloadFile(bucket,key,filePath1,size)
                        }
                    }
                }, function () {
                    if (call) {
                        call();
                    }
                });
            };
            function cancleCheckbox() {
                $("#allObject").get(0).checked = false;
                $("#objLists tbody").find(".objectCheckbox").each(function () {
                    $(this).get(0).checked = false;
                    $(this).removeClass('ObjectChecked');
                })
            }
            $scope.okButton = {
                click: function () {
                    if (!$scope.validateResult || !$scope.validateExpiresResult) {
                        return false;
                    }
                    var path = $("#recoverAndDowloadPath").val();
                    path = path.replace(/\\/g, "/");
                    if(path.length <1){
                        $('.mui-model').showMessage({
                            type:'warning',
                            message: languageJson.obs_browser_downloadPath_hint,
                            ok: function () {
                                return false;
                            },
                            title: languageJson.warning
                        });
                        return false;
                    }
                    taskManager.setAbortAll(false);
                    var days = $scope.numberOptions.value;
                    var tier = $scope.recoverAndDowload.selected.value;
                    var bucket = $('#curBucketName').html();
                    var parentPath = getCurrPath();
                    if($("#recoverAndDowload").is(":checked")){
                        handleMuilFloder(days, tier,path);
                    }else{
                        cancleCheckbox();
                        taskControlAction.pathCheck(path, function (exist) {
                            if (exist) {
                                //被选中的列表
                                var lis = $("#objLists tr.selected-tr-active>td:last-child");
                                $("#objLists tr.selected-tr-active>td:nth-child(2)").find('span').removeClass('show-span-active');
                                $("#downloadbtn,#btnDeleteObjects,#recoverBtn").addClass('mui-disabled');
                                $("#downloadbtn").attr('data-title',languageJson.selectFileOrFolder);
                                if (global.UCDVersion === "HEC" || global.UCDVersion === "HK") {
                                    $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyArchive_tip);
                                }else {
                                    $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
                                }
                                $("#objLists tr.selected-tr-active").removeClass('selected-tr-active');
                                if (bucket && lis && path) {
                                    isShowDownErrMsg = true;
                                    if(taskManager){
                                        taskManager.setPauseAll(false);
                                        taskManager.abortAll=false;
                                    }

                                    /**
                                     * 与forEach相似，但不是并行执行。而是一个个按顺序执行。
                                     */
                                        //控制错误信息只弹出一次
                                    var showMsgTemp = true;
                                    //控制任务加载动画只执行一次
                                    var showCreateTasks = true;
                                    async.forEachSeries(lis, function(li,callback) {
                                        var obj=JSON.parse($(li).text());
                                        var name = obj.name;
                                        if(showCreateTasks){
                                            showCreateTasksAnimation();//加载新增任务动画效果
                                            $("#downloadbtn,#btnDeleteObjects,#recoverBtn,#PolicyBtn,#movebtn,#copybtn,#ObjectMorebtn").addClass('mui-disabled');
                                            showCreateTasks = false;
                                        }
                                        taskControlAction.downloadPath(bucket,parentPath,name,'',path,0, function (err) {
                                            if(err){
                                                //下载失败，则创建一个失败的下载任务
                                                if(err&&showMsgTemp) {
                                                    showMsgTemp = false;
                                                    //超时信息错误码特殊处理
                                                    var errCode = err.code === 'NetworkingError' ? "someObjectDownErr" : err.code;
                                                    //为了避免加载任务动画效果和错误信息同时出现，错误信息延迟2秒显示
                                                    setTimeout(function () {
                                                        $('.mui-model').showErrorMessage({
                                                            message: languageJson[errCode],
                                                            obsError: obsError(errCode,err.message)
                                                        });
                                                    },2000)

                                                }
                                            }
                                        });
                                        callback();
                                    }, function(err) {
                                        if(err){
                                            logger.error('err: ' + err);
                                        }
                                    });
                                } else {
                                    $('.mui-model').showMessage({
                                        type: "warning",
                                        message: languageJson.selectObjcet,
                                        ok: function () {
                                            return false;
                                        },
                                        title: languageJson.warning
                                    });
                                }
                            } else {
                                $('.mui-model').showMessage({
                                    type: "info",
                                    message: languageJson.pathNotExist,
                                    ok: function () {
                                        return false;
                                    },
                                    title: languageJson.hint
                                });
                            }
                        });
                        taskControlAction.checkDBData();
                    }
                    showCreateTasksAnimation();
                    $scope.cancelButton.click();
                }
            };

            $scope.cancelButton = {
                click: function () {
                    $scope.validateResult = true;
                    $scope.validateExpiresResult = true;
                    $("#recoverAndDowloadPath").val("");
                    $("#downloadFloder").val("");
                    $("#recoverFloderPage").removeClass('shown');
                    $scope.numberOptions.value = 30;
                    $scope.recoverAndDowload.selected = {
                        value: $scope.recoverAndDowload.recoverSpeedList[1].key,
                    };
                    $scope.recoverAndDowload.description = $scope.recoverAndDowload.recoverSpeedList[1].desc;
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                }
            };
            $scope.validateResult = true;
            $scope.validateExpiresResult = true;
            $scope.recoverObject = {
                daysValidate: {
                    "validator": [{
                        rule: function (value) {
                            if (value > 0 && value < 31) {
                                $scope.validateResult = true;
                                return true;
                            } else {
                                $scope.validateResult = false;
                                return false;
                            }
                        },
                        errorMsg: global.langData.obs_task_restoreDaysBeyond_tip
                    }, {
                        rule: function (value) {
                            var oldExpires = $("#recoverObjectExpires").text();
                            if (commonUtils.compareExpiresDays(value, oldExpires)) {
                                $scope.validateExpiresResult = true;
                                return true;
                            } else {
                                $scope.validateExpiresResult = false;
                                return false;
                            }
                        },
                        errorMsg: global.langData.obs_task_restoreValidityPeriodFault_info
                    }]
                },
                cleanInvalidate: function () {
                    tiValid.clearInValid($("#recoverFloderDays"));
                },
            };

        }]);

        angular.bootstrap($('#recoverFloderPage'), ['recoverFloderModule']);
    });
}
//单个恢复
function handleSingleObject(key, bucket, days, tier, call) {
    bucketAndObjectAction.restoreObject(bucket, key, days, tier, function (err, data) {
        if (err) {
            if (call) {
                call(err);
            }
        } else {
            if (call) {
                call();
            }
        }
    });
}

/**
 * 重试单个恢复任务
 * @param id
 * @param callback
 */
function restoreSingleTask(id, callback) {
    mongodb.get({"id": id}, function (err, data) {
        if (data) {
            data.stat = 'RESTORING';
            refrchStat(data);//刷新界面状态
            setTimeout(function () {
                handleSingleObject(data.key, data.bucket, data.days, data.tier, function (err) {
                    if (err) {
                        data.errMessage = err.code;
                        data.stat = 'FAILED';
                        data.endTime = new Date();
                        refrchStat(data);//刷新界面状态
                    } else {
                        data.stat = 'RESTORING';
                    }
                    mongodb.updateStat(data);
                    if (callback) {
                        callback();
                    }
                });
            }, 1000);
        } else {
            if (callback) {
                callback();
            }
        }
    });
}

/**
 * 重试所有恢复任务
 * @param id
 * @param callback
 */
function restoreAllFailedTask(callback) {
    var queryString = {type: 'recover', stat: 'FAILED'};
    taskManager.listAndGetResult(queryString, {"id": 1}, function (err, data) {
        if (err) {
            global.logger.error('restoreAllFailedTask failed:', err);
            if (callback) {
                callback();
            }
        } else {
            setTimeout(function () {
                async.eachLimit(data, 20, function (item, call) {
                    restoreSingleTask(item.id, call);
                }, function () {
                    if (callback) {
                        callback();
                    }
                });
            }, 1500)
        }
    });
}

/**
 * 更新对象界面恢复状态
 * @param key 对象名称
 * @param stat 目标状态
 */
function updateRestoreStatCache(key, stat) {
    var objId = AWS.util.crypto.sha256(key, 'hex');
    var loopDataKey = objId + Const("RESTORE_STATUS_SUFFIX");
    if ($("#" + loopDataKey).text()) {
        $("#" + loopDataKey).text(stat);
        // 任务列表恢复状态同步刷新
        $('#recover-refresh-div').click();
        global.restoreCache.data[loopDataKey] = stat;
    }
}